# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class AmazonLexRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        AmazonLexRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'request_attributes': 'dict(str, str)',
            'session_attributes': 'dict(str, str)'
        }

        self.attribute_map = {
            'request_attributes': 'requestAttributes',
            'session_attributes': 'sessionAttributes'
        }

        self._request_attributes = None
        self._session_attributes = None

    @property
    def request_attributes(self) -> Dict[str, str]:
        """
        Gets the request_attributes of this AmazonLexRequest.
        AttributeName/AttributeValue pairs of User Defined Request Attributes to be sent to the amazon bot See - https://docs.aws.amazon.com/lex/latest/dg/context-mgmt.html#context-mgmt-request-attribs

        :return: The request_attributes of this AmazonLexRequest.
        :rtype: dict(str, str)
        """
        return self._request_attributes

    @request_attributes.setter
    def request_attributes(self, request_attributes: Dict[str, str]) -> None:
        """
        Sets the request_attributes of this AmazonLexRequest.
        AttributeName/AttributeValue pairs of User Defined Request Attributes to be sent to the amazon bot See - https://docs.aws.amazon.com/lex/latest/dg/context-mgmt.html#context-mgmt-request-attribs

        :param request_attributes: The request_attributes of this AmazonLexRequest.
        :type: dict(str, str)
        """
        

        self._request_attributes = request_attributes

    @property
    def session_attributes(self) -> Dict[str, str]:
        """
        Gets the session_attributes of this AmazonLexRequest.
        AttributeName/AttributeValue pairs of Session Attributes to be sent to the amazon bot. See - https://docs.aws.amazon.com/lex/latest/dg/context-mgmt.html#context-mgmt-session-attribs

        :return: The session_attributes of this AmazonLexRequest.
        :rtype: dict(str, str)
        """
        return self._session_attributes

    @session_attributes.setter
    def session_attributes(self, session_attributes: Dict[str, str]) -> None:
        """
        Sets the session_attributes of this AmazonLexRequest.
        AttributeName/AttributeValue pairs of Session Attributes to be sent to the amazon bot. See - https://docs.aws.amazon.com/lex/latest/dg/context-mgmt.html#context-mgmt-session-attribs

        :param session_attributes: The session_attributes of this AmazonLexRequest.
        :type: dict(str, str)
        """
        

        self._session_attributes = session_attributes

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

