# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import ArchitectDependencyTrackingBuildNotificationClient
    from . import ArchitectDependencyTrackingBuildNotificationUser

class ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'status': 'str',
            'user': 'ArchitectDependencyTrackingBuildNotificationUser',
            'client': 'ArchitectDependencyTrackingBuildNotificationClient',
            'start_time': 'datetime'
        }

        self.attribute_map = {
            'status': 'status',
            'user': 'user',
            'client': 'client',
            'start_time': 'startTime'
        }

        self._status = None
        self._user = None
        self._client = None
        self._start_time = None

    @property
    def status(self) -> str:
        """
        Gets the status of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        The organization's new dependency tracking build status

        :return: The status of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str) -> None:
        """
        Sets the status of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        The organization's new dependency tracking build status

        :param status: The status of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        :type: str
        """
        

        self._status = status

    @property
    def user(self) -> 'ArchitectDependencyTrackingBuildNotificationUser':
        """
        Gets the user of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.


        :return: The user of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        :rtype: ArchitectDependencyTrackingBuildNotificationUser
        """
        return self._user

    @user.setter
    def user(self, user: 'ArchitectDependencyTrackingBuildNotificationUser') -> None:
        """
        Sets the user of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.


        :param user: The user of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        :type: ArchitectDependencyTrackingBuildNotificationUser
        """
        

        self._user = user

    @property
    def client(self) -> 'ArchitectDependencyTrackingBuildNotificationClient':
        """
        Gets the client of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.


        :return: The client of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        :rtype: ArchitectDependencyTrackingBuildNotificationClient
        """
        return self._client

    @client.setter
    def client(self, client: 'ArchitectDependencyTrackingBuildNotificationClient') -> None:
        """
        Sets the client of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.


        :param client: The client of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        :type: ArchitectDependencyTrackingBuildNotificationClient
        """
        

        self._client = client

    @property
    def start_time(self) -> datetime:
        """
        Gets the start_time of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        The time the last build started, in ISO 8601 format

        :return: The start_time of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time: datetime) -> None:
        """
        Sets the start_time of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        The time the last build started, in ISO 8601 format

        :param start_time: The start_time of this ArchitectDependencyTrackingBuildNotificationDependencyTrackingBuildNotification.
        :type: datetime
        """
        

        self._start_time = start_time

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

