# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import WorkitemStatusReference

class AutoStatusTransitionDetail(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        AutoStatusTransitionDetail - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'next_status': 'WorkitemStatusReference',
            'date_of_transition': 'datetime'
        }

        self.attribute_map = {
            'next_status': 'nextStatus',
            'date_of_transition': 'dateOfTransition'
        }

        self._next_status = None
        self._date_of_transition = None

    @property
    def next_status(self) -> 'WorkitemStatusReference':
        """
        Gets the next_status of this AutoStatusTransitionDetail.
        Next status of auto status transition.

        :return: The next_status of this AutoStatusTransitionDetail.
        :rtype: WorkitemStatusReference
        """
        return self._next_status

    @next_status.setter
    def next_status(self, next_status: 'WorkitemStatusReference') -> None:
        """
        Sets the next_status of this AutoStatusTransitionDetail.
        Next status of auto status transition.

        :param next_status: The next_status of this AutoStatusTransitionDetail.
        :type: WorkitemStatusReference
        """
        

        self._next_status = next_status

    @property
    def date_of_transition(self) -> datetime:
        """
        Gets the date_of_transition of this AutoStatusTransitionDetail.
        Date at which auto status transition occurs. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :return: The date_of_transition of this AutoStatusTransitionDetail.
        :rtype: datetime
        """
        return self._date_of_transition

    @date_of_transition.setter
    def date_of_transition(self, date_of_transition: datetime) -> None:
        """
        Sets the date_of_transition of this AutoStatusTransitionDetail.
        Date at which auto status transition occurs. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :param date_of_transition: The date_of_transition of this AutoStatusTransitionDetail.
        :type: datetime
        """
        

        self._date_of_transition = date_of_transition

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

