# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import ManagementUnitReference
    from . import MuRescheduleResultWrapper

class BuRescheduleAgentScheduleResult(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        BuRescheduleAgentScheduleResult - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'management_unit': 'ManagementUnitReference',
            'download_result': 'MuRescheduleResultWrapper',
            'download_url': 'str'
        }

        self.attribute_map = {
            'management_unit': 'managementUnit',
            'download_result': 'downloadResult',
            'download_url': 'downloadUrl'
        }

        self._management_unit = None
        self._download_result = None
        self._download_url = None

    @property
    def management_unit(self) -> 'ManagementUnitReference':
        """
        Gets the management_unit of this BuRescheduleAgentScheduleResult.
        The management unit to which this part of the result applies

        :return: The management_unit of this BuRescheduleAgentScheduleResult.
        :rtype: ManagementUnitReference
        """
        return self._management_unit

    @management_unit.setter
    def management_unit(self, management_unit: 'ManagementUnitReference') -> None:
        """
        Sets the management_unit of this BuRescheduleAgentScheduleResult.
        The management unit to which this part of the result applies

        :param management_unit: The management_unit of this BuRescheduleAgentScheduleResult.
        :type: ManagementUnitReference
        """
        

        self._management_unit = management_unit

    @property
    def download_result(self) -> 'MuRescheduleResultWrapper':
        """
        Gets the download_result of this BuRescheduleAgentScheduleResult.
        The agent schedules.  Result will always come via the downloadUrl; however the schema is included for documentation

        :return: The download_result of this BuRescheduleAgentScheduleResult.
        :rtype: MuRescheduleResultWrapper
        """
        return self._download_result

    @download_result.setter
    def download_result(self, download_result: 'MuRescheduleResultWrapper') -> None:
        """
        Sets the download_result of this BuRescheduleAgentScheduleResult.
        The agent schedules.  Result will always come via the downloadUrl; however the schema is included for documentation

        :param download_result: The download_result of this BuRescheduleAgentScheduleResult.
        :type: MuRescheduleResultWrapper
        """
        

        self._download_result = download_result

    @property
    def download_url(self) -> str:
        """
        Gets the download_url of this BuRescheduleAgentScheduleResult.
        The download URL from which to fetch the result

        :return: The download_url of this BuRescheduleAgentScheduleResult.
        :rtype: str
        """
        return self._download_url

    @download_url.setter
    def download_url(self, download_url: str) -> None:
        """
        Sets the download_url of this BuRescheduleAgentScheduleResult.
        The download URL from which to fetch the result

        :param download_url: The download_url of this BuRescheduleAgentScheduleResult.
        :type: str
        """
        

        self._download_url = download_url

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

