# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import MuteSnoozeFields
    from . import UnreadFields

class CommonAlertBulkUpdateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        CommonAlertBulkUpdateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',
            'alert_ids': 'list[str]',
            'mute_snooze': 'MuteSnoozeFields',
            'unread': 'UnreadFields'
        }

        self.attribute_map = {
            'type': 'type',
            'alert_ids': 'alertIds',
            'mute_snooze': 'muteSnooze',
            'unread': 'unread'
        }

        self._type = None
        self._alert_ids = None
        self._mute_snooze = None
        self._unread = None

    @property
    def type(self) -> str:
        """
        Gets the type of this CommonAlertBulkUpdateRequest.
        The action to take

        :return: The type of this CommonAlertBulkUpdateRequest.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str) -> None:
        """
        Sets the type of this CommonAlertBulkUpdateRequest.
        The action to take

        :param type: The type of this CommonAlertBulkUpdateRequest.
        :type: str
        """
        if isinstance(type, int):
            type = str(type)
        allowed_values = ["Mute", "Snooze", "Unread"]
        if type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for type -> " + type)
            self._type = "outdated_sdk_version"
        else:
            self._type = type

    @property
    def alert_ids(self) -> List[str]:
        """
        Gets the alert_ids of this CommonAlertBulkUpdateRequest.
        The user supplied alert ids to be muted

        :return: The alert_ids of this CommonAlertBulkUpdateRequest.
        :rtype: list[str]
        """
        return self._alert_ids

    @alert_ids.setter
    def alert_ids(self, alert_ids: List[str]) -> None:
        """
        Sets the alert_ids of this CommonAlertBulkUpdateRequest.
        The user supplied alert ids to be muted

        :param alert_ids: The alert_ids of this CommonAlertBulkUpdateRequest.
        :type: list[str]
        """
        

        self._alert_ids = alert_ids

    @property
    def mute_snooze(self) -> 'MuteSnoozeFields':
        """
        Gets the mute_snooze of this CommonAlertBulkUpdateRequest.
        The fields need for a mute or snooze requests

        :return: The mute_snooze of this CommonAlertBulkUpdateRequest.
        :rtype: MuteSnoozeFields
        """
        return self._mute_snooze

    @mute_snooze.setter
    def mute_snooze(self, mute_snooze: 'MuteSnoozeFields') -> None:
        """
        Sets the mute_snooze of this CommonAlertBulkUpdateRequest.
        The fields need for a mute or snooze requests

        :param mute_snooze: The mute_snooze of this CommonAlertBulkUpdateRequest.
        :type: MuteSnoozeFields
        """
        

        self._mute_snooze = mute_snooze

    @property
    def unread(self) -> 'UnreadFields':
        """
        Gets the unread of this CommonAlertBulkUpdateRequest.
        The fields need for an unread update requests

        :return: The unread of this CommonAlertBulkUpdateRequest.
        :rtype: UnreadFields
        """
        return self._unread

    @unread.setter
    def unread(self, unread: 'UnreadFields') -> None:
        """
        Sets the unread of this CommonAlertBulkUpdateRequest.
        The fields need for an unread update requests

        :param unread: The unread of this CommonAlertBulkUpdateRequest.
        :type: UnreadFields
        """
        

        self._unread = unread

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

