# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import KpiResult

class ComparisonPeriod(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        ComparisonPeriod - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'kpi': 'str',
            'date_started': 'datetime',
            'date_ended': 'datetime',
            'percentage_benefit': 'float',
            'kpi_results': 'list[KpiResult]',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'kpi': 'kpi',
            'date_started': 'dateStarted',
            'date_ended': 'dateEnded',
            'percentage_benefit': 'percentageBenefit',
            'kpi_results': 'kpiResults',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._kpi = None
        self._date_started = None
        self._date_ended = None
        self._percentage_benefit = None
        self._kpi_results = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this ComparisonPeriod.
        The globally unique identifier for the object.

        :return: The id of this ComparisonPeriod.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this ComparisonPeriod.
        The globally unique identifier for the object.

        :param id: The id of this ComparisonPeriod.
        :type: str
        """
        

        self._id = id

    @property
    def kpi(self) -> str:
        """
        Gets the kpi of this ComparisonPeriod.
        Key Performance Indicator optimised during the comparison period.

        :return: The kpi of this ComparisonPeriod.
        :rtype: str
        """
        return self._kpi

    @kpi.setter
    def kpi(self, kpi: str) -> None:
        """
        Sets the kpi of this ComparisonPeriod.
        Key Performance Indicator optimised during the comparison period.

        :param kpi: The kpi of this ComparisonPeriod.
        :type: str
        """
        

        self._kpi = kpi

    @property
    def date_started(self) -> datetime:
        """
        Gets the date_started of this ComparisonPeriod.
        Start date of the comparison period. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :return: The date_started of this ComparisonPeriod.
        :rtype: datetime
        """
        return self._date_started

    @date_started.setter
    def date_started(self, date_started: datetime) -> None:
        """
        Sets the date_started of this ComparisonPeriod.
        Start date of the comparison period. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :param date_started: The date_started of this ComparisonPeriod.
        :type: datetime
        """
        

        self._date_started = date_started

    @property
    def date_ended(self) -> datetime:
        """
        Gets the date_ended of this ComparisonPeriod.
        End date of the comparison period. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :return: The date_ended of this ComparisonPeriod.
        :rtype: datetime
        """
        return self._date_ended

    @date_ended.setter
    def date_ended(self, date_ended: datetime) -> None:
        """
        Sets the date_ended of this ComparisonPeriod.
        End date of the comparison period. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :param date_ended: The date_ended of this ComparisonPeriod.
        :type: datetime
        """
        

        self._date_ended = date_ended

    @property
    def percentage_benefit(self) -> float:
        """
        Gets the percentage_benefit of this ComparisonPeriod.
        The percentage benefit on this queue for the duration of the comparison period

        :return: The percentage_benefit of this ComparisonPeriod.
        :rtype: float
        """
        return self._percentage_benefit

    @percentage_benefit.setter
    def percentage_benefit(self, percentage_benefit: float) -> None:
        """
        Sets the percentage_benefit of this ComparisonPeriod.
        The percentage benefit on this queue for the duration of the comparison period

        :param percentage_benefit: The percentage_benefit of this ComparisonPeriod.
        :type: float
        """
        

        self._percentage_benefit = percentage_benefit

    @property
    def kpi_results(self) -> List['KpiResult']:
        """
        Gets the kpi_results of this ComparisonPeriod.
        KPI results for each metric

        :return: The kpi_results of this ComparisonPeriod.
        :rtype: list[KpiResult]
        """
        return self._kpi_results

    @kpi_results.setter
    def kpi_results(self, kpi_results: List['KpiResult']) -> None:
        """
        Sets the kpi_results of this ComparisonPeriod.
        KPI results for each metric

        :param kpi_results: The kpi_results of this ComparisonPeriod.
        :type: list[KpiResult]
        """
        

        self._kpi_results = kpi_results

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this ComparisonPeriod.
        The URI for this object

        :return: The self_uri of this ComparisonPeriod.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this ComparisonPeriod.
        The URI for this object

        :param self_uri: The self_uri of this ComparisonPeriod.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

