# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class ConversationChannel(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        ConversationChannel - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',
            'message_type': 'str',
            'platform': 'str'
        }

        self.attribute_map = {
            'type': 'type',
            'message_type': 'messageType',
            'platform': 'platform'
        }

        self._type = None
        self._message_type = None
        self._platform = None

    @property
    def type(self) -> str:
        """
        Gets the type of this ConversationChannel.
        The type or category of this channel.

        :return: The type of this ConversationChannel.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str) -> None:
        """
        Sets the type of this ConversationChannel.
        The type or category of this channel.

        :param type: The type of this ConversationChannel.
        :type: str
        """
        if isinstance(type, int):
            type = str(type)
        allowed_values = ["Unknown", "Call", "Callback", "Email", "GenericObject", "Messaging", "Social", "Webchat", "Voice", "Chat", "Cobrowse", "Video", "Screenshare", "Message"]
        if type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for type -> " + type)
            self._type = "outdated_sdk_version"
        else:
            self._type = type

    @property
    def message_type(self) -> str:
        """
        Gets the message_type of this ConversationChannel.
        Message type for messaging conversations.

        :return: The message_type of this ConversationChannel.
        :rtype: str
        """
        return self._message_type

    @message_type.setter
    def message_type(self, message_type: str) -> None:
        """
        Sets the message_type of this ConversationChannel.
        Message type for messaging conversations.

        :param message_type: The message_type of this ConversationChannel.
        :type: str
        """
        if isinstance(message_type, int):
            message_type = str(message_type)
        allowed_values = ["Unknown", "Sms", "Twitter", "Facebook", "Line", "WhatsApp", "WebMessaging", "Open", "Instagram"]
        if message_type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for message_type -> " + message_type)
            self._message_type = "outdated_sdk_version"
        else:
            self._message_type = message_type

    @property
    def platform(self) -> str:
        """
        Gets the platform of this ConversationChannel.
        The source provider for the conversation (e.g. Edge, PureCloud Messaging, PureCloud Email).

        :return: The platform of this ConversationChannel.
        :rtype: str
        """
        return self._platform

    @platform.setter
    def platform(self, platform: str) -> None:
        """
        Sets the platform of this ConversationChannel.
        The source provider for the conversation (e.g. Edge, PureCloud Messaging, PureCloud Email).

        :param platform: The platform of this ConversationChannel.
        :type: str
        """
        

        self._platform = platform

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

