# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class CredentialSpecification(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        CredentialSpecification - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'required': 'bool',
            'title': 'str',
            'credential_types': 'list[str]'
        }

        self.attribute_map = {
            'required': 'required',
            'title': 'title',
            'credential_types': 'credentialTypes'
        }

        self._required = None
        self._title = None
        self._credential_types = None

    @property
    def required(self) -> bool:
        """
        Gets the required of this CredentialSpecification.
        Indicates if the credential must be provided in order for the integration configuration to be valid.

        :return: The required of this CredentialSpecification.
        :rtype: bool
        """
        return self._required

    @required.setter
    def required(self, required: bool) -> None:
        """
        Sets the required of this CredentialSpecification.
        Indicates if the credential must be provided in order for the integration configuration to be valid.

        :param required: The required of this CredentialSpecification.
        :type: bool
        """
        

        self._required = required

    @property
    def title(self) -> str:
        """
        Gets the title of this CredentialSpecification.
        Title describing the usage for this credential.

        :return: The title of this CredentialSpecification.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str) -> None:
        """
        Sets the title of this CredentialSpecification.
        Title describing the usage for this credential.

        :param title: The title of this CredentialSpecification.
        :type: str
        """
        

        self._title = title

    @property
    def credential_types(self) -> List[str]:
        """
        Gets the credential_types of this CredentialSpecification.
        List of acceptable credential types that can be provided for this credential.

        :return: The credential_types of this CredentialSpecification.
        :rtype: list[str]
        """
        return self._credential_types

    @credential_types.setter
    def credential_types(self, credential_types: List[str]) -> None:
        """
        Sets the credential_types of this CredentialSpecification.
        List of acceptable credential types that can be provided for this credential.

        :param credential_types: The credential_types of this CredentialSpecification.
        :type: list[str]
        """
        

        self._credential_types = credential_types

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

