# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class CustomerStartDetailEventTopicJourneyContext(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        CustomerStartDetailEventTopicJourneyContext - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'session_id': 'str',
            'session_id_type': 'str',
            'action_id': 'str',
            'action_map_id': 'str'
        }

        self.attribute_map = {
            'session_id': 'sessionId',
            'session_id_type': 'sessionIdType',
            'action_id': 'actionId',
            'action_map_id': 'actionMapId'
        }

        self._session_id = None
        self._session_id_type = None
        self._action_id = None
        self._action_map_id = None

    @property
    def session_id(self) -> str:
        """
        Gets the session_id of this CustomerStartDetailEventTopicJourneyContext.


        :return: The session_id of this CustomerStartDetailEventTopicJourneyContext.
        :rtype: str
        """
        return self._session_id

    @session_id.setter
    def session_id(self, session_id: str) -> None:
        """
        Sets the session_id of this CustomerStartDetailEventTopicJourneyContext.


        :param session_id: The session_id of this CustomerStartDetailEventTopicJourneyContext.
        :type: str
        """
        

        self._session_id = session_id

    @property
    def session_id_type(self) -> str:
        """
        Gets the session_id_type of this CustomerStartDetailEventTopicJourneyContext.


        :return: The session_id_type of this CustomerStartDetailEventTopicJourneyContext.
        :rtype: str
        """
        return self._session_id_type

    @session_id_type.setter
    def session_id_type(self, session_id_type: str) -> None:
        """
        Sets the session_id_type of this CustomerStartDetailEventTopicJourneyContext.


        :param session_id_type: The session_id_type of this CustomerStartDetailEventTopicJourneyContext.
        :type: str
        """
        

        self._session_id_type = session_id_type

    @property
    def action_id(self) -> str:
        """
        Gets the action_id of this CustomerStartDetailEventTopicJourneyContext.


        :return: The action_id of this CustomerStartDetailEventTopicJourneyContext.
        :rtype: str
        """
        return self._action_id

    @action_id.setter
    def action_id(self, action_id: str) -> None:
        """
        Sets the action_id of this CustomerStartDetailEventTopicJourneyContext.


        :param action_id: The action_id of this CustomerStartDetailEventTopicJourneyContext.
        :type: str
        """
        

        self._action_id = action_id

    @property
    def action_map_id(self) -> str:
        """
        Gets the action_map_id of this CustomerStartDetailEventTopicJourneyContext.


        :return: The action_map_id of this CustomerStartDetailEventTopicJourneyContext.
        :rtype: str
        """
        return self._action_map_id

    @action_map_id.setter
    def action_map_id(self, action_map_id: str) -> None:
        """
        Sets the action_map_id of this CustomerStartDetailEventTopicJourneyContext.


        :param action_map_id: The action_map_id of this CustomerStartDetailEventTopicJourneyContext.
        :type: str
        """
        

        self._action_map_id = action_map_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

