# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import DialerAttemptLimitsConfigChangeRecallEntry

class DialerAttemptLimitsConfigChangeAttemptLimits(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        DialerAttemptLimitsConfigChangeAttemptLimits - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'max_attempts_per_contact': 'int',
            'max_attempts_per_number': 'int',
            'time_zone_id': 'str',
            'reset_period': 'str',
            'recall_entries': 'dict(str, DialerAttemptLimitsConfigChangeRecallEntry)',
            'breadth_first_recalls': 'bool',
            'additional_properties': 'dict(str, object)',
            'id': 'str',
            'name': 'str',
            'date_created': 'datetime',
            'date_modified': 'datetime',
            'version': 'int'
        }

        self.attribute_map = {
            'max_attempts_per_contact': 'maxAttemptsPerContact',
            'max_attempts_per_number': 'maxAttemptsPerNumber',
            'time_zone_id': 'timeZoneId',
            'reset_period': 'resetPeriod',
            'recall_entries': 'recallEntries',
            'breadth_first_recalls': 'breadthFirstRecalls',
            'additional_properties': 'additionalProperties',
            'id': 'id',
            'name': 'name',
            'date_created': 'dateCreated',
            'date_modified': 'dateModified',
            'version': 'version'
        }

        self._max_attempts_per_contact = None
        self._max_attempts_per_number = None
        self._time_zone_id = None
        self._reset_period = None
        self._recall_entries = None
        self._breadth_first_recalls = None
        self._additional_properties = None
        self._id = None
        self._name = None
        self._date_created = None
        self._date_modified = None
        self._version = None

    @property
    def max_attempts_per_contact(self) -> int:
        """
        Gets the max_attempts_per_contact of this DialerAttemptLimitsConfigChangeAttemptLimits.


        :return: The max_attempts_per_contact of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: int
        """
        return self._max_attempts_per_contact

    @max_attempts_per_contact.setter
    def max_attempts_per_contact(self, max_attempts_per_contact: int) -> None:
        """
        Sets the max_attempts_per_contact of this DialerAttemptLimitsConfigChangeAttemptLimits.


        :param max_attempts_per_contact: The max_attempts_per_contact of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: int
        """
        

        self._max_attempts_per_contact = max_attempts_per_contact

    @property
    def max_attempts_per_number(self) -> int:
        """
        Gets the max_attempts_per_number of this DialerAttemptLimitsConfigChangeAttemptLimits.


        :return: The max_attempts_per_number of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: int
        """
        return self._max_attempts_per_number

    @max_attempts_per_number.setter
    def max_attempts_per_number(self, max_attempts_per_number: int) -> None:
        """
        Sets the max_attempts_per_number of this DialerAttemptLimitsConfigChangeAttemptLimits.


        :param max_attempts_per_number: The max_attempts_per_number of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: int
        """
        

        self._max_attempts_per_number = max_attempts_per_number

    @property
    def time_zone_id(self) -> str:
        """
        Gets the time_zone_id of this DialerAttemptLimitsConfigChangeAttemptLimits.
        The timezone is necessary to define when \"today\" starts and ends

        :return: The time_zone_id of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: str
        """
        return self._time_zone_id

    @time_zone_id.setter
    def time_zone_id(self, time_zone_id: str) -> None:
        """
        Sets the time_zone_id of this DialerAttemptLimitsConfigChangeAttemptLimits.
        The timezone is necessary to define when \"today\" starts and ends

        :param time_zone_id: The time_zone_id of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: str
        """
        

        self._time_zone_id = time_zone_id

    @property
    def reset_period(self) -> str:
        """
        Gets the reset_period of this DialerAttemptLimitsConfigChangeAttemptLimits.
        After how long the number of attempts will be set back to 0

        :return: The reset_period of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: str
        """
        return self._reset_period

    @reset_period.setter
    def reset_period(self, reset_period: str) -> None:
        """
        Sets the reset_period of this DialerAttemptLimitsConfigChangeAttemptLimits.
        After how long the number of attempts will be set back to 0

        :param reset_period: The reset_period of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: str
        """
        if isinstance(reset_period, int):
            reset_period = str(reset_period)
        allowed_values = ["NEVER", "TODAY"]
        if reset_period.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for reset_period -> " + reset_period)
            self._reset_period = "outdated_sdk_version"
        else:
            self._reset_period = reset_period

    @property
    def recall_entries(self) -> Dict[str, 'DialerAttemptLimitsConfigChangeRecallEntry']:
        """
        Gets the recall_entries of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Configuration for recall attempts

        :return: The recall_entries of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: dict(str, DialerAttemptLimitsConfigChangeRecallEntry)
        """
        return self._recall_entries

    @recall_entries.setter
    def recall_entries(self, recall_entries: Dict[str, 'DialerAttemptLimitsConfigChangeRecallEntry']) -> None:
        """
        Sets the recall_entries of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Configuration for recall attempts

        :param recall_entries: The recall_entries of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: dict(str, DialerAttemptLimitsConfigChangeRecallEntry)
        """
        

        self._recall_entries = recall_entries

    @property
    def breadth_first_recalls(self) -> bool:
        """
        Gets the breadth_first_recalls of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Whether recalls are performed before considering other numbers (true) or after (false)

        :return: The breadth_first_recalls of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: bool
        """
        return self._breadth_first_recalls

    @breadth_first_recalls.setter
    def breadth_first_recalls(self, breadth_first_recalls: bool) -> None:
        """
        Sets the breadth_first_recalls of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Whether recalls are performed before considering other numbers (true) or after (false)

        :param breadth_first_recalls: The breadth_first_recalls of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: bool
        """
        

        self._breadth_first_recalls = breadth_first_recalls

    @property
    def additional_properties(self) -> Dict[str, object]:
        """
        Gets the additional_properties of this DialerAttemptLimitsConfigChangeAttemptLimits.


        :return: The additional_properties of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: dict(str, object)
        """
        return self._additional_properties

    @additional_properties.setter
    def additional_properties(self, additional_properties: Dict[str, object]) -> None:
        """
        Sets the additional_properties of this DialerAttemptLimitsConfigChangeAttemptLimits.


        :param additional_properties: The additional_properties of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: dict(str, object)
        """
        

        self._additional_properties = additional_properties

    @property
    def id(self) -> str:
        """
        Gets the id of this DialerAttemptLimitsConfigChangeAttemptLimits.
        The globally unique identifier for the object.

        :return: The id of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this DialerAttemptLimitsConfigChangeAttemptLimits.
        The globally unique identifier for the object.

        :param id: The id of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: str
        """
        

        self._id = id

    @property
    def name(self) -> str:
        """
        Gets the name of this DialerAttemptLimitsConfigChangeAttemptLimits.
        The UI-visible name of the object

        :return: The name of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str) -> None:
        """
        Sets the name of this DialerAttemptLimitsConfigChangeAttemptLimits.
        The UI-visible name of the object

        :param name: The name of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: str
        """
        

        self._name = name

    @property
    def date_created(self) -> datetime:
        """
        Gets the date_created of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Creation time of the entity

        :return: The date_created of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: datetime
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created: datetime) -> None:
        """
        Sets the date_created of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Creation time of the entity

        :param date_created: The date_created of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: datetime
        """
        

        self._date_created = date_created

    @property
    def date_modified(self) -> datetime:
        """
        Gets the date_modified of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Last modified time of the entity

        :return: The date_modified of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: datetime
        """
        return self._date_modified

    @date_modified.setter
    def date_modified(self, date_modified: datetime) -> None:
        """
        Sets the date_modified of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Last modified time of the entity

        :param date_modified: The date_modified of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: datetime
        """
        

        self._date_modified = date_modified

    @property
    def version(self) -> int:
        """
        Gets the version of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Required for updates, must match the version number of the most recent update

        :return: The version of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version: int) -> None:
        """
        Sets the version of this DialerAttemptLimitsConfigChangeAttemptLimits.
        Required for updates, must match the version number of the most recent update

        :param version: The version of this DialerAttemptLimitsConfigChangeAttemptLimits.
        :type: int
        """
        

        self._version = version

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

