# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import AddressableEntityRef

class DirectRoutingCallMediaSettings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        DirectRoutingCallMediaSettings - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'enabled': 'bool',
            'inbound_flow': 'AddressableEntityRef',
            'voicemail_flow': 'AddressableEntityRef'
        }

        self.attribute_map = {
            'enabled': 'enabled',
            'inbound_flow': 'inboundFlow',
            'voicemail_flow': 'voicemailFlow'
        }

        self._enabled = None
        self._inbound_flow = None
        self._voicemail_flow = None

    @property
    def enabled(self) -> bool:
        """
        Gets the enabled of this DirectRoutingCallMediaSettings.
        Toggle that enables Direct Routing for this media type.

        :return: The enabled of this DirectRoutingCallMediaSettings.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled: bool) -> None:
        """
        Sets the enabled of this DirectRoutingCallMediaSettings.
        Toggle that enables Direct Routing for this media type.

        :param enabled: The enabled of this DirectRoutingCallMediaSettings.
        :type: bool
        """
        

        self._enabled = enabled

    @property
    def inbound_flow(self) -> 'AddressableEntityRef':
        """
        Gets the inbound_flow of this DirectRoutingCallMediaSettings.
        The Direct Routing inbound flow id for this media type.

        :return: The inbound_flow of this DirectRoutingCallMediaSettings.
        :rtype: AddressableEntityRef
        """
        return self._inbound_flow

    @inbound_flow.setter
    def inbound_flow(self, inbound_flow: 'AddressableEntityRef') -> None:
        """
        Sets the inbound_flow of this DirectRoutingCallMediaSettings.
        The Direct Routing inbound flow id for this media type.

        :param inbound_flow: The inbound_flow of this DirectRoutingCallMediaSettings.
        :type: AddressableEntityRef
        """
        

        self._inbound_flow = inbound_flow

    @property
    def voicemail_flow(self) -> 'AddressableEntityRef':
        """
        Gets the voicemail_flow of this DirectRoutingCallMediaSettings.
        ID of the in-queue flow that handles voicemails for Direct Routing and to transfer calls to ACD voicemail.

        :return: The voicemail_flow of this DirectRoutingCallMediaSettings.
        :rtype: AddressableEntityRef
        """
        return self._voicemail_flow

    @voicemail_flow.setter
    def voicemail_flow(self, voicemail_flow: 'AddressableEntityRef') -> None:
        """
        Sets the voicemail_flow of this DirectRoutingCallMediaSettings.
        ID of the in-queue flow that handles voicemails for Direct Routing and to transfer calls to ACD voicemail.

        :param voicemail_flow: The voicemail_flow of this DirectRoutingCallMediaSettings.
        :type: AddressableEntityRef
        """
        

        self._voicemail_flow = voicemail_flow

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

