# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class EmployerInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        EmployerInfo - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'official_name': 'str',
            'employee_id': 'str',
            'employee_type': 'str',
            'date_hire': 'str'
        }

        self.attribute_map = {
            'official_name': 'officialName',
            'employee_id': 'employeeId',
            'employee_type': 'employeeType',
            'date_hire': 'dateHire'
        }

        self._official_name = None
        self._employee_id = None
        self._employee_type = None
        self._date_hire = None

    @property
    def official_name(self) -> str:
        """
        Gets the official_name of this EmployerInfo.


        :return: The official_name of this EmployerInfo.
        :rtype: str
        """
        return self._official_name

    @official_name.setter
    def official_name(self, official_name: str) -> None:
        """
        Sets the official_name of this EmployerInfo.


        :param official_name: The official_name of this EmployerInfo.
        :type: str
        """
        

        self._official_name = official_name

    @property
    def employee_id(self) -> str:
        """
        Gets the employee_id of this EmployerInfo.


        :return: The employee_id of this EmployerInfo.
        :rtype: str
        """
        return self._employee_id

    @employee_id.setter
    def employee_id(self, employee_id: str) -> None:
        """
        Sets the employee_id of this EmployerInfo.


        :param employee_id: The employee_id of this EmployerInfo.
        :type: str
        """
        

        self._employee_id = employee_id

    @property
    def employee_type(self) -> str:
        """
        Gets the employee_type of this EmployerInfo.


        :return: The employee_type of this EmployerInfo.
        :rtype: str
        """
        return self._employee_type

    @employee_type.setter
    def employee_type(self, employee_type: str) -> None:
        """
        Sets the employee_type of this EmployerInfo.


        :param employee_type: The employee_type of this EmployerInfo.
        :type: str
        """
        

        self._employee_type = employee_type

    @property
    def date_hire(self) -> str:
        """
        Gets the date_hire of this EmployerInfo.


        :return: The date_hire of this EmployerInfo.
        :rtype: str
        """
        return self._date_hire

    @date_hire.setter
    def date_hire(self, date_hire: str) -> None:
        """
        Sets the date_hire of this EmployerInfo.


        :param date_hire: The date_hire of this EmployerInfo.
        :type: str
        """
        

        self._date_hire = date_hire

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

