# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import ActionEventActionMap
    from . import GenericEventAction

class GenericActionEvent(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        GenericActionEvent - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'action': 'GenericEventAction',
            'action_map': 'ActionEventActionMap',
            'error_code': 'str',
            'error_message': 'str'
        }

        self.attribute_map = {
            'action': 'action',
            'action_map': 'actionMap',
            'error_code': 'errorCode',
            'error_message': 'errorMessage'
        }

        self._action = None
        self._action_map = None
        self._error_code = None
        self._error_message = None

    @property
    def action(self) -> 'GenericEventAction':
        """
        Gets the action of this GenericActionEvent.
        The action that triggered the event.

        :return: The action of this GenericActionEvent.
        :rtype: GenericEventAction
        """
        return self._action

    @action.setter
    def action(self, action: 'GenericEventAction') -> None:
        """
        Sets the action of this GenericActionEvent.
        The action that triggered the event.

        :param action: The action of this GenericActionEvent.
        :type: GenericEventAction
        """
        

        self._action = action

    @property
    def action_map(self) -> 'ActionEventActionMap':
        """
        Gets the action_map of this GenericActionEvent.
        The action map that triggered the action.

        :return: The action_map of this GenericActionEvent.
        :rtype: ActionEventActionMap
        """
        return self._action_map

    @action_map.setter
    def action_map(self, action_map: 'ActionEventActionMap') -> None:
        """
        Sets the action_map of this GenericActionEvent.
        The action map that triggered the action.

        :param action_map: The action_map of this GenericActionEvent.
        :type: ActionEventActionMap
        """
        

        self._action_map = action_map

    @property
    def error_code(self) -> str:
        """
        Gets the error_code of this GenericActionEvent.
        Code of the error returned when the action fails.

        :return: The error_code of this GenericActionEvent.
        :rtype: str
        """
        return self._error_code

    @error_code.setter
    def error_code(self, error_code: str) -> None:
        """
        Sets the error_code of this GenericActionEvent.
        Code of the error returned when the action fails.

        :param error_code: The error_code of this GenericActionEvent.
        :type: str
        """
        

        self._error_code = error_code

    @property
    def error_message(self) -> str:
        """
        Gets the error_message of this GenericActionEvent.
        Message of the error returned when the action fails.

        :return: The error_message of this GenericActionEvent.
        :rtype: str
        """
        return self._error_message

    @error_message.setter
    def error_message(self, error_message: str) -> None:
        """
        Sets the error_message of this GenericActionEvent.
        Message of the error returned when the action fails.

        :param error_message: The error_message of this GenericActionEvent.
        :type: str
        """
        

        self._error_message = error_message

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

