# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import InsightsSummaryMetricItem
    from . import InsightsSummaryOverallItem
    from . import UserReference

class InsightsSummaryUserItem(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        InsightsSummaryUserItem - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'user': 'UserReference',
            'metric_data': 'list[InsightsSummaryMetricItem]',
            'overall_data': 'InsightsSummaryOverallItem'
        }

        self.attribute_map = {
            'user': 'user',
            'metric_data': 'metricData',
            'overall_data': 'overallData'
        }

        self._user = None
        self._metric_data = None
        self._overall_data = None

    @property
    def user(self) -> 'UserReference':
        """
        Gets the user of this InsightsSummaryUserItem.
        Queried user

        :return: The user of this InsightsSummaryUserItem.
        :rtype: UserReference
        """
        return self._user

    @user.setter
    def user(self, user: 'UserReference') -> None:
        """
        Sets the user of this InsightsSummaryUserItem.
        Queried user

        :param user: The user of this InsightsSummaryUserItem.
        :type: UserReference
        """
        

        self._user = user

    @property
    def metric_data(self) -> List['InsightsSummaryMetricItem']:
        """
        Gets the metric_data of this InsightsSummaryUserItem.
        The list of insights data for each metric of the user

        :return: The metric_data of this InsightsSummaryUserItem.
        :rtype: list[InsightsSummaryMetricItem]
        """
        return self._metric_data

    @metric_data.setter
    def metric_data(self, metric_data: List['InsightsSummaryMetricItem']) -> None:
        """
        Sets the metric_data of this InsightsSummaryUserItem.
        The list of insights data for each metric of the user

        :param metric_data: The metric_data of this InsightsSummaryUserItem.
        :type: list[InsightsSummaryMetricItem]
        """
        

        self._metric_data = metric_data

    @property
    def overall_data(self) -> 'InsightsSummaryOverallItem':
        """
        Gets the overall_data of this InsightsSummaryUserItem.
        Overall insights data of the user

        :return: The overall_data of this InsightsSummaryUserItem.
        :rtype: InsightsSummaryOverallItem
        """
        return self._overall_data

    @overall_data.setter
    def overall_data(self, overall_data: 'InsightsSummaryOverallItem') -> None:
        """
        Sets the overall_data of this InsightsSummaryUserItem.
        Overall insights data of the user

        :param overall_data: The overall_data of this InsightsSummaryUserItem.
        :type: InsightsSummaryOverallItem
        """
        

        self._overall_data = overall_data

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

