# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class JsonCursorSearchResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        JsonCursorSearchResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'types': 'list[str]',
            'results': 'object',
            'aggregations': 'object',
            'cursor': 'str'
        }

        self.attribute_map = {
            'types': 'types',
            'results': 'results',
            'aggregations': 'aggregations',
            'cursor': 'cursor'
        }

        self._types = None
        self._results = None
        self._aggregations = None
        self._cursor = None

    @property
    def types(self) -> List[str]:
        """
        Gets the types of this JsonCursorSearchResponse.
        Resource types the search was performed against

        :return: The types of this JsonCursorSearchResponse.
        :rtype: list[str]
        """
        return self._types

    @types.setter
    def types(self, types: List[str]) -> None:
        """
        Sets the types of this JsonCursorSearchResponse.
        Resource types the search was performed against

        :param types: The types of this JsonCursorSearchResponse.
        :type: list[str]
        """
        

        self._types = types

    @property
    def results(self) -> 'object':
        """
        Gets the results of this JsonCursorSearchResponse.
        Search results

        :return: The results of this JsonCursorSearchResponse.
        :rtype: object
        """
        return self._results

    @results.setter
    def results(self, results: 'object') -> None:
        """
        Sets the results of this JsonCursorSearchResponse.
        Search results

        :param results: The results of this JsonCursorSearchResponse.
        :type: object
        """
        

        self._results = results

    @property
    def aggregations(self) -> object:
        """
        Gets the aggregations of this JsonCursorSearchResponse.


        :return: The aggregations of this JsonCursorSearchResponse.
        :rtype: object
        """
        return self._aggregations

    @aggregations.setter
    def aggregations(self, aggregations: object) -> None:
        """
        Sets the aggregations of this JsonCursorSearchResponse.


        :param aggregations: The aggregations of this JsonCursorSearchResponse.
        :type: object
        """
        

        self._aggregations = aggregations

    @property
    def cursor(self) -> str:
        """
        Gets the cursor of this JsonCursorSearchResponse.
        The page cursor

        :return: The cursor of this JsonCursorSearchResponse.
        :rtype: str
        """
        return self._cursor

    @cursor.setter
    def cursor(self, cursor: str) -> None:
        """
        Sets the cursor of this JsonCursorSearchResponse.
        The page cursor

        :param cursor: The cursor of this JsonCursorSearchResponse.
        :type: str
        """
        

        self._cursor = cursor

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

