# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class MetadataProperty(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        MetadataProperty - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',
            'description': 'str',
            'help': 'str',
            'default': 'str',
            'enum': 'list[str]'
        }

        self.attribute_map = {
            'type': 'type',
            'description': 'description',
            'help': 'help',
            'default': 'default',
            'enum': 'enum'
        }

        self._type = None
        self._description = None
        self._help = None
        self._default = None
        self._enum = None

    @property
    def type(self) -> str:
        """
        Gets the type of this MetadataProperty.
        the data type of the input property

        :return: The type of this MetadataProperty.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str) -> None:
        """
        Sets the type of this MetadataProperty.
        the data type of the input property

        :param type: The type of this MetadataProperty.
        :type: str
        """
        

        self._type = type

    @property
    def description(self) -> str:
        """
        Gets the description of this MetadataProperty.
        brief description of the input property

        :return: The description of this MetadataProperty.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str) -> None:
        """
        Sets the description of this MetadataProperty.
        brief description of the input property

        :param description: The description of this MetadataProperty.
        :type: str
        """
        

        self._description = description

    @property
    def help(self) -> str:
        """
        Gets the help of this MetadataProperty.
        optional URL with addition information about the input property

        :return: The help of this MetadataProperty.
        :rtype: str
        """
        return self._help

    @help.setter
    def help(self, help: str) -> None:
        """
        Sets the help of this MetadataProperty.
        optional URL with addition information about the input property

        :param help: The help of this MetadataProperty.
        :type: str
        """
        

        self._help = help

    @property
    def default(self) -> str:
        """
        Gets the default of this MetadataProperty.
        optional default value of the input property

        :return: The default of this MetadataProperty.
        :rtype: str
        """
        return self._default

    @default.setter
    def default(self, default: str) -> None:
        """
        Sets the default of this MetadataProperty.
        optional default value of the input property

        :param default: The default of this MetadataProperty.
        :type: str
        """
        

        self._default = default

    @property
    def enum(self) -> List[str]:
        """
        Gets the enum of this MetadataProperty.
        set of possible values if the input property is an enumeration

        :return: The enum of this MetadataProperty.
        :rtype: list[str]
        """
        return self._enum

    @enum.setter
    def enum(self, enum: List[str]) -> None:
        """
        Sets the enum of this MetadataProperty.
        set of possible values if the input property is an enumeration

        :param enum: The enum of this MetadataProperty.
        :type: list[str]
        """
        

        self._enum = enum

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

