# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import AdditionalLanguagesSynonyms

class NamedEntityTypeItem(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        NamedEntityTypeItem - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'value': 'str',
            'synonyms': 'list[str]',
            'additional_languages': 'dict(str, AdditionalLanguagesSynonyms)'
        }

        self.attribute_map = {
            'value': 'value',
            'synonyms': 'synonyms',
            'additional_languages': 'additionalLanguages'
        }

        self._value = None
        self._synonyms = None
        self._additional_languages = None

    @property
    def value(self) -> str:
        """
        Gets the value of this NamedEntityTypeItem.
        A value for an named entity type definition.

        :return: The value of this NamedEntityTypeItem.
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value: str) -> None:
        """
        Sets the value of this NamedEntityTypeItem.
        A value for an named entity type definition.

        :param value: The value of this NamedEntityTypeItem.
        :type: str
        """
        

        self._value = value

    @property
    def synonyms(self) -> List[str]:
        """
        Gets the synonyms of this NamedEntityTypeItem.
        Synonyms for the given named entity value.

        :return: The synonyms of this NamedEntityTypeItem.
        :rtype: list[str]
        """
        return self._synonyms

    @synonyms.setter
    def synonyms(self, synonyms: List[str]) -> None:
        """
        Sets the synonyms of this NamedEntityTypeItem.
        Synonyms for the given named entity value.

        :param synonyms: The synonyms of this NamedEntityTypeItem.
        :type: list[str]
        """
        

        self._synonyms = synonyms

    @property
    def additional_languages(self) -> Dict[str, 'AdditionalLanguagesSynonyms']:
        """
        Gets the additional_languages of this NamedEntityTypeItem.
        Additional Language Synonyms for the given named entity value.

        :return: The additional_languages of this NamedEntityTypeItem.
        :rtype: dict(str, AdditionalLanguagesSynonyms)
        """
        return self._additional_languages

    @additional_languages.setter
    def additional_languages(self, additional_languages: Dict[str, 'AdditionalLanguagesSynonyms']) -> None:
        """
        Sets the additional_languages of this NamedEntityTypeItem.
        Additional Language Synonyms for the given named entity value.

        :param additional_languages: The additional_languages of this NamedEntityTypeItem.
        :type: dict(str, AdditionalLanguagesSynonyms)
        """
        

        self._additional_languages = additional_languages

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

