# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import DomainEntityRef

class OpenActionFields(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        OpenActionFields - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'open_action': 'DomainEntityRef',
            'configuration_fields': 'dict(str, object)'
        }

        self.attribute_map = {
            'open_action': 'openAction',
            'configuration_fields': 'configurationFields'
        }

        self._open_action = None
        self._configuration_fields = None

    @property
    def open_action(self) -> 'DomainEntityRef':
        """
        Gets the open_action of this OpenActionFields.
        The specific type of the open action.

        :return: The open_action of this OpenActionFields.
        :rtype: DomainEntityRef
        """
        return self._open_action

    @open_action.setter
    def open_action(self, open_action: 'DomainEntityRef') -> None:
        """
        Sets the open_action of this OpenActionFields.
        The specific type of the open action.

        :param open_action: The open_action of this OpenActionFields.
        :type: DomainEntityRef
        """
        

        self._open_action = open_action

    @property
    def configuration_fields(self) -> Dict[str, object]:
        """
        Gets the configuration_fields of this OpenActionFields.
        Custom fields defined in the schema referenced by the open action type selected.

        :return: The configuration_fields of this OpenActionFields.
        :rtype: dict(str, object)
        """
        return self._configuration_fields

    @configuration_fields.setter
    def configuration_fields(self, configuration_fields: Dict[str, object]) -> None:
        """
        Sets the configuration_fields of this OpenActionFields.
        Custom fields defined in the schema referenced by the open action type selected.

        :param configuration_fields: The configuration_fields of this OpenActionFields.
        :type: dict(str, object)
        """
        

        self._configuration_fields = configuration_fields

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

