# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class OrganizationPresenceDefinition(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        OrganizationPresenceDefinition - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'name': 'str',
            'type': 'str',
            'language_labels': 'dict(str, str)',
            'system_presence': 'str',
            'division_id': 'str',
            'deactivated': 'bool',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'type': 'type',
            'language_labels': 'languageLabels',
            'system_presence': 'systemPresence',
            'division_id': 'divisionId',
            'deactivated': 'deactivated',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._name = None
        self._type = None
        self._language_labels = None
        self._system_presence = None
        self._division_id = None
        self._deactivated = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this OrganizationPresenceDefinition.
        The globally unique identifier for the object.

        :return: The id of this OrganizationPresenceDefinition.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this OrganizationPresenceDefinition.
        The globally unique identifier for the object.

        :param id: The id of this OrganizationPresenceDefinition.
        :type: str
        """
        

        self._id = id

    @property
    def name(self) -> str:
        """
        Gets the name of this OrganizationPresenceDefinition.


        :return: The name of this OrganizationPresenceDefinition.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str) -> None:
        """
        Sets the name of this OrganizationPresenceDefinition.


        :param name: The name of this OrganizationPresenceDefinition.
        :type: str
        """
        

        self._name = name

    @property
    def type(self) -> str:
        """
        Gets the type of this OrganizationPresenceDefinition.
        The type of definition

        :return: The type of this OrganizationPresenceDefinition.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str) -> None:
        """
        Sets the type of this OrganizationPresenceDefinition.
        The type of definition

        :param type: The type of this OrganizationPresenceDefinition.
        :type: str
        """
        if isinstance(type, int):
            type = str(type)
        allowed_values = ["System", "User"]
        if type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for type -> " + type)
            self._type = "outdated_sdk_version"
        else:
            self._type = type

    @property
    def language_labels(self) -> Dict[str, str]:
        """
        Gets the language_labels of this OrganizationPresenceDefinition.
        The label used for the definition in each specified language

        :return: The language_labels of this OrganizationPresenceDefinition.
        :rtype: dict(str, str)
        """
        return self._language_labels

    @language_labels.setter
    def language_labels(self, language_labels: Dict[str, str]) -> None:
        """
        Sets the language_labels of this OrganizationPresenceDefinition.
        The label used for the definition in each specified language

        :param language_labels: The language_labels of this OrganizationPresenceDefinition.
        :type: dict(str, str)
        """
        

        self._language_labels = language_labels

    @property
    def system_presence(self) -> str:
        """
        Gets the system_presence of this OrganizationPresenceDefinition.


        :return: The system_presence of this OrganizationPresenceDefinition.
        :rtype: str
        """
        return self._system_presence

    @system_presence.setter
    def system_presence(self, system_presence: str) -> None:
        """
        Sets the system_presence of this OrganizationPresenceDefinition.


        :param system_presence: The system_presence of this OrganizationPresenceDefinition.
        :type: str
        """
        if isinstance(system_presence, int):
            system_presence = str(system_presence)
        allowed_values = ["Available", "Away", "Busy", "Offline", "Idle", "OnQueue", "Meal", "Training", "Meeting", "Break"]
        if system_presence.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for system_presence -> " + system_presence)
            self._system_presence = "outdated_sdk_version"
        else:
            self._system_presence = system_presence

    @property
    def division_id(self) -> str:
        """
        Gets the division_id of this OrganizationPresenceDefinition.


        :return: The division_id of this OrganizationPresenceDefinition.
        :rtype: str
        """
        return self._division_id

    @division_id.setter
    def division_id(self, division_id: str) -> None:
        """
        Sets the division_id of this OrganizationPresenceDefinition.


        :param division_id: The division_id of this OrganizationPresenceDefinition.
        :type: str
        """
        

        self._division_id = division_id

    @property
    def deactivated(self) -> bool:
        """
        Gets the deactivated of this OrganizationPresenceDefinition.


        :return: The deactivated of this OrganizationPresenceDefinition.
        :rtype: bool
        """
        return self._deactivated

    @deactivated.setter
    def deactivated(self, deactivated: bool) -> None:
        """
        Sets the deactivated of this OrganizationPresenceDefinition.


        :param deactivated: The deactivated of this OrganizationPresenceDefinition.
        :type: bool
        """
        

        self._deactivated = deactivated

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this OrganizationPresenceDefinition.
        The URI for this object

        :return: The self_uri of this OrganizationPresenceDefinition.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this OrganizationPresenceDefinition.
        The URI for this object

        :param self_uri: The self_uri of this OrganizationPresenceDefinition.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

