# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class OutboundMessagingMessagingCampaignConfigChangeContactSort(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        OutboundMessagingMessagingCampaignConfigChangeContactSort - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'field_name': 'str',
            'direction': 'str',
            'numeric': 'bool',
            'additional_properties': 'dict(str, object)'
        }

        self.attribute_map = {
            'field_name': 'fieldName',
            'direction': 'direction',
            'numeric': 'numeric',
            'additional_properties': 'additionalProperties'
        }

        self._field_name = None
        self._direction = None
        self._numeric = None
        self._additional_properties = None

    @property
    def field_name(self) -> str:
        """
        Gets the field_name of this OutboundMessagingMessagingCampaignConfigChangeContactSort.


        :return: The field_name of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        :rtype: str
        """
        return self._field_name

    @field_name.setter
    def field_name(self, field_name: str) -> None:
        """
        Sets the field_name of this OutboundMessagingMessagingCampaignConfigChangeContactSort.


        :param field_name: The field_name of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        :type: str
        """
        

        self._field_name = field_name

    @property
    def direction(self) -> str:
        """
        Gets the direction of this OutboundMessagingMessagingCampaignConfigChangeContactSort.


        :return: The direction of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        :rtype: str
        """
        return self._direction

    @direction.setter
    def direction(self, direction: str) -> None:
        """
        Sets the direction of this OutboundMessagingMessagingCampaignConfigChangeContactSort.


        :param direction: The direction of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        :type: str
        """
        if isinstance(direction, int):
            direction = str(direction)
        allowed_values = ["ASC", "DESC"]
        if direction.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for direction -> " + direction)
            self._direction = "outdated_sdk_version"
        else:
            self._direction = direction

    @property
    def numeric(self) -> bool:
        """
        Gets the numeric of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        Whether that column contains numeric data

        :return: The numeric of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        :rtype: bool
        """
        return self._numeric

    @numeric.setter
    def numeric(self, numeric: bool) -> None:
        """
        Sets the numeric of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        Whether that column contains numeric data

        :param numeric: The numeric of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        :type: bool
        """
        

        self._numeric = numeric

    @property
    def additional_properties(self) -> Dict[str, object]:
        """
        Gets the additional_properties of this OutboundMessagingMessagingCampaignConfigChangeContactSort.


        :return: The additional_properties of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        :rtype: dict(str, object)
        """
        return self._additional_properties

    @additional_properties.setter
    def additional_properties(self, additional_properties: Dict[str, object]) -> None:
        """
        Sets the additional_properties of this OutboundMessagingMessagingCampaignConfigChangeContactSort.


        :param additional_properties: The additional_properties of this OutboundMessagingMessagingCampaignConfigChangeContactSort.
        :type: dict(str, object)
        """
        

        self._additional_properties = additional_properties

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

