# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class PositionSettings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        PositionSettings - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'alignment': 'str',
            'side_space': 'int',
            'bottom_space': 'int'
        }

        self.attribute_map = {
            'alignment': 'alignment',
            'side_space': 'sideSpace',
            'bottom_space': 'bottomSpace'
        }

        self._alignment = None
        self._side_space = None
        self._bottom_space = None

    @property
    def alignment(self) -> str:
        """
        Gets the alignment of this PositionSettings.
        The alignment for position

        :return: The alignment of this PositionSettings.
        :rtype: str
        """
        return self._alignment

    @alignment.setter
    def alignment(self, alignment: str) -> None:
        """
        Sets the alignment of this PositionSettings.
        The alignment for position

        :param alignment: The alignment of this PositionSettings.
        :type: str
        """
        if isinstance(alignment, int):
            alignment = str(alignment)
        allowed_values = ["Auto", "Left", "Right"]
        if alignment.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for alignment -> " + alignment)
            self._alignment = "outdated_sdk_version"
        else:
            self._alignment = alignment

    @property
    def side_space(self) -> int:
        """
        Gets the side_space of this PositionSettings.
        The sidespace value for position

        :return: The side_space of this PositionSettings.
        :rtype: int
        """
        return self._side_space

    @side_space.setter
    def side_space(self, side_space: int) -> None:
        """
        Sets the side_space of this PositionSettings.
        The sidespace value for position

        :param side_space: The side_space of this PositionSettings.
        :type: int
        """
        

        self._side_space = side_space

    @property
    def bottom_space(self) -> int:
        """
        Gets the bottom_space of this PositionSettings.
        The bottomspace value for position

        :return: The bottom_space of this PositionSettings.
        :rtype: int
        """
        return self._bottom_space

    @bottom_space.setter
    def bottom_space(self, bottom_space: int) -> None:
        """
        Sets the bottom_space of this PositionSettings.
        The bottomspace value for position

        :param bottom_space: The bottom_space of this PositionSettings.
        :type: int
        """
        

        self._bottom_space = bottom_space

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

