# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class PredictorModelFeature(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        PredictorModelFeature - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'type': 'str',
            'percentage_importance': 'float'
        }

        self.attribute_map = {
            'id': 'id',
            'type': 'type',
            'percentage_importance': 'percentageImportance'
        }

        self._id = None
        self._type = None
        self._percentage_importance = None

    @property
    def id(self) -> str:
        """
        Gets the id of this PredictorModelFeature.
        The globally unique identifier for the object.

        :return: The id of this PredictorModelFeature.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this PredictorModelFeature.
        The globally unique identifier for the object.

        :param id: The id of this PredictorModelFeature.
        :type: str
        """
        

        self._id = id

    @property
    def type(self) -> str:
        """
        Gets the type of this PredictorModelFeature.
        The type of feature.

        :return: The type of this PredictorModelFeature.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str) -> None:
        """
        Sets the type of this PredictorModelFeature.
        The type of feature.

        :param type: The type of this PredictorModelFeature.
        :type: str
        """
        if isinstance(type, int):
            type = str(type)
        allowed_values = ["User", "Customer", "Other"]
        if type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for type -> " + type)
            self._type = "outdated_sdk_version"
        else:
            self._type = type

    @property
    def percentage_importance(self) -> float:
        """
        Gets the percentage_importance of this PredictorModelFeature.
        The percentage of how important a feature is in the model.

        :return: The percentage_importance of this PredictorModelFeature.
        :rtype: float
        """
        return self._percentage_importance

    @percentage_importance.setter
    def percentage_importance(self, percentage_importance: float) -> None:
        """
        Sets the percentage_importance of this PredictorModelFeature.
        The percentage of how important a feature is in the model.

        :param percentage_importance: The percentage_importance of this PredictorModelFeature.
        :type: float
        """
        

        self._percentage_importance = percentage_importance

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

