# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import FacetEntry
    from . import FacetKeyAttribute

class QueryFacetInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        QueryFacetInfo - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'attributes': 'list[FacetKeyAttribute]',
            'facets': 'list[FacetEntry]'
        }

        self.attribute_map = {
            'attributes': 'attributes',
            'facets': 'facets'
        }

        self._attributes = None
        self._facets = None

    @property
    def attributes(self) -> List['FacetKeyAttribute']:
        """
        Gets the attributes of this QueryFacetInfo.


        :return: The attributes of this QueryFacetInfo.
        :rtype: list[FacetKeyAttribute]
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes: List['FacetKeyAttribute']) -> None:
        """
        Sets the attributes of this QueryFacetInfo.


        :param attributes: The attributes of this QueryFacetInfo.
        :type: list[FacetKeyAttribute]
        """
        

        self._attributes = attributes

    @property
    def facets(self) -> List['FacetEntry']:
        """
        Gets the facets of this QueryFacetInfo.


        :return: The facets of this QueryFacetInfo.
        :rtype: list[FacetEntry]
        """
        return self._facets

    @facets.setter
    def facets(self, facets: List['FacetEntry']) -> None:
        """
        Sets the facets of this QueryFacetInfo.


        :param facets: The facets of this QueryFacetInfo.
        :type: list[FacetEntry]
        """
        

        self._facets = facets

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

