# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import QueueConversationCallEventTopicConversationRoutingData
    from . import QueueConversationCallEventTopicErrorBody
    from . import QueueConversationCallEventTopicFaxStatus
    from . import QueueConversationCallEventTopicJourneyContext
    from . import QueueConversationCallEventTopicUriReference
    from . import QueueConversationCallEventTopicWrapup

class QueueConversationCallEventTopicCallMediaParticipant(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        QueueConversationCallEventTopicCallMediaParticipant - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'name': 'str',
            'address': 'str',
            'start_time': 'datetime',
            'connected_time': 'datetime',
            'end_time': 'datetime',
            'start_hold_time': 'datetime',
            'purpose': 'str',
            'state': 'str',
            'initial_state': 'str',
            'direction': 'str',
            'disconnect_type': 'str',
            'held': 'bool',
            'wrapup_required': 'bool',
            'wrapup_prompt': 'str',
            'user': 'QueueConversationCallEventTopicUriReference',
            'queue': 'QueueConversationCallEventTopicUriReference',
            'team': 'QueueConversationCallEventTopicUriReference',
            'attributes': 'dict(str, str)',
            'error_info': 'QueueConversationCallEventTopicErrorBody',
            'script': 'QueueConversationCallEventTopicUriReference',
            'wrapup_timeout_ms': 'int',
            'wrapup_skipped': 'bool',
            'alerting_timeout_ms': 'int',
            'provider': 'str',
            'external_contact': 'QueueConversationCallEventTopicUriReference',
            'external_organization': 'QueueConversationCallEventTopicUriReference',
            'wrapup': 'QueueConversationCallEventTopicWrapup',
            'conversation_routing_data': 'QueueConversationCallEventTopicConversationRoutingData',
            'peer': 'str',
            'screen_recording_state': 'str',
            'flagged_reason': 'str',
            'journey_context': 'QueueConversationCallEventTopicJourneyContext',
            'start_acw_time': 'datetime',
            'end_acw_time': 'datetime',
            'media_roles': 'list[str]',
            'muted': 'bool',
            'confined': 'bool',
            'recording': 'bool',
            'recording_state': 'str',
            'secure_pause': 'bool',
            'group': 'QueueConversationCallEventTopicUriReference',
            'ani': 'str',
            'dnis': 'str',
            'document_id': 'str',
            'monitored_participant_id': 'str',
            'coached_participant_id': 'str',
            'barged_participant_id': 'str',
            'barged_time': 'datetime',
            'consult_participant_id': 'str',
            'fax_status': 'QueueConversationCallEventTopicFaxStatus'
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'address': 'address',
            'start_time': 'startTime',
            'connected_time': 'connectedTime',
            'end_time': 'endTime',
            'start_hold_time': 'startHoldTime',
            'purpose': 'purpose',
            'state': 'state',
            'initial_state': 'initialState',
            'direction': 'direction',
            'disconnect_type': 'disconnectType',
            'held': 'held',
            'wrapup_required': 'wrapupRequired',
            'wrapup_prompt': 'wrapupPrompt',
            'user': 'user',
            'queue': 'queue',
            'team': 'team',
            'attributes': 'attributes',
            'error_info': 'errorInfo',
            'script': 'script',
            'wrapup_timeout_ms': 'wrapupTimeoutMs',
            'wrapup_skipped': 'wrapupSkipped',
            'alerting_timeout_ms': 'alertingTimeoutMs',
            'provider': 'provider',
            'external_contact': 'externalContact',
            'external_organization': 'externalOrganization',
            'wrapup': 'wrapup',
            'conversation_routing_data': 'conversationRoutingData',
            'peer': 'peer',
            'screen_recording_state': 'screenRecordingState',
            'flagged_reason': 'flaggedReason',
            'journey_context': 'journeyContext',
            'start_acw_time': 'startAcwTime',
            'end_acw_time': 'endAcwTime',
            'media_roles': 'mediaRoles',
            'muted': 'muted',
            'confined': 'confined',
            'recording': 'recording',
            'recording_state': 'recordingState',
            'secure_pause': 'securePause',
            'group': 'group',
            'ani': 'ani',
            'dnis': 'dnis',
            'document_id': 'documentId',
            'monitored_participant_id': 'monitoredParticipantId',
            'coached_participant_id': 'coachedParticipantId',
            'barged_participant_id': 'bargedParticipantId',
            'barged_time': 'bargedTime',
            'consult_participant_id': 'consultParticipantId',
            'fax_status': 'faxStatus'
        }

        self._id = None
        self._name = None
        self._address = None
        self._start_time = None
        self._connected_time = None
        self._end_time = None
        self._start_hold_time = None
        self._purpose = None
        self._state = None
        self._initial_state = None
        self._direction = None
        self._disconnect_type = None
        self._held = None
        self._wrapup_required = None
        self._wrapup_prompt = None
        self._user = None
        self._queue = None
        self._team = None
        self._attributes = None
        self._error_info = None
        self._script = None
        self._wrapup_timeout_ms = None
        self._wrapup_skipped = None
        self._alerting_timeout_ms = None
        self._provider = None
        self._external_contact = None
        self._external_organization = None
        self._wrapup = None
        self._conversation_routing_data = None
        self._peer = None
        self._screen_recording_state = None
        self._flagged_reason = None
        self._journey_context = None
        self._start_acw_time = None
        self._end_acw_time = None
        self._media_roles = None
        self._muted = None
        self._confined = None
        self._recording = None
        self._recording_state = None
        self._secure_pause = None
        self._group = None
        self._ani = None
        self._dnis = None
        self._document_id = None
        self._monitored_participant_id = None
        self._coached_participant_id = None
        self._barged_participant_id = None
        self._barged_time = None
        self._consult_participant_id = None
        self._fax_status = None

    @property
    def id(self) -> str:
        """
        Gets the id of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The id of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this QueueConversationCallEventTopicCallMediaParticipant.


        :param id: The id of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._id = id

    @property
    def name(self) -> str:
        """
        Gets the name of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The name of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str) -> None:
        """
        Sets the name of this QueueConversationCallEventTopicCallMediaParticipant.


        :param name: The name of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._name = name

    @property
    def address(self) -> str:
        """
        Gets the address of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The address of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address: str) -> None:
        """
        Sets the address of this QueueConversationCallEventTopicCallMediaParticipant.


        :param address: The address of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._address = address

    @property
    def start_time(self) -> datetime:
        """
        Gets the start_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The start_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time: datetime) -> None:
        """
        Sets the start_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :param start_time: The start_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: datetime
        """
        

        self._start_time = start_time

    @property
    def connected_time(self) -> datetime:
        """
        Gets the connected_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The connected_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: datetime
        """
        return self._connected_time

    @connected_time.setter
    def connected_time(self, connected_time: datetime) -> None:
        """
        Sets the connected_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :param connected_time: The connected_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: datetime
        """
        

        self._connected_time = connected_time

    @property
    def end_time(self) -> datetime:
        """
        Gets the end_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The end_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: datetime
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time: datetime) -> None:
        """
        Sets the end_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :param end_time: The end_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: datetime
        """
        

        self._end_time = end_time

    @property
    def start_hold_time(self) -> datetime:
        """
        Gets the start_hold_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The start_hold_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: datetime
        """
        return self._start_hold_time

    @start_hold_time.setter
    def start_hold_time(self, start_hold_time: datetime) -> None:
        """
        Sets the start_hold_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :param start_hold_time: The start_hold_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: datetime
        """
        

        self._start_hold_time = start_hold_time

    @property
    def purpose(self) -> str:
        """
        Gets the purpose of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The purpose of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._purpose

    @purpose.setter
    def purpose(self, purpose: str) -> None:
        """
        Sets the purpose of this QueueConversationCallEventTopicCallMediaParticipant.


        :param purpose: The purpose of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._purpose = purpose

    @property
    def state(self) -> str:
        """
        Gets the state of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The state of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state: str) -> None:
        """
        Sets the state of this QueueConversationCallEventTopicCallMediaParticipant.


        :param state: The state of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        if isinstance(state, int):
            state = str(state)
        allowed_values = ["alerting", "dialing", "contacting", "offering", "connected", "disconnected", "terminated", "converting", "uploading", "transmitting", "scheduled", "none"]
        if state.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for state -> " + state)
            self._state = "outdated_sdk_version"
        else:
            self._state = state

    @property
    def initial_state(self) -> str:
        """
        Gets the initial_state of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The initial_state of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._initial_state

    @initial_state.setter
    def initial_state(self, initial_state: str) -> None:
        """
        Sets the initial_state of this QueueConversationCallEventTopicCallMediaParticipant.


        :param initial_state: The initial_state of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        if isinstance(initial_state, int):
            initial_state = str(initial_state)
        allowed_values = ["alerting", "dialing", "contacting", "offering", "connected", "disconnected", "terminated", "converting", "uploading", "transmitting", "scheduled", "none"]
        if initial_state.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for initial_state -> " + initial_state)
            self._initial_state = "outdated_sdk_version"
        else:
            self._initial_state = initial_state

    @property
    def direction(self) -> str:
        """
        Gets the direction of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The direction of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._direction

    @direction.setter
    def direction(self, direction: str) -> None:
        """
        Sets the direction of this QueueConversationCallEventTopicCallMediaParticipant.


        :param direction: The direction of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        if isinstance(direction, int):
            direction = str(direction)
        allowed_values = ["inbound", "outbound"]
        if direction.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for direction -> " + direction)
            self._direction = "outdated_sdk_version"
        else:
            self._direction = direction

    @property
    def disconnect_type(self) -> str:
        """
        Gets the disconnect_type of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The disconnect_type of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._disconnect_type

    @disconnect_type.setter
    def disconnect_type(self, disconnect_type: str) -> None:
        """
        Sets the disconnect_type of this QueueConversationCallEventTopicCallMediaParticipant.


        :param disconnect_type: The disconnect_type of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        if isinstance(disconnect_type, int):
            disconnect_type = str(disconnect_type)
        allowed_values = ["endpoint", "client", "system", "transfer", "timeout", "transfer.conference", "transfer.consult", "transfer.forward", "transfer.noanswer", "transfer.notavailable", "transport.failure", "error", "peer", "other", "spam", "uncallable"]
        if disconnect_type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for disconnect_type -> " + disconnect_type)
            self._disconnect_type = "outdated_sdk_version"
        else:
            self._disconnect_type = disconnect_type

    @property
    def held(self) -> bool:
        """
        Gets the held of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The held of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: bool
        """
        return self._held

    @held.setter
    def held(self, held: bool) -> None:
        """
        Sets the held of this QueueConversationCallEventTopicCallMediaParticipant.


        :param held: The held of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: bool
        """
        

        self._held = held

    @property
    def wrapup_required(self) -> bool:
        """
        Gets the wrapup_required of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The wrapup_required of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: bool
        """
        return self._wrapup_required

    @wrapup_required.setter
    def wrapup_required(self, wrapup_required: bool) -> None:
        """
        Sets the wrapup_required of this QueueConversationCallEventTopicCallMediaParticipant.


        :param wrapup_required: The wrapup_required of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: bool
        """
        

        self._wrapup_required = wrapup_required

    @property
    def wrapup_prompt(self) -> str:
        """
        Gets the wrapup_prompt of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The wrapup_prompt of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._wrapup_prompt

    @wrapup_prompt.setter
    def wrapup_prompt(self, wrapup_prompt: str) -> None:
        """
        Sets the wrapup_prompt of this QueueConversationCallEventTopicCallMediaParticipant.


        :param wrapup_prompt: The wrapup_prompt of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._wrapup_prompt = wrapup_prompt

    @property
    def user(self) -> 'QueueConversationCallEventTopicUriReference':
        """
        Gets the user of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The user of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicUriReference
        """
        return self._user

    @user.setter
    def user(self, user: 'QueueConversationCallEventTopicUriReference') -> None:
        """
        Sets the user of this QueueConversationCallEventTopicCallMediaParticipant.


        :param user: The user of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicUriReference
        """
        

        self._user = user

    @property
    def queue(self) -> 'QueueConversationCallEventTopicUriReference':
        """
        Gets the queue of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The queue of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicUriReference
        """
        return self._queue

    @queue.setter
    def queue(self, queue: 'QueueConversationCallEventTopicUriReference') -> None:
        """
        Sets the queue of this QueueConversationCallEventTopicCallMediaParticipant.


        :param queue: The queue of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicUriReference
        """
        

        self._queue = queue

    @property
    def team(self) -> 'QueueConversationCallEventTopicUriReference':
        """
        Gets the team of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The team of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicUriReference
        """
        return self._team

    @team.setter
    def team(self, team: 'QueueConversationCallEventTopicUriReference') -> None:
        """
        Sets the team of this QueueConversationCallEventTopicCallMediaParticipant.


        :param team: The team of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicUriReference
        """
        

        self._team = team

    @property
    def attributes(self) -> Dict[str, str]:
        """
        Gets the attributes of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The attributes of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: dict(str, str)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes: Dict[str, str]) -> None:
        """
        Sets the attributes of this QueueConversationCallEventTopicCallMediaParticipant.


        :param attributes: The attributes of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: dict(str, str)
        """
        

        self._attributes = attributes

    @property
    def error_info(self) -> 'QueueConversationCallEventTopicErrorBody':
        """
        Gets the error_info of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The error_info of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicErrorBody
        """
        return self._error_info

    @error_info.setter
    def error_info(self, error_info: 'QueueConversationCallEventTopicErrorBody') -> None:
        """
        Sets the error_info of this QueueConversationCallEventTopicCallMediaParticipant.


        :param error_info: The error_info of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicErrorBody
        """
        

        self._error_info = error_info

    @property
    def script(self) -> 'QueueConversationCallEventTopicUriReference':
        """
        Gets the script of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The script of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicUriReference
        """
        return self._script

    @script.setter
    def script(self, script: 'QueueConversationCallEventTopicUriReference') -> None:
        """
        Sets the script of this QueueConversationCallEventTopicCallMediaParticipant.


        :param script: The script of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicUriReference
        """
        

        self._script = script

    @property
    def wrapup_timeout_ms(self) -> int:
        """
        Gets the wrapup_timeout_ms of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The wrapup_timeout_ms of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: int
        """
        return self._wrapup_timeout_ms

    @wrapup_timeout_ms.setter
    def wrapup_timeout_ms(self, wrapup_timeout_ms: int) -> None:
        """
        Sets the wrapup_timeout_ms of this QueueConversationCallEventTopicCallMediaParticipant.


        :param wrapup_timeout_ms: The wrapup_timeout_ms of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: int
        """
        

        self._wrapup_timeout_ms = wrapup_timeout_ms

    @property
    def wrapup_skipped(self) -> bool:
        """
        Gets the wrapup_skipped of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The wrapup_skipped of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: bool
        """
        return self._wrapup_skipped

    @wrapup_skipped.setter
    def wrapup_skipped(self, wrapup_skipped: bool) -> None:
        """
        Sets the wrapup_skipped of this QueueConversationCallEventTopicCallMediaParticipant.


        :param wrapup_skipped: The wrapup_skipped of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: bool
        """
        

        self._wrapup_skipped = wrapup_skipped

    @property
    def alerting_timeout_ms(self) -> int:
        """
        Gets the alerting_timeout_ms of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The alerting_timeout_ms of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: int
        """
        return self._alerting_timeout_ms

    @alerting_timeout_ms.setter
    def alerting_timeout_ms(self, alerting_timeout_ms: int) -> None:
        """
        Sets the alerting_timeout_ms of this QueueConversationCallEventTopicCallMediaParticipant.


        :param alerting_timeout_ms: The alerting_timeout_ms of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: int
        """
        

        self._alerting_timeout_ms = alerting_timeout_ms

    @property
    def provider(self) -> str:
        """
        Gets the provider of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The provider of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider: str) -> None:
        """
        Sets the provider of this QueueConversationCallEventTopicCallMediaParticipant.


        :param provider: The provider of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._provider = provider

    @property
    def external_contact(self) -> 'QueueConversationCallEventTopicUriReference':
        """
        Gets the external_contact of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The external_contact of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicUriReference
        """
        return self._external_contact

    @external_contact.setter
    def external_contact(self, external_contact: 'QueueConversationCallEventTopicUriReference') -> None:
        """
        Sets the external_contact of this QueueConversationCallEventTopicCallMediaParticipant.


        :param external_contact: The external_contact of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicUriReference
        """
        

        self._external_contact = external_contact

    @property
    def external_organization(self) -> 'QueueConversationCallEventTopicUriReference':
        """
        Gets the external_organization of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The external_organization of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicUriReference
        """
        return self._external_organization

    @external_organization.setter
    def external_organization(self, external_organization: 'QueueConversationCallEventTopicUriReference') -> None:
        """
        Sets the external_organization of this QueueConversationCallEventTopicCallMediaParticipant.


        :param external_organization: The external_organization of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicUriReference
        """
        

        self._external_organization = external_organization

    @property
    def wrapup(self) -> 'QueueConversationCallEventTopicWrapup':
        """
        Gets the wrapup of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The wrapup of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicWrapup
        """
        return self._wrapup

    @wrapup.setter
    def wrapup(self, wrapup: 'QueueConversationCallEventTopicWrapup') -> None:
        """
        Sets the wrapup of this QueueConversationCallEventTopicCallMediaParticipant.


        :param wrapup: The wrapup of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicWrapup
        """
        

        self._wrapup = wrapup

    @property
    def conversation_routing_data(self) -> 'QueueConversationCallEventTopicConversationRoutingData':
        """
        Gets the conversation_routing_data of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The conversation_routing_data of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicConversationRoutingData
        """
        return self._conversation_routing_data

    @conversation_routing_data.setter
    def conversation_routing_data(self, conversation_routing_data: 'QueueConversationCallEventTopicConversationRoutingData') -> None:
        """
        Sets the conversation_routing_data of this QueueConversationCallEventTopicCallMediaParticipant.


        :param conversation_routing_data: The conversation_routing_data of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicConversationRoutingData
        """
        

        self._conversation_routing_data = conversation_routing_data

    @property
    def peer(self) -> str:
        """
        Gets the peer of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The peer of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._peer

    @peer.setter
    def peer(self, peer: str) -> None:
        """
        Sets the peer of this QueueConversationCallEventTopicCallMediaParticipant.


        :param peer: The peer of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._peer = peer

    @property
    def screen_recording_state(self) -> str:
        """
        Gets the screen_recording_state of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The screen_recording_state of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._screen_recording_state

    @screen_recording_state.setter
    def screen_recording_state(self, screen_recording_state: str) -> None:
        """
        Sets the screen_recording_state of this QueueConversationCallEventTopicCallMediaParticipant.


        :param screen_recording_state: The screen_recording_state of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._screen_recording_state = screen_recording_state

    @property
    def flagged_reason(self) -> str:
        """
        Gets the flagged_reason of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The flagged_reason of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._flagged_reason

    @flagged_reason.setter
    def flagged_reason(self, flagged_reason: str) -> None:
        """
        Sets the flagged_reason of this QueueConversationCallEventTopicCallMediaParticipant.


        :param flagged_reason: The flagged_reason of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        if isinstance(flagged_reason, int):
            flagged_reason = str(flagged_reason)
        allowed_values = ["general"]
        if flagged_reason.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for flagged_reason -> " + flagged_reason)
            self._flagged_reason = "outdated_sdk_version"
        else:
            self._flagged_reason = flagged_reason

    @property
    def journey_context(self) -> 'QueueConversationCallEventTopicJourneyContext':
        """
        Gets the journey_context of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The journey_context of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicJourneyContext
        """
        return self._journey_context

    @journey_context.setter
    def journey_context(self, journey_context: 'QueueConversationCallEventTopicJourneyContext') -> None:
        """
        Sets the journey_context of this QueueConversationCallEventTopicCallMediaParticipant.


        :param journey_context: The journey_context of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicJourneyContext
        """
        

        self._journey_context = journey_context

    @property
    def start_acw_time(self) -> datetime:
        """
        Gets the start_acw_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The start_acw_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: datetime
        """
        return self._start_acw_time

    @start_acw_time.setter
    def start_acw_time(self, start_acw_time: datetime) -> None:
        """
        Sets the start_acw_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :param start_acw_time: The start_acw_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: datetime
        """
        

        self._start_acw_time = start_acw_time

    @property
    def end_acw_time(self) -> datetime:
        """
        Gets the end_acw_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The end_acw_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: datetime
        """
        return self._end_acw_time

    @end_acw_time.setter
    def end_acw_time(self, end_acw_time: datetime) -> None:
        """
        Sets the end_acw_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :param end_acw_time: The end_acw_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: datetime
        """
        

        self._end_acw_time = end_acw_time

    @property
    def media_roles(self) -> List[str]:
        """
        Gets the media_roles of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The media_roles of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: list[str]
        """
        return self._media_roles

    @media_roles.setter
    def media_roles(self, media_roles: List[str]) -> None:
        """
        Sets the media_roles of this QueueConversationCallEventTopicCallMediaParticipant.


        :param media_roles: The media_roles of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: list[str]
        """
        

        self._media_roles = media_roles

    @property
    def muted(self) -> bool:
        """
        Gets the muted of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The muted of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: bool
        """
        return self._muted

    @muted.setter
    def muted(self, muted: bool) -> None:
        """
        Sets the muted of this QueueConversationCallEventTopicCallMediaParticipant.


        :param muted: The muted of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: bool
        """
        

        self._muted = muted

    @property
    def confined(self) -> bool:
        """
        Gets the confined of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The confined of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: bool
        """
        return self._confined

    @confined.setter
    def confined(self, confined: bool) -> None:
        """
        Sets the confined of this QueueConversationCallEventTopicCallMediaParticipant.


        :param confined: The confined of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: bool
        """
        

        self._confined = confined

    @property
    def recording(self) -> bool:
        """
        Gets the recording of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The recording of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: bool
        """
        return self._recording

    @recording.setter
    def recording(self, recording: bool) -> None:
        """
        Sets the recording of this QueueConversationCallEventTopicCallMediaParticipant.


        :param recording: The recording of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: bool
        """
        

        self._recording = recording

    @property
    def recording_state(self) -> str:
        """
        Gets the recording_state of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The recording_state of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._recording_state

    @recording_state.setter
    def recording_state(self, recording_state: str) -> None:
        """
        Sets the recording_state of this QueueConversationCallEventTopicCallMediaParticipant.


        :param recording_state: The recording_state of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        if isinstance(recording_state, int):
            recording_state = str(recording_state)
        allowed_values = ["none", "active", "paused"]
        if recording_state.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for recording_state -> " + recording_state)
            self._recording_state = "outdated_sdk_version"
        else:
            self._recording_state = recording_state

    @property
    def secure_pause(self) -> bool:
        """
        Gets the secure_pause of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The secure_pause of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: bool
        """
        return self._secure_pause

    @secure_pause.setter
    def secure_pause(self, secure_pause: bool) -> None:
        """
        Sets the secure_pause of this QueueConversationCallEventTopicCallMediaParticipant.


        :param secure_pause: The secure_pause of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: bool
        """
        

        self._secure_pause = secure_pause

    @property
    def group(self) -> 'QueueConversationCallEventTopicUriReference':
        """
        Gets the group of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The group of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicUriReference
        """
        return self._group

    @group.setter
    def group(self, group: 'QueueConversationCallEventTopicUriReference') -> None:
        """
        Sets the group of this QueueConversationCallEventTopicCallMediaParticipant.


        :param group: The group of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicUriReference
        """
        

        self._group = group

    @property
    def ani(self) -> str:
        """
        Gets the ani of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The ani of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._ani

    @ani.setter
    def ani(self, ani: str) -> None:
        """
        Sets the ani of this QueueConversationCallEventTopicCallMediaParticipant.


        :param ani: The ani of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._ani = ani

    @property
    def dnis(self) -> str:
        """
        Gets the dnis of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The dnis of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._dnis

    @dnis.setter
    def dnis(self, dnis: str) -> None:
        """
        Sets the dnis of this QueueConversationCallEventTopicCallMediaParticipant.


        :param dnis: The dnis of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._dnis = dnis

    @property
    def document_id(self) -> str:
        """
        Gets the document_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The document_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._document_id

    @document_id.setter
    def document_id(self, document_id: str) -> None:
        """
        Sets the document_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :param document_id: The document_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._document_id = document_id

    @property
    def monitored_participant_id(self) -> str:
        """
        Gets the monitored_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The monitored_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._monitored_participant_id

    @monitored_participant_id.setter
    def monitored_participant_id(self, monitored_participant_id: str) -> None:
        """
        Sets the monitored_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :param monitored_participant_id: The monitored_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._monitored_participant_id = monitored_participant_id

    @property
    def coached_participant_id(self) -> str:
        """
        Gets the coached_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The coached_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._coached_participant_id

    @coached_participant_id.setter
    def coached_participant_id(self, coached_participant_id: str) -> None:
        """
        Sets the coached_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :param coached_participant_id: The coached_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._coached_participant_id = coached_participant_id

    @property
    def barged_participant_id(self) -> str:
        """
        Gets the barged_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The barged_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._barged_participant_id

    @barged_participant_id.setter
    def barged_participant_id(self, barged_participant_id: str) -> None:
        """
        Sets the barged_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :param barged_participant_id: The barged_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._barged_participant_id = barged_participant_id

    @property
    def barged_time(self) -> datetime:
        """
        Gets the barged_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The barged_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: datetime
        """
        return self._barged_time

    @barged_time.setter
    def barged_time(self, barged_time: datetime) -> None:
        """
        Sets the barged_time of this QueueConversationCallEventTopicCallMediaParticipant.


        :param barged_time: The barged_time of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: datetime
        """
        

        self._barged_time = barged_time

    @property
    def consult_participant_id(self) -> str:
        """
        Gets the consult_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The consult_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: str
        """
        return self._consult_participant_id

    @consult_participant_id.setter
    def consult_participant_id(self, consult_participant_id: str) -> None:
        """
        Sets the consult_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.


        :param consult_participant_id: The consult_participant_id of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: str
        """
        

        self._consult_participant_id = consult_participant_id

    @property
    def fax_status(self) -> 'QueueConversationCallEventTopicFaxStatus':
        """
        Gets the fax_status of this QueueConversationCallEventTopicCallMediaParticipant.


        :return: The fax_status of this QueueConversationCallEventTopicCallMediaParticipant.
        :rtype: QueueConversationCallEventTopicFaxStatus
        """
        return self._fax_status

    @fax_status.setter
    def fax_status(self, fax_status: 'QueueConversationCallEventTopicFaxStatus') -> None:
        """
        Sets the fax_status of this QueueConversationCallEventTopicCallMediaParticipant.


        :param fax_status: The fax_status of this QueueConversationCallEventTopicCallMediaParticipant.
        :type: QueueConversationCallEventTopicFaxStatus
        """
        

        self._fax_status = fax_status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

