# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class RecordingUploadReport(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        RecordingUploadReport - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'name': 'str',
            'state': 'str',
            'signed_url': 'str',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'state': 'state',
            'signed_url': 'signedUrl',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._name = None
        self._state = None
        self._signed_url = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this RecordingUploadReport.
        The report id.

        :return: The id of this RecordingUploadReport.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this RecordingUploadReport.
        The report id.

        :param id: The id of this RecordingUploadReport.
        :type: str
        """
        

        self._id = id

    @property
    def name(self) -> str:
        """
        Gets the name of this RecordingUploadReport.


        :return: The name of this RecordingUploadReport.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str) -> None:
        """
        Sets the name of this RecordingUploadReport.


        :param name: The name of this RecordingUploadReport.
        :type: str
        """
        

        self._name = name

    @property
    def state(self) -> str:
        """
        Gets the state of this RecordingUploadReport.
        The current status of the upload report.

        :return: The state of this RecordingUploadReport.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state: str) -> None:
        """
        Sets the state of this RecordingUploadReport.
        The current status of the upload report.

        :param state: The state of this RecordingUploadReport.
        :type: str
        """
        if isinstance(state, int):
            state = str(state)
        allowed_values = ["InProgress", "Completed", "Failed"]
        if state.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for state -> " + state)
            self._state = "outdated_sdk_version"
        else:
            self._state = state

    @property
    def signed_url(self) -> str:
        """
        Gets the signed_url of this RecordingUploadReport.
        For COMPLETED tasks, the signed url to download the report.

        :return: The signed_url of this RecordingUploadReport.
        :rtype: str
        """
        return self._signed_url

    @signed_url.setter
    def signed_url(self, signed_url: str) -> None:
        """
        Sets the signed_url of this RecordingUploadReport.
        For COMPLETED tasks, the signed url to download the report.

        :param signed_url: The signed_url of this RecordingUploadReport.
        :type: str
        """
        

        self._signed_url = signed_url

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this RecordingUploadReport.
        The URI for this object

        :return: The self_uri of this RecordingUploadReport.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this RecordingUploadReport.
        The URI for this object

        :param self_uri: The self_uri of this RecordingUploadReport.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

