# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import ScreenRecordingMetaData

class ScreenRecordingMetaDataRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        ScreenRecordingMetaDataRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'participant_jid': 'str',
            'room_id': 'str',
            'meta_data': 'list[ScreenRecordingMetaData]'
        }

        self.attribute_map = {
            'participant_jid': 'participantJid',
            'room_id': 'roomId',
            'meta_data': 'metaData'
        }

        self._participant_jid = None
        self._room_id = None
        self._meta_data = None

    @property
    def participant_jid(self) -> str:
        """
        Gets the participant_jid of this ScreenRecordingMetaDataRequest.


        :return: The participant_jid of this ScreenRecordingMetaDataRequest.
        :rtype: str
        """
        return self._participant_jid

    @participant_jid.setter
    def participant_jid(self, participant_jid: str) -> None:
        """
        Sets the participant_jid of this ScreenRecordingMetaDataRequest.


        :param participant_jid: The participant_jid of this ScreenRecordingMetaDataRequest.
        :type: str
        """
        

        self._participant_jid = participant_jid

    @property
    def room_id(self) -> str:
        """
        Gets the room_id of this ScreenRecordingMetaDataRequest.


        :return: The room_id of this ScreenRecordingMetaDataRequest.
        :rtype: str
        """
        return self._room_id

    @room_id.setter
    def room_id(self, room_id: str) -> None:
        """
        Sets the room_id of this ScreenRecordingMetaDataRequest.


        :param room_id: The room_id of this ScreenRecordingMetaDataRequest.
        :type: str
        """
        

        self._room_id = room_id

    @property
    def meta_data(self) -> List['ScreenRecordingMetaData']:
        """
        Gets the meta_data of this ScreenRecordingMetaDataRequest.


        :return: The meta_data of this ScreenRecordingMetaDataRequest.
        :rtype: list[ScreenRecordingMetaData]
        """
        return self._meta_data

    @meta_data.setter
    def meta_data(self, meta_data: List['ScreenRecordingMetaData']) -> None:
        """
        Sets the meta_data of this ScreenRecordingMetaDataRequest.


        :param meta_data: The meta_data of this ScreenRecordingMetaDataRequest.
        :type: list[ScreenRecordingMetaData]
        """
        

        self._meta_data = meta_data

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

