# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import TranscriptionTopicTranscriptResult
    from . import TranscriptionTopicTranscriptionRequestStatus

class TranscriptionTopicTranscriptionMessage(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        TranscriptionTopicTranscriptionMessage - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'event_time': 'datetime',
            'organization_id': 'str',
            'conversation_id': 'str',
            'communication_id': 'str',
            'session_start_time_ms': 'int',
            'transcription_start_time_ms': 'int',
            'transcripts': 'list[TranscriptionTopicTranscriptResult]',
            'status': 'TranscriptionTopicTranscriptionRequestStatus'
        }

        self.attribute_map = {
            'event_time': 'eventTime',
            'organization_id': 'organizationId',
            'conversation_id': 'conversationId',
            'communication_id': 'communicationId',
            'session_start_time_ms': 'sessionStartTimeMs',
            'transcription_start_time_ms': 'transcriptionStartTimeMs',
            'transcripts': 'transcripts',
            'status': 'status'
        }

        self._event_time = None
        self._organization_id = None
        self._conversation_id = None
        self._communication_id = None
        self._session_start_time_ms = None
        self._transcription_start_time_ms = None
        self._transcripts = None
        self._status = None

    @property
    def event_time(self) -> datetime:
        """
        Gets the event_time of this TranscriptionTopicTranscriptionMessage.


        :return: The event_time of this TranscriptionTopicTranscriptionMessage.
        :rtype: datetime
        """
        return self._event_time

    @event_time.setter
    def event_time(self, event_time: datetime) -> None:
        """
        Sets the event_time of this TranscriptionTopicTranscriptionMessage.


        :param event_time: The event_time of this TranscriptionTopicTranscriptionMessage.
        :type: datetime
        """
        

        self._event_time = event_time

    @property
    def organization_id(self) -> str:
        """
        Gets the organization_id of this TranscriptionTopicTranscriptionMessage.


        :return: The organization_id of this TranscriptionTopicTranscriptionMessage.
        :rtype: str
        """
        return self._organization_id

    @organization_id.setter
    def organization_id(self, organization_id: str) -> None:
        """
        Sets the organization_id of this TranscriptionTopicTranscriptionMessage.


        :param organization_id: The organization_id of this TranscriptionTopicTranscriptionMessage.
        :type: str
        """
        

        self._organization_id = organization_id

    @property
    def conversation_id(self) -> str:
        """
        Gets the conversation_id of this TranscriptionTopicTranscriptionMessage.


        :return: The conversation_id of this TranscriptionTopicTranscriptionMessage.
        :rtype: str
        """
        return self._conversation_id

    @conversation_id.setter
    def conversation_id(self, conversation_id: str) -> None:
        """
        Sets the conversation_id of this TranscriptionTopicTranscriptionMessage.


        :param conversation_id: The conversation_id of this TranscriptionTopicTranscriptionMessage.
        :type: str
        """
        

        self._conversation_id = conversation_id

    @property
    def communication_id(self) -> str:
        """
        Gets the communication_id of this TranscriptionTopicTranscriptionMessage.


        :return: The communication_id of this TranscriptionTopicTranscriptionMessage.
        :rtype: str
        """
        return self._communication_id

    @communication_id.setter
    def communication_id(self, communication_id: str) -> None:
        """
        Sets the communication_id of this TranscriptionTopicTranscriptionMessage.


        :param communication_id: The communication_id of this TranscriptionTopicTranscriptionMessage.
        :type: str
        """
        

        self._communication_id = communication_id

    @property
    def session_start_time_ms(self) -> int:
        """
        Gets the session_start_time_ms of this TranscriptionTopicTranscriptionMessage.


        :return: The session_start_time_ms of this TranscriptionTopicTranscriptionMessage.
        :rtype: int
        """
        return self._session_start_time_ms

    @session_start_time_ms.setter
    def session_start_time_ms(self, session_start_time_ms: int) -> None:
        """
        Sets the session_start_time_ms of this TranscriptionTopicTranscriptionMessage.


        :param session_start_time_ms: The session_start_time_ms of this TranscriptionTopicTranscriptionMessage.
        :type: int
        """
        

        self._session_start_time_ms = session_start_time_ms

    @property
    def transcription_start_time_ms(self) -> int:
        """
        Gets the transcription_start_time_ms of this TranscriptionTopicTranscriptionMessage.


        :return: The transcription_start_time_ms of this TranscriptionTopicTranscriptionMessage.
        :rtype: int
        """
        return self._transcription_start_time_ms

    @transcription_start_time_ms.setter
    def transcription_start_time_ms(self, transcription_start_time_ms: int) -> None:
        """
        Sets the transcription_start_time_ms of this TranscriptionTopicTranscriptionMessage.


        :param transcription_start_time_ms: The transcription_start_time_ms of this TranscriptionTopicTranscriptionMessage.
        :type: int
        """
        

        self._transcription_start_time_ms = transcription_start_time_ms

    @property
    def transcripts(self) -> List['TranscriptionTopicTranscriptResult']:
        """
        Gets the transcripts of this TranscriptionTopicTranscriptionMessage.


        :return: The transcripts of this TranscriptionTopicTranscriptionMessage.
        :rtype: list[TranscriptionTopicTranscriptResult]
        """
        return self._transcripts

    @transcripts.setter
    def transcripts(self, transcripts: List['TranscriptionTopicTranscriptResult']) -> None:
        """
        Sets the transcripts of this TranscriptionTopicTranscriptionMessage.


        :param transcripts: The transcripts of this TranscriptionTopicTranscriptionMessage.
        :type: list[TranscriptionTopicTranscriptResult]
        """
        

        self._transcripts = transcripts

    @property
    def status(self) -> 'TranscriptionTopicTranscriptionRequestStatus':
        """
        Gets the status of this TranscriptionTopicTranscriptionMessage.


        :return: The status of this TranscriptionTopicTranscriptionMessage.
        :rtype: TranscriptionTopicTranscriptionRequestStatus
        """
        return self._status

    @status.setter
    def status(self, status: 'TranscriptionTopicTranscriptionRequestStatus') -> None:
        """
        Sets the status of this TranscriptionTopicTranscriptionMessage.


        :param status: The status of this TranscriptionTopicTranscriptionMessage.
        :type: TranscriptionTopicTranscriptionRequestStatus
        """
        

        self._status = status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

