# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import UserRoutingStatusErrorInfo
    from . import UserRoutingStatusRoutingStatus

class UserRoutingStatusUserRoutingStatus(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        UserRoutingStatusUserRoutingStatus - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'routing_status': 'UserRoutingStatusRoutingStatus',
            'error_info': 'UserRoutingStatusErrorInfo'
        }

        self.attribute_map = {
            'id': 'id',
            'routing_status': 'routingStatus',
            'error_info': 'errorInfo'
        }

        self._id = None
        self._routing_status = None
        self._error_info = None

    @property
    def id(self) -> str:
        """
        Gets the id of this UserRoutingStatusUserRoutingStatus.
        The unique identifier of the user.

        :return: The id of this UserRoutingStatusUserRoutingStatus.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this UserRoutingStatusUserRoutingStatus.
        The unique identifier of the user.

        :param id: The id of this UserRoutingStatusUserRoutingStatus.
        :type: str
        """
        

        self._id = id

    @property
    def routing_status(self) -> 'UserRoutingStatusRoutingStatus':
        """
        Gets the routing_status of this UserRoutingStatusUserRoutingStatus.


        :return: The routing_status of this UserRoutingStatusUserRoutingStatus.
        :rtype: UserRoutingStatusRoutingStatus
        """
        return self._routing_status

    @routing_status.setter
    def routing_status(self, routing_status: 'UserRoutingStatusRoutingStatus') -> None:
        """
        Sets the routing_status of this UserRoutingStatusUserRoutingStatus.


        :param routing_status: The routing_status of this UserRoutingStatusUserRoutingStatus.
        :type: UserRoutingStatusRoutingStatus
        """
        

        self._routing_status = routing_status

    @property
    def error_info(self) -> 'UserRoutingStatusErrorInfo':
        """
        Gets the error_info of this UserRoutingStatusUserRoutingStatus.


        :return: The error_info of this UserRoutingStatusUserRoutingStatus.
        :rtype: UserRoutingStatusErrorInfo
        """
        return self._error_info

    @error_info.setter
    def error_info(self, error_info: 'UserRoutingStatusErrorInfo') -> None:
        """
        Sets the error_info of this UserRoutingStatusUserRoutingStatus.


        :param error_info: The error_info of this UserRoutingStatusUserRoutingStatus.
        :type: UserRoutingStatusErrorInfo
        """
        

        self._error_info = error_info

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

