# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import ConversationProperties
    from . import NumericRange
    from . import TranscriptTopics
    from . import Transcripts

class ViewFilter(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        ViewFilter - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'media_types': 'list[str]',
            'queue_ids': 'list[str]',
            'skill_ids': 'list[str]',
            'skill_groups': 'list[str]',
            'language_ids': 'list[str]',
            'language_groups': 'list[str]',
            'directions': 'list[str]',
            'originating_directions': 'list[str]',
            'wrap_up_codes': 'list[str]',
            'dnis_list': 'list[str]',
            'session_dnis_list': 'list[str]',
            'filter_queues_by_user_ids': 'list[str]',
            'filter_users_by_queue_ids': 'list[str]',
            'user_ids': 'list[str]',
            'management_unit_ids': 'list[str]',
            'address_tos': 'list[str]',
            'address_froms': 'list[str]',
            'outbound_campaign_ids': 'list[str]',
            'outbound_contact_list_ids': 'list[str]',
            'contact_ids': 'list[str]',
            'external_contact_ids': 'list[str]',
            'external_org_ids': 'list[str]',
            'ani_list': 'list[str]',
            'durations_milliseconds': 'list[NumericRange]',
            'acd_durations_milliseconds': 'list[NumericRange]',
            'talk_durations_milliseconds': 'list[NumericRange]',
            'acw_durations_milliseconds': 'list[NumericRange]',
            'handle_durations_milliseconds': 'list[NumericRange]',
            'hold_durations_milliseconds': 'list[NumericRange]',
            'abandon_durations_milliseconds': 'list[NumericRange]',
            'evaluation_score': 'NumericRange',
            'evaluation_critical_score': 'NumericRange',
            'evaluation_form_ids': 'list[str]',
            'evaluated_agent_ids': 'list[str]',
            'evaluator_ids': 'list[str]',
            'transferred': 'bool',
            'abandoned': 'bool',
            'answered': 'bool',
            'message_types': 'list[str]',
            'division_ids': 'list[str]',
            'survey_form_ids': 'list[str]',
            'survey_total_score': 'NumericRange',
            'survey_nps_score': 'NumericRange',
            'mos': 'NumericRange',
            'survey_question_group_score': 'NumericRange',
            'survey_promoter_score': 'NumericRange',
            'survey_form_context_ids': 'list[str]',
            'conversation_ids': 'list[str]',
            'sip_call_ids': 'list[str]',
            'is_ended': 'bool',
            'is_surveyed': 'bool',
            'survey_scores': 'list[NumericRange]',
            'promoter_scores': 'list[NumericRange]',
            'is_campaign': 'bool',
            'survey_statuses': 'list[str]',
            'conversation_properties': 'ConversationProperties',
            'is_blind_transferred': 'bool',
            'is_consulted': 'bool',
            'is_consult_transferred': 'bool',
            'remote_participants': 'list[str]',
            'flow_ids': 'list[str]',
            'flow_outcome_ids': 'list[str]',
            'flow_outcome_values': 'list[str]',
            'flow_destination_types': 'list[str]',
            'flow_disconnect_reasons': 'list[str]',
            'flow_types': 'list[str]',
            'flow_entry_types': 'list[str]',
            'flow_entry_reasons': 'list[str]',
            'flow_versions': 'list[str]',
            'group_ids': 'list[str]',
            'has_journey_customer_id': 'bool',
            'has_journey_action_map_id': 'bool',
            'has_journey_visit_id': 'bool',
            'has_media': 'bool',
            'role_ids': 'list[str]',
            'reports_tos': 'list[str]',
            'location_ids': 'list[str]',
            'flow_out_types': 'list[str]',
            'provider_list': 'list[str]',
            'callback_number_list': 'list[str]',
            'callback_interval': 'str',
            'used_routing_types': 'list[str]',
            'requested_routing_types': 'list[str]',
            'has_agent_assist_id': 'bool',
            'transcripts': 'list[Transcripts]',
            'transcript_languages': 'list[str]',
            'participant_purposes': 'list[str]',
            'show_first_queue': 'bool',
            'team_ids': 'list[str]',
            'filter_users_by_team_ids': 'list[str]',
            'journey_action_map_ids': 'list[str]',
            'journey_outcome_ids': 'list[str]',
            'journey_segment_ids': 'list[str]',
            'journey_action_map_types': 'list[str]',
            'development_role_list': 'list[str]',
            'development_type_list': 'list[str]',
            'development_status_list': 'list[str]',
            'development_module_ids': 'list[str]',
            'development_activity_overdue': 'bool',
            'customer_sentiment_score': 'NumericRange',
            'customer_sentiment_trend': 'NumericRange',
            'flow_transfer_targets': 'list[str]',
            'development_name': 'str',
            'topic_ids': 'list[str]',
            'external_tags': 'list[str]',
            'is_not_responding': 'bool',
            'is_authenticated': 'bool',
            'bot_ids': 'list[str]',
            'bot_versions': 'list[str]',
            'bot_message_types': 'list[str]',
            'bot_provider_list': 'list[str]',
            'bot_product_list': 'list[str]',
            'bot_recognition_failure_reason_list': 'list[str]',
            'bot_intent_list': 'list[str]',
            'bot_final_intent_list': 'list[str]',
            'bot_slot_list': 'list[str]',
            'bot_result_list': 'list[str]',
            'blocked_reasons': 'list[str]',
            'is_recorded': 'bool',
            'has_evaluation': 'bool',
            'has_scored_evaluation': 'bool',
            'email_delivery_status_list': 'list[str]',
            'is_agent_owned_callback': 'bool',
            'agent_callback_owner_ids': 'list[str]',
            'transcript_topics': 'list[TranscriptTopics]',
            'journey_frequency_cap_reasons': 'list[str]',
            'journey_blocking_action_map_ids': 'list[str]',
            'journey_action_target_ids': 'list[str]',
            'journey_blocking_schedule_group_ids': 'list[str]',
            'journey_blocking_emergency_schedule_group_ids': 'list[str]',
            'journey_url_equal_conditions': 'list[str]',
            'journey_url_not_equal_conditions': 'list[str]',
            'journey_url_starts_with_conditions': 'list[str]',
            'journey_url_ends_with_conditions': 'list[str]',
            'journey_url_contains_any_conditions': 'list[str]',
            'journey_url_not_contains_any_conditions': 'list[str]',
            'journey_url_contains_all_conditions': 'list[str]',
            'journey_url_not_contains_all_conditions': 'list[str]',
            'flow_milestone_ids': 'list[str]',
            'is_assessment_passed': 'bool',
            'conversation_initiators': 'list[str]',
            'has_customer_participated': 'bool',
            'is_acd_interaction': 'bool',
            'has_fax': 'bool',
            'data_action_ids': 'list[str]',
            'action_category_name': 'str',
            'integration_ids': 'list[str]',
            'response_statuses': 'list[str]',
            'available_dashboard': 'str',
            'favourite_dashboard': 'bool',
            'my_dashboard': 'bool',
            'station_errors': 'list[str]',
            'canonical_contact_ids': 'list[str]',
            'alert_rule_ids': 'list[str]',
            'evaluation_form_context_ids': 'list[str]',
            'evaluation_statuses': 'list[str]',
            'workbin_ids': 'list[str]',
            'worktype_ids': 'list[str]',
            'workitem_ids': 'list[str]',
            'workitem_assignee_ids': 'list[str]',
            'workitem_statuses': 'list[str]',
            'is_analyzed_for_sensitive_data': 'bool',
            'has_sensitive_data': 'bool',
            'sub_path': 'str',
            'user_state': 'str',
            'is_cleared_by_customer': 'bool',
            'evaluation_assignee_ids': 'list[str]',
            'evaluation_assigned': 'bool',
            'assistant_ids': 'list[str]',
            'knowledge_base_ids': 'list[str]',
            'is_parked': 'bool'
        }

        self.attribute_map = {
            'media_types': 'mediaTypes',
            'queue_ids': 'queueIds',
            'skill_ids': 'skillIds',
            'skill_groups': 'skillGroups',
            'language_ids': 'languageIds',
            'language_groups': 'languageGroups',
            'directions': 'directions',
            'originating_directions': 'originatingDirections',
            'wrap_up_codes': 'wrapUpCodes',
            'dnis_list': 'dnisList',
            'session_dnis_list': 'sessionDnisList',
            'filter_queues_by_user_ids': 'filterQueuesByUserIds',
            'filter_users_by_queue_ids': 'filterUsersByQueueIds',
            'user_ids': 'userIds',
            'management_unit_ids': 'managementUnitIds',
            'address_tos': 'addressTos',
            'address_froms': 'addressFroms',
            'outbound_campaign_ids': 'outboundCampaignIds',
            'outbound_contact_list_ids': 'outboundContactListIds',
            'contact_ids': 'contactIds',
            'external_contact_ids': 'externalContactIds',
            'external_org_ids': 'externalOrgIds',
            'ani_list': 'aniList',
            'durations_milliseconds': 'durationsMilliseconds',
            'acd_durations_milliseconds': 'acdDurationsMilliseconds',
            'talk_durations_milliseconds': 'talkDurationsMilliseconds',
            'acw_durations_milliseconds': 'acwDurationsMilliseconds',
            'handle_durations_milliseconds': 'handleDurationsMilliseconds',
            'hold_durations_milliseconds': 'holdDurationsMilliseconds',
            'abandon_durations_milliseconds': 'abandonDurationsMilliseconds',
            'evaluation_score': 'evaluationScore',
            'evaluation_critical_score': 'evaluationCriticalScore',
            'evaluation_form_ids': 'evaluationFormIds',
            'evaluated_agent_ids': 'evaluatedAgentIds',
            'evaluator_ids': 'evaluatorIds',
            'transferred': 'transferred',
            'abandoned': 'abandoned',
            'answered': 'answered',
            'message_types': 'messageTypes',
            'division_ids': 'divisionIds',
            'survey_form_ids': 'surveyFormIds',
            'survey_total_score': 'surveyTotalScore',
            'survey_nps_score': 'surveyNpsScore',
            'mos': 'mos',
            'survey_question_group_score': 'surveyQuestionGroupScore',
            'survey_promoter_score': 'surveyPromoterScore',
            'survey_form_context_ids': 'surveyFormContextIds',
            'conversation_ids': 'conversationIds',
            'sip_call_ids': 'sipCallIds',
            'is_ended': 'isEnded',
            'is_surveyed': 'isSurveyed',
            'survey_scores': 'surveyScores',
            'promoter_scores': 'promoterScores',
            'is_campaign': 'isCampaign',
            'survey_statuses': 'surveyStatuses',
            'conversation_properties': 'conversationProperties',
            'is_blind_transferred': 'isBlindTransferred',
            'is_consulted': 'isConsulted',
            'is_consult_transferred': 'isConsultTransferred',
            'remote_participants': 'remoteParticipants',
            'flow_ids': 'flowIds',
            'flow_outcome_ids': 'flowOutcomeIds',
            'flow_outcome_values': 'flowOutcomeValues',
            'flow_destination_types': 'flowDestinationTypes',
            'flow_disconnect_reasons': 'flowDisconnectReasons',
            'flow_types': 'flowTypes',
            'flow_entry_types': 'flowEntryTypes',
            'flow_entry_reasons': 'flowEntryReasons',
            'flow_versions': 'flowVersions',
            'group_ids': 'groupIds',
            'has_journey_customer_id': 'hasJourneyCustomerId',
            'has_journey_action_map_id': 'hasJourneyActionMapId',
            'has_journey_visit_id': 'hasJourneyVisitId',
            'has_media': 'hasMedia',
            'role_ids': 'roleIds',
            'reports_tos': 'reportsTos',
            'location_ids': 'locationIds',
            'flow_out_types': 'flowOutTypes',
            'provider_list': 'providerList',
            'callback_number_list': 'callbackNumberList',
            'callback_interval': 'callbackInterval',
            'used_routing_types': 'usedRoutingTypes',
            'requested_routing_types': 'requestedRoutingTypes',
            'has_agent_assist_id': 'hasAgentAssistId',
            'transcripts': 'transcripts',
            'transcript_languages': 'transcriptLanguages',
            'participant_purposes': 'participantPurposes',
            'show_first_queue': 'showFirstQueue',
            'team_ids': 'teamIds',
            'filter_users_by_team_ids': 'filterUsersByTeamIds',
            'journey_action_map_ids': 'journeyActionMapIds',
            'journey_outcome_ids': 'journeyOutcomeIds',
            'journey_segment_ids': 'journeySegmentIds',
            'journey_action_map_types': 'journeyActionMapTypes',
            'development_role_list': 'developmentRoleList',
            'development_type_list': 'developmentTypeList',
            'development_status_list': 'developmentStatusList',
            'development_module_ids': 'developmentModuleIds',
            'development_activity_overdue': 'developmentActivityOverdue',
            'customer_sentiment_score': 'customerSentimentScore',
            'customer_sentiment_trend': 'customerSentimentTrend',
            'flow_transfer_targets': 'flowTransferTargets',
            'development_name': 'developmentName',
            'topic_ids': 'topicIds',
            'external_tags': 'externalTags',
            'is_not_responding': 'isNotResponding',
            'is_authenticated': 'isAuthenticated',
            'bot_ids': 'botIds',
            'bot_versions': 'botVersions',
            'bot_message_types': 'botMessageTypes',
            'bot_provider_list': 'botProviderList',
            'bot_product_list': 'botProductList',
            'bot_recognition_failure_reason_list': 'botRecognitionFailureReasonList',
            'bot_intent_list': 'botIntentList',
            'bot_final_intent_list': 'botFinalIntentList',
            'bot_slot_list': 'botSlotList',
            'bot_result_list': 'botResultList',
            'blocked_reasons': 'blockedReasons',
            'is_recorded': 'isRecorded',
            'has_evaluation': 'hasEvaluation',
            'has_scored_evaluation': 'hasScoredEvaluation',
            'email_delivery_status_list': 'emailDeliveryStatusList',
            'is_agent_owned_callback': 'isAgentOwnedCallback',
            'agent_callback_owner_ids': 'agentCallbackOwnerIds',
            'transcript_topics': 'transcriptTopics',
            'journey_frequency_cap_reasons': 'journeyFrequencyCapReasons',
            'journey_blocking_action_map_ids': 'journeyBlockingActionMapIds',
            'journey_action_target_ids': 'journeyActionTargetIds',
            'journey_blocking_schedule_group_ids': 'journeyBlockingScheduleGroupIds',
            'journey_blocking_emergency_schedule_group_ids': 'journeyBlockingEmergencyScheduleGroupIds',
            'journey_url_equal_conditions': 'journeyUrlEqualConditions',
            'journey_url_not_equal_conditions': 'journeyUrlNotEqualConditions',
            'journey_url_starts_with_conditions': 'journeyUrlStartsWithConditions',
            'journey_url_ends_with_conditions': 'journeyUrlEndsWithConditions',
            'journey_url_contains_any_conditions': 'journeyUrlContainsAnyConditions',
            'journey_url_not_contains_any_conditions': 'journeyUrlNotContainsAnyConditions',
            'journey_url_contains_all_conditions': 'journeyUrlContainsAllConditions',
            'journey_url_not_contains_all_conditions': 'journeyUrlNotContainsAllConditions',
            'flow_milestone_ids': 'flowMilestoneIds',
            'is_assessment_passed': 'isAssessmentPassed',
            'conversation_initiators': 'conversationInitiators',
            'has_customer_participated': 'hasCustomerParticipated',
            'is_acd_interaction': 'isAcdInteraction',
            'has_fax': 'hasFax',
            'data_action_ids': 'dataActionIds',
            'action_category_name': 'actionCategoryName',
            'integration_ids': 'integrationIds',
            'response_statuses': 'responseStatuses',
            'available_dashboard': 'availableDashboard',
            'favourite_dashboard': 'favouriteDashboard',
            'my_dashboard': 'myDashboard',
            'station_errors': 'stationErrors',
            'canonical_contact_ids': 'canonicalContactIds',
            'alert_rule_ids': 'alertRuleIds',
            'evaluation_form_context_ids': 'evaluationFormContextIds',
            'evaluation_statuses': 'evaluationStatuses',
            'workbin_ids': 'workbinIds',
            'worktype_ids': 'worktypeIds',
            'workitem_ids': 'workitemIds',
            'workitem_assignee_ids': 'workitemAssigneeIds',
            'workitem_statuses': 'workitemStatuses',
            'is_analyzed_for_sensitive_data': 'isAnalyzedForSensitiveData',
            'has_sensitive_data': 'hasSensitiveData',
            'sub_path': 'subPath',
            'user_state': 'userState',
            'is_cleared_by_customer': 'isClearedByCustomer',
            'evaluation_assignee_ids': 'evaluationAssigneeIds',
            'evaluation_assigned': 'evaluationAssigned',
            'assistant_ids': 'assistantIds',
            'knowledge_base_ids': 'knowledgeBaseIds',
            'is_parked': 'isParked'
        }

        self._media_types = None
        self._queue_ids = None
        self._skill_ids = None
        self._skill_groups = None
        self._language_ids = None
        self._language_groups = None
        self._directions = None
        self._originating_directions = None
        self._wrap_up_codes = None
        self._dnis_list = None
        self._session_dnis_list = None
        self._filter_queues_by_user_ids = None
        self._filter_users_by_queue_ids = None
        self._user_ids = None
        self._management_unit_ids = None
        self._address_tos = None
        self._address_froms = None
        self._outbound_campaign_ids = None
        self._outbound_contact_list_ids = None
        self._contact_ids = None
        self._external_contact_ids = None
        self._external_org_ids = None
        self._ani_list = None
        self._durations_milliseconds = None
        self._acd_durations_milliseconds = None
        self._talk_durations_milliseconds = None
        self._acw_durations_milliseconds = None
        self._handle_durations_milliseconds = None
        self._hold_durations_milliseconds = None
        self._abandon_durations_milliseconds = None
        self._evaluation_score = None
        self._evaluation_critical_score = None
        self._evaluation_form_ids = None
        self._evaluated_agent_ids = None
        self._evaluator_ids = None
        self._transferred = None
        self._abandoned = None
        self._answered = None
        self._message_types = None
        self._division_ids = None
        self._survey_form_ids = None
        self._survey_total_score = None
        self._survey_nps_score = None
        self._mos = None
        self._survey_question_group_score = None
        self._survey_promoter_score = None
        self._survey_form_context_ids = None
        self._conversation_ids = None
        self._sip_call_ids = None
        self._is_ended = None
        self._is_surveyed = None
        self._survey_scores = None
        self._promoter_scores = None
        self._is_campaign = None
        self._survey_statuses = None
        self._conversation_properties = None
        self._is_blind_transferred = None
        self._is_consulted = None
        self._is_consult_transferred = None
        self._remote_participants = None
        self._flow_ids = None
        self._flow_outcome_ids = None
        self._flow_outcome_values = None
        self._flow_destination_types = None
        self._flow_disconnect_reasons = None
        self._flow_types = None
        self._flow_entry_types = None
        self._flow_entry_reasons = None
        self._flow_versions = None
        self._group_ids = None
        self._has_journey_customer_id = None
        self._has_journey_action_map_id = None
        self._has_journey_visit_id = None
        self._has_media = None
        self._role_ids = None
        self._reports_tos = None
        self._location_ids = None
        self._flow_out_types = None
        self._provider_list = None
        self._callback_number_list = None
        self._callback_interval = None
        self._used_routing_types = None
        self._requested_routing_types = None
        self._has_agent_assist_id = None
        self._transcripts = None
        self._transcript_languages = None
        self._participant_purposes = None
        self._show_first_queue = None
        self._team_ids = None
        self._filter_users_by_team_ids = None
        self._journey_action_map_ids = None
        self._journey_outcome_ids = None
        self._journey_segment_ids = None
        self._journey_action_map_types = None
        self._development_role_list = None
        self._development_type_list = None
        self._development_status_list = None
        self._development_module_ids = None
        self._development_activity_overdue = None
        self._customer_sentiment_score = None
        self._customer_sentiment_trend = None
        self._flow_transfer_targets = None
        self._development_name = None
        self._topic_ids = None
        self._external_tags = None
        self._is_not_responding = None
        self._is_authenticated = None
        self._bot_ids = None
        self._bot_versions = None
        self._bot_message_types = None
        self._bot_provider_list = None
        self._bot_product_list = None
        self._bot_recognition_failure_reason_list = None
        self._bot_intent_list = None
        self._bot_final_intent_list = None
        self._bot_slot_list = None
        self._bot_result_list = None
        self._blocked_reasons = None
        self._is_recorded = None
        self._has_evaluation = None
        self._has_scored_evaluation = None
        self._email_delivery_status_list = None
        self._is_agent_owned_callback = None
        self._agent_callback_owner_ids = None
        self._transcript_topics = None
        self._journey_frequency_cap_reasons = None
        self._journey_blocking_action_map_ids = None
        self._journey_action_target_ids = None
        self._journey_blocking_schedule_group_ids = None
        self._journey_blocking_emergency_schedule_group_ids = None
        self._journey_url_equal_conditions = None
        self._journey_url_not_equal_conditions = None
        self._journey_url_starts_with_conditions = None
        self._journey_url_ends_with_conditions = None
        self._journey_url_contains_any_conditions = None
        self._journey_url_not_contains_any_conditions = None
        self._journey_url_contains_all_conditions = None
        self._journey_url_not_contains_all_conditions = None
        self._flow_milestone_ids = None
        self._is_assessment_passed = None
        self._conversation_initiators = None
        self._has_customer_participated = None
        self._is_acd_interaction = None
        self._has_fax = None
        self._data_action_ids = None
        self._action_category_name = None
        self._integration_ids = None
        self._response_statuses = None
        self._available_dashboard = None
        self._favourite_dashboard = None
        self._my_dashboard = None
        self._station_errors = None
        self._canonical_contact_ids = None
        self._alert_rule_ids = None
        self._evaluation_form_context_ids = None
        self._evaluation_statuses = None
        self._workbin_ids = None
        self._worktype_ids = None
        self._workitem_ids = None
        self._workitem_assignee_ids = None
        self._workitem_statuses = None
        self._is_analyzed_for_sensitive_data = None
        self._has_sensitive_data = None
        self._sub_path = None
        self._user_state = None
        self._is_cleared_by_customer = None
        self._evaluation_assignee_ids = None
        self._evaluation_assigned = None
        self._assistant_ids = None
        self._knowledge_base_ids = None
        self._is_parked = None

    @property
    def media_types(self) -> List[str]:
        """
        Gets the media_types of this ViewFilter.
        The media types are used to filter the view

        :return: The media_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._media_types

    @media_types.setter
    def media_types(self, media_types: List[str]) -> None:
        """
        Sets the media_types of this ViewFilter.
        The media types are used to filter the view

        :param media_types: The media_types of this ViewFilter.
        :type: list[str]
        """
        

        self._media_types = media_types

    @property
    def queue_ids(self) -> List[str]:
        """
        Gets the queue_ids of this ViewFilter.
        The queue ids are used to filter the view

        :return: The queue_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._queue_ids

    @queue_ids.setter
    def queue_ids(self, queue_ids: List[str]) -> None:
        """
        Sets the queue_ids of this ViewFilter.
        The queue ids are used to filter the view

        :param queue_ids: The queue_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._queue_ids = queue_ids

    @property
    def skill_ids(self) -> List[str]:
        """
        Gets the skill_ids of this ViewFilter.
        The skill ids are used to filter the view

        :return: The skill_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._skill_ids

    @skill_ids.setter
    def skill_ids(self, skill_ids: List[str]) -> None:
        """
        Sets the skill_ids of this ViewFilter.
        The skill ids are used to filter the view

        :param skill_ids: The skill_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._skill_ids = skill_ids

    @property
    def skill_groups(self) -> List[str]:
        """
        Gets the skill_groups of this ViewFilter.
        The skill groups used to filter the view

        :return: The skill_groups of this ViewFilter.
        :rtype: list[str]
        """
        return self._skill_groups

    @skill_groups.setter
    def skill_groups(self, skill_groups: List[str]) -> None:
        """
        Sets the skill_groups of this ViewFilter.
        The skill groups used to filter the view

        :param skill_groups: The skill_groups of this ViewFilter.
        :type: list[str]
        """
        

        self._skill_groups = skill_groups

    @property
    def language_ids(self) -> List[str]:
        """
        Gets the language_ids of this ViewFilter.
        The language ids are used to filter the view

        :return: The language_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._language_ids

    @language_ids.setter
    def language_ids(self, language_ids: List[str]) -> None:
        """
        Sets the language_ids of this ViewFilter.
        The language ids are used to filter the view

        :param language_ids: The language_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._language_ids = language_ids

    @property
    def language_groups(self) -> List[str]:
        """
        Gets the language_groups of this ViewFilter.
        The language groups used to filter the view

        :return: The language_groups of this ViewFilter.
        :rtype: list[str]
        """
        return self._language_groups

    @language_groups.setter
    def language_groups(self, language_groups: List[str]) -> None:
        """
        Sets the language_groups of this ViewFilter.
        The language groups used to filter the view

        :param language_groups: The language_groups of this ViewFilter.
        :type: list[str]
        """
        

        self._language_groups = language_groups

    @property
    def directions(self) -> List[str]:
        """
        Gets the directions of this ViewFilter.
        The directions are used to filter the view

        :return: The directions of this ViewFilter.
        :rtype: list[str]
        """
        return self._directions

    @directions.setter
    def directions(self, directions: List[str]) -> None:
        """
        Sets the directions of this ViewFilter.
        The directions are used to filter the view

        :param directions: The directions of this ViewFilter.
        :type: list[str]
        """
        

        self._directions = directions

    @property
    def originating_directions(self) -> List[str]:
        """
        Gets the originating_directions of this ViewFilter.
        The list of orginating directions used to filter the view

        :return: The originating_directions of this ViewFilter.
        :rtype: list[str]
        """
        return self._originating_directions

    @originating_directions.setter
    def originating_directions(self, originating_directions: List[str]) -> None:
        """
        Sets the originating_directions of this ViewFilter.
        The list of orginating directions used to filter the view

        :param originating_directions: The originating_directions of this ViewFilter.
        :type: list[str]
        """
        

        self._originating_directions = originating_directions

    @property
    def wrap_up_codes(self) -> List[str]:
        """
        Gets the wrap_up_codes of this ViewFilter.
        The wrap up codes are used to filter the view

        :return: The wrap_up_codes of this ViewFilter.
        :rtype: list[str]
        """
        return self._wrap_up_codes

    @wrap_up_codes.setter
    def wrap_up_codes(self, wrap_up_codes: List[str]) -> None:
        """
        Sets the wrap_up_codes of this ViewFilter.
        The wrap up codes are used to filter the view

        :param wrap_up_codes: The wrap_up_codes of this ViewFilter.
        :type: list[str]
        """
        

        self._wrap_up_codes = wrap_up_codes

    @property
    def dnis_list(self) -> List[str]:
        """
        Gets the dnis_list of this ViewFilter.
        The dnis list is used to filter the view

        :return: The dnis_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._dnis_list

    @dnis_list.setter
    def dnis_list(self, dnis_list: List[str]) -> None:
        """
        Sets the dnis_list of this ViewFilter.
        The dnis list is used to filter the view

        :param dnis_list: The dnis_list of this ViewFilter.
        :type: list[str]
        """
        

        self._dnis_list = dnis_list

    @property
    def session_dnis_list(self) -> List[str]:
        """
        Gets the session_dnis_list of this ViewFilter.
        The list of session dnis used to filter the view

        :return: The session_dnis_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._session_dnis_list

    @session_dnis_list.setter
    def session_dnis_list(self, session_dnis_list: List[str]) -> None:
        """
        Sets the session_dnis_list of this ViewFilter.
        The list of session dnis used to filter the view

        :param session_dnis_list: The session_dnis_list of this ViewFilter.
        :type: list[str]
        """
        

        self._session_dnis_list = session_dnis_list

    @property
    def filter_queues_by_user_ids(self) -> List[str]:
        """
        Gets the filter_queues_by_user_ids of this ViewFilter.
        The user ids are used to fetch associated queues for the view

        :return: The filter_queues_by_user_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._filter_queues_by_user_ids

    @filter_queues_by_user_ids.setter
    def filter_queues_by_user_ids(self, filter_queues_by_user_ids: List[str]) -> None:
        """
        Sets the filter_queues_by_user_ids of this ViewFilter.
        The user ids are used to fetch associated queues for the view

        :param filter_queues_by_user_ids: The filter_queues_by_user_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._filter_queues_by_user_ids = filter_queues_by_user_ids

    @property
    def filter_users_by_queue_ids(self) -> List[str]:
        """
        Gets the filter_users_by_queue_ids of this ViewFilter.
        The queue ids are used to fetch associated users for the view

        :return: The filter_users_by_queue_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._filter_users_by_queue_ids

    @filter_users_by_queue_ids.setter
    def filter_users_by_queue_ids(self, filter_users_by_queue_ids: List[str]) -> None:
        """
        Sets the filter_users_by_queue_ids of this ViewFilter.
        The queue ids are used to fetch associated users for the view

        :param filter_users_by_queue_ids: The filter_users_by_queue_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._filter_users_by_queue_ids = filter_users_by_queue_ids

    @property
    def user_ids(self) -> List[str]:
        """
        Gets the user_ids of this ViewFilter.
        The user ids are used to filter the view

        :return: The user_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._user_ids

    @user_ids.setter
    def user_ids(self, user_ids: List[str]) -> None:
        """
        Sets the user_ids of this ViewFilter.
        The user ids are used to filter the view

        :param user_ids: The user_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._user_ids = user_ids

    @property
    def management_unit_ids(self) -> List[str]:
        """
        Gets the management_unit_ids of this ViewFilter.
        The management unit ids are used to filter the view

        :return: The management_unit_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._management_unit_ids

    @management_unit_ids.setter
    def management_unit_ids(self, management_unit_ids: List[str]) -> None:
        """
        Sets the management_unit_ids of this ViewFilter.
        The management unit ids are used to filter the view

        :param management_unit_ids: The management_unit_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._management_unit_ids = management_unit_ids

    @property
    def address_tos(self) -> List[str]:
        """
        Gets the address_tos of this ViewFilter.
        The address To values are used to filter the view

        :return: The address_tos of this ViewFilter.
        :rtype: list[str]
        """
        return self._address_tos

    @address_tos.setter
    def address_tos(self, address_tos: List[str]) -> None:
        """
        Sets the address_tos of this ViewFilter.
        The address To values are used to filter the view

        :param address_tos: The address_tos of this ViewFilter.
        :type: list[str]
        """
        

        self._address_tos = address_tos

    @property
    def address_froms(self) -> List[str]:
        """
        Gets the address_froms of this ViewFilter.
        The address from values are used to filter the view

        :return: The address_froms of this ViewFilter.
        :rtype: list[str]
        """
        return self._address_froms

    @address_froms.setter
    def address_froms(self, address_froms: List[str]) -> None:
        """
        Sets the address_froms of this ViewFilter.
        The address from values are used to filter the view

        :param address_froms: The address_froms of this ViewFilter.
        :type: list[str]
        """
        

        self._address_froms = address_froms

    @property
    def outbound_campaign_ids(self) -> List[str]:
        """
        Gets the outbound_campaign_ids of this ViewFilter.
        The outbound campaign ids are used to filter the view

        :return: The outbound_campaign_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._outbound_campaign_ids

    @outbound_campaign_ids.setter
    def outbound_campaign_ids(self, outbound_campaign_ids: List[str]) -> None:
        """
        Sets the outbound_campaign_ids of this ViewFilter.
        The outbound campaign ids are used to filter the view

        :param outbound_campaign_ids: The outbound_campaign_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._outbound_campaign_ids = outbound_campaign_ids

    @property
    def outbound_contact_list_ids(self) -> List[str]:
        """
        Gets the outbound_contact_list_ids of this ViewFilter.
        The outbound contact list ids are used to filter the view

        :return: The outbound_contact_list_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._outbound_contact_list_ids

    @outbound_contact_list_ids.setter
    def outbound_contact_list_ids(self, outbound_contact_list_ids: List[str]) -> None:
        """
        Sets the outbound_contact_list_ids of this ViewFilter.
        The outbound contact list ids are used to filter the view

        :param outbound_contact_list_ids: The outbound_contact_list_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._outbound_contact_list_ids = outbound_contact_list_ids

    @property
    def contact_ids(self) -> List[str]:
        """
        Gets the contact_ids of this ViewFilter.
        The contact ids are used to filter the view

        :return: The contact_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._contact_ids

    @contact_ids.setter
    def contact_ids(self, contact_ids: List[str]) -> None:
        """
        Sets the contact_ids of this ViewFilter.
        The contact ids are used to filter the view

        :param contact_ids: The contact_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._contact_ids = contact_ids

    @property
    def external_contact_ids(self) -> List[str]:
        """
        Gets the external_contact_ids of this ViewFilter.
        The external contact ids are used to filter the view

        :return: The external_contact_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._external_contact_ids

    @external_contact_ids.setter
    def external_contact_ids(self, external_contact_ids: List[str]) -> None:
        """
        Sets the external_contact_ids of this ViewFilter.
        The external contact ids are used to filter the view

        :param external_contact_ids: The external_contact_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._external_contact_ids = external_contact_ids

    @property
    def external_org_ids(self) -> List[str]:
        """
        Gets the external_org_ids of this ViewFilter.
        The external org ids are used to filter the view

        :return: The external_org_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._external_org_ids

    @external_org_ids.setter
    def external_org_ids(self, external_org_ids: List[str]) -> None:
        """
        Sets the external_org_ids of this ViewFilter.
        The external org ids are used to filter the view

        :param external_org_ids: The external_org_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._external_org_ids = external_org_ids

    @property
    def ani_list(self) -> List[str]:
        """
        Gets the ani_list of this ViewFilter.
        The ani list ids are used to filter the view

        :return: The ani_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._ani_list

    @ani_list.setter
    def ani_list(self, ani_list: List[str]) -> None:
        """
        Sets the ani_list of this ViewFilter.
        The ani list ids are used to filter the view

        :param ani_list: The ani_list of this ViewFilter.
        :type: list[str]
        """
        

        self._ani_list = ani_list

    @property
    def durations_milliseconds(self) -> List['NumericRange']:
        """
        Gets the durations_milliseconds of this ViewFilter.
        The durations in milliseconds used to filter the view

        :return: The durations_milliseconds of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._durations_milliseconds

    @durations_milliseconds.setter
    def durations_milliseconds(self, durations_milliseconds: List['NumericRange']) -> None:
        """
        Sets the durations_milliseconds of this ViewFilter.
        The durations in milliseconds used to filter the view

        :param durations_milliseconds: The durations_milliseconds of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._durations_milliseconds = durations_milliseconds

    @property
    def acd_durations_milliseconds(self) -> List['NumericRange']:
        """
        Gets the acd_durations_milliseconds of this ViewFilter.
        The acd durations in milliseconds used to filter the view

        :return: The acd_durations_milliseconds of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._acd_durations_milliseconds

    @acd_durations_milliseconds.setter
    def acd_durations_milliseconds(self, acd_durations_milliseconds: List['NumericRange']) -> None:
        """
        Sets the acd_durations_milliseconds of this ViewFilter.
        The acd durations in milliseconds used to filter the view

        :param acd_durations_milliseconds: The acd_durations_milliseconds of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._acd_durations_milliseconds = acd_durations_milliseconds

    @property
    def talk_durations_milliseconds(self) -> List['NumericRange']:
        """
        Gets the talk_durations_milliseconds of this ViewFilter.
        The talk durations in milliseconds used to filter the view

        :return: The talk_durations_milliseconds of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._talk_durations_milliseconds

    @talk_durations_milliseconds.setter
    def talk_durations_milliseconds(self, talk_durations_milliseconds: List['NumericRange']) -> None:
        """
        Sets the talk_durations_milliseconds of this ViewFilter.
        The talk durations in milliseconds used to filter the view

        :param talk_durations_milliseconds: The talk_durations_milliseconds of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._talk_durations_milliseconds = talk_durations_milliseconds

    @property
    def acw_durations_milliseconds(self) -> List['NumericRange']:
        """
        Gets the acw_durations_milliseconds of this ViewFilter.
        The acw durations in milliseconds used to filter the view

        :return: The acw_durations_milliseconds of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._acw_durations_milliseconds

    @acw_durations_milliseconds.setter
    def acw_durations_milliseconds(self, acw_durations_milliseconds: List['NumericRange']) -> None:
        """
        Sets the acw_durations_milliseconds of this ViewFilter.
        The acw durations in milliseconds used to filter the view

        :param acw_durations_milliseconds: The acw_durations_milliseconds of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._acw_durations_milliseconds = acw_durations_milliseconds

    @property
    def handle_durations_milliseconds(self) -> List['NumericRange']:
        """
        Gets the handle_durations_milliseconds of this ViewFilter.
        The handle durations in milliseconds used to filter the view

        :return: The handle_durations_milliseconds of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._handle_durations_milliseconds

    @handle_durations_milliseconds.setter
    def handle_durations_milliseconds(self, handle_durations_milliseconds: List['NumericRange']) -> None:
        """
        Sets the handle_durations_milliseconds of this ViewFilter.
        The handle durations in milliseconds used to filter the view

        :param handle_durations_milliseconds: The handle_durations_milliseconds of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._handle_durations_milliseconds = handle_durations_milliseconds

    @property
    def hold_durations_milliseconds(self) -> List['NumericRange']:
        """
        Gets the hold_durations_milliseconds of this ViewFilter.
        The hold durations in milliseconds used to filter the view

        :return: The hold_durations_milliseconds of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._hold_durations_milliseconds

    @hold_durations_milliseconds.setter
    def hold_durations_milliseconds(self, hold_durations_milliseconds: List['NumericRange']) -> None:
        """
        Sets the hold_durations_milliseconds of this ViewFilter.
        The hold durations in milliseconds used to filter the view

        :param hold_durations_milliseconds: The hold_durations_milliseconds of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._hold_durations_milliseconds = hold_durations_milliseconds

    @property
    def abandon_durations_milliseconds(self) -> List['NumericRange']:
        """
        Gets the abandon_durations_milliseconds of this ViewFilter.
        The abandon durations in milliseconds used to filter the view

        :return: The abandon_durations_milliseconds of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._abandon_durations_milliseconds

    @abandon_durations_milliseconds.setter
    def abandon_durations_milliseconds(self, abandon_durations_milliseconds: List['NumericRange']) -> None:
        """
        Sets the abandon_durations_milliseconds of this ViewFilter.
        The abandon durations in milliseconds used to filter the view

        :param abandon_durations_milliseconds: The abandon_durations_milliseconds of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._abandon_durations_milliseconds = abandon_durations_milliseconds

    @property
    def evaluation_score(self) -> 'NumericRange':
        """
        Gets the evaluation_score of this ViewFilter.
        The evaluationScore is used to filter the view

        :return: The evaluation_score of this ViewFilter.
        :rtype: NumericRange
        """
        return self._evaluation_score

    @evaluation_score.setter
    def evaluation_score(self, evaluation_score: 'NumericRange') -> None:
        """
        Sets the evaluation_score of this ViewFilter.
        The evaluationScore is used to filter the view

        :param evaluation_score: The evaluation_score of this ViewFilter.
        :type: NumericRange
        """
        

        self._evaluation_score = evaluation_score

    @property
    def evaluation_critical_score(self) -> 'NumericRange':
        """
        Gets the evaluation_critical_score of this ViewFilter.
        The evaluationCriticalScore is used to filter the view

        :return: The evaluation_critical_score of this ViewFilter.
        :rtype: NumericRange
        """
        return self._evaluation_critical_score

    @evaluation_critical_score.setter
    def evaluation_critical_score(self, evaluation_critical_score: 'NumericRange') -> None:
        """
        Sets the evaluation_critical_score of this ViewFilter.
        The evaluationCriticalScore is used to filter the view

        :param evaluation_critical_score: The evaluation_critical_score of this ViewFilter.
        :type: NumericRange
        """
        

        self._evaluation_critical_score = evaluation_critical_score

    @property
    def evaluation_form_ids(self) -> List[str]:
        """
        Gets the evaluation_form_ids of this ViewFilter.
        The evaluation form ids are used to filter the view

        :return: The evaluation_form_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._evaluation_form_ids

    @evaluation_form_ids.setter
    def evaluation_form_ids(self, evaluation_form_ids: List[str]) -> None:
        """
        Sets the evaluation_form_ids of this ViewFilter.
        The evaluation form ids are used to filter the view

        :param evaluation_form_ids: The evaluation_form_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._evaluation_form_ids = evaluation_form_ids

    @property
    def evaluated_agent_ids(self) -> List[str]:
        """
        Gets the evaluated_agent_ids of this ViewFilter.
        The evaluated agent ids are used to filter the view

        :return: The evaluated_agent_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._evaluated_agent_ids

    @evaluated_agent_ids.setter
    def evaluated_agent_ids(self, evaluated_agent_ids: List[str]) -> None:
        """
        Sets the evaluated_agent_ids of this ViewFilter.
        The evaluated agent ids are used to filter the view

        :param evaluated_agent_ids: The evaluated_agent_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._evaluated_agent_ids = evaluated_agent_ids

    @property
    def evaluator_ids(self) -> List[str]:
        """
        Gets the evaluator_ids of this ViewFilter.
        The evaluator ids are used to filter the view

        :return: The evaluator_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._evaluator_ids

    @evaluator_ids.setter
    def evaluator_ids(self, evaluator_ids: List[str]) -> None:
        """
        Sets the evaluator_ids of this ViewFilter.
        The evaluator ids are used to filter the view

        :param evaluator_ids: The evaluator_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._evaluator_ids = evaluator_ids

    @property
    def transferred(self) -> bool:
        """
        Gets the transferred of this ViewFilter.
        Indicates filtering for transfers

        :return: The transferred of this ViewFilter.
        :rtype: bool
        """
        return self._transferred

    @transferred.setter
    def transferred(self, transferred: bool) -> None:
        """
        Sets the transferred of this ViewFilter.
        Indicates filtering for transfers

        :param transferred: The transferred of this ViewFilter.
        :type: bool
        """
        

        self._transferred = transferred

    @property
    def abandoned(self) -> bool:
        """
        Gets the abandoned of this ViewFilter.
        Indicates filtering for abandons

        :return: The abandoned of this ViewFilter.
        :rtype: bool
        """
        return self._abandoned

    @abandoned.setter
    def abandoned(self, abandoned: bool) -> None:
        """
        Sets the abandoned of this ViewFilter.
        Indicates filtering for abandons

        :param abandoned: The abandoned of this ViewFilter.
        :type: bool
        """
        

        self._abandoned = abandoned

    @property
    def answered(self) -> bool:
        """
        Gets the answered of this ViewFilter.
        Indicates filtering for answered interactions

        :return: The answered of this ViewFilter.
        :rtype: bool
        """
        return self._answered

    @answered.setter
    def answered(self, answered: bool) -> None:
        """
        Sets the answered of this ViewFilter.
        Indicates filtering for answered interactions

        :param answered: The answered of this ViewFilter.
        :type: bool
        """
        

        self._answered = answered

    @property
    def message_types(self) -> List[str]:
        """
        Gets the message_types of this ViewFilter.
        The message media types used to filter the view

        :return: The message_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._message_types

    @message_types.setter
    def message_types(self, message_types: List[str]) -> None:
        """
        Sets the message_types of this ViewFilter.
        The message media types used to filter the view

        :param message_types: The message_types of this ViewFilter.
        :type: list[str]
        """
        

        self._message_types = message_types

    @property
    def division_ids(self) -> List[str]:
        """
        Gets the division_ids of this ViewFilter.
        The divison Ids used to filter the view

        :return: The division_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._division_ids

    @division_ids.setter
    def division_ids(self, division_ids: List[str]) -> None:
        """
        Sets the division_ids of this ViewFilter.
        The divison Ids used to filter the view

        :param division_ids: The division_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._division_ids = division_ids

    @property
    def survey_form_ids(self) -> List[str]:
        """
        Gets the survey_form_ids of this ViewFilter.
        The survey form ids used to filter the view

        :return: The survey_form_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._survey_form_ids

    @survey_form_ids.setter
    def survey_form_ids(self, survey_form_ids: List[str]) -> None:
        """
        Sets the survey_form_ids of this ViewFilter.
        The survey form ids used to filter the view

        :param survey_form_ids: The survey_form_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._survey_form_ids = survey_form_ids

    @property
    def survey_total_score(self) -> 'NumericRange':
        """
        Gets the survey_total_score of this ViewFilter.
        The survey total score used to filter the view

        :return: The survey_total_score of this ViewFilter.
        :rtype: NumericRange
        """
        return self._survey_total_score

    @survey_total_score.setter
    def survey_total_score(self, survey_total_score: 'NumericRange') -> None:
        """
        Sets the survey_total_score of this ViewFilter.
        The survey total score used to filter the view

        :param survey_total_score: The survey_total_score of this ViewFilter.
        :type: NumericRange
        """
        

        self._survey_total_score = survey_total_score

    @property
    def survey_nps_score(self) -> 'NumericRange':
        """
        Gets the survey_nps_score of this ViewFilter.
        The survey NPS score used to filter the view

        :return: The survey_nps_score of this ViewFilter.
        :rtype: NumericRange
        """
        return self._survey_nps_score

    @survey_nps_score.setter
    def survey_nps_score(self, survey_nps_score: 'NumericRange') -> None:
        """
        Sets the survey_nps_score of this ViewFilter.
        The survey NPS score used to filter the view

        :param survey_nps_score: The survey_nps_score of this ViewFilter.
        :type: NumericRange
        """
        

        self._survey_nps_score = survey_nps_score

    @property
    def mos(self) -> 'NumericRange':
        """
        Gets the mos of this ViewFilter.
        The desired range for mos values

        :return: The mos of this ViewFilter.
        :rtype: NumericRange
        """
        return self._mos

    @mos.setter
    def mos(self, mos: 'NumericRange') -> None:
        """
        Sets the mos of this ViewFilter.
        The desired range for mos values

        :param mos: The mos of this ViewFilter.
        :type: NumericRange
        """
        

        self._mos = mos

    @property
    def survey_question_group_score(self) -> 'NumericRange':
        """
        Gets the survey_question_group_score of this ViewFilter.
        The survey question group score used to filter the view

        :return: The survey_question_group_score of this ViewFilter.
        :rtype: NumericRange
        """
        return self._survey_question_group_score

    @survey_question_group_score.setter
    def survey_question_group_score(self, survey_question_group_score: 'NumericRange') -> None:
        """
        Sets the survey_question_group_score of this ViewFilter.
        The survey question group score used to filter the view

        :param survey_question_group_score: The survey_question_group_score of this ViewFilter.
        :type: NumericRange
        """
        

        self._survey_question_group_score = survey_question_group_score

    @property
    def survey_promoter_score(self) -> 'NumericRange':
        """
        Gets the survey_promoter_score of this ViewFilter.
        The survey promoter score used to filter the view

        :return: The survey_promoter_score of this ViewFilter.
        :rtype: NumericRange
        """
        return self._survey_promoter_score

    @survey_promoter_score.setter
    def survey_promoter_score(self, survey_promoter_score: 'NumericRange') -> None:
        """
        Sets the survey_promoter_score of this ViewFilter.
        The survey promoter score used to filter the view

        :param survey_promoter_score: The survey_promoter_score of this ViewFilter.
        :type: NumericRange
        """
        

        self._survey_promoter_score = survey_promoter_score

    @property
    def survey_form_context_ids(self) -> List[str]:
        """
        Gets the survey_form_context_ids of this ViewFilter.
        The list of survey form context ids used to filter the view

        :return: The survey_form_context_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._survey_form_context_ids

    @survey_form_context_ids.setter
    def survey_form_context_ids(self, survey_form_context_ids: List[str]) -> None:
        """
        Sets the survey_form_context_ids of this ViewFilter.
        The list of survey form context ids used to filter the view

        :param survey_form_context_ids: The survey_form_context_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._survey_form_context_ids = survey_form_context_ids

    @property
    def conversation_ids(self) -> List[str]:
        """
        Gets the conversation_ids of this ViewFilter.
        The list of conversation ids used to filter the view

        :return: The conversation_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._conversation_ids

    @conversation_ids.setter
    def conversation_ids(self, conversation_ids: List[str]) -> None:
        """
        Sets the conversation_ids of this ViewFilter.
        The list of conversation ids used to filter the view

        :param conversation_ids: The conversation_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._conversation_ids = conversation_ids

    @property
    def sip_call_ids(self) -> List[str]:
        """
        Gets the sip_call_ids of this ViewFilter.
        The list of SIP call ids used to filter the view

        :return: The sip_call_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._sip_call_ids

    @sip_call_ids.setter
    def sip_call_ids(self, sip_call_ids: List[str]) -> None:
        """
        Sets the sip_call_ids of this ViewFilter.
        The list of SIP call ids used to filter the view

        :param sip_call_ids: The sip_call_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._sip_call_ids = sip_call_ids

    @property
    def is_ended(self) -> bool:
        """
        Gets the is_ended of this ViewFilter.
        Indicates filtering for ended

        :return: The is_ended of this ViewFilter.
        :rtype: bool
        """
        return self._is_ended

    @is_ended.setter
    def is_ended(self, is_ended: bool) -> None:
        """
        Sets the is_ended of this ViewFilter.
        Indicates filtering for ended

        :param is_ended: The is_ended of this ViewFilter.
        :type: bool
        """
        

        self._is_ended = is_ended

    @property
    def is_surveyed(self) -> bool:
        """
        Gets the is_surveyed of this ViewFilter.
        Indicates filtering for survey

        :return: The is_surveyed of this ViewFilter.
        :rtype: bool
        """
        return self._is_surveyed

    @is_surveyed.setter
    def is_surveyed(self, is_surveyed: bool) -> None:
        """
        Sets the is_surveyed of this ViewFilter.
        Indicates filtering for survey

        :param is_surveyed: The is_surveyed of this ViewFilter.
        :type: bool
        """
        

        self._is_surveyed = is_surveyed

    @property
    def survey_scores(self) -> List['NumericRange']:
        """
        Gets the survey_scores of this ViewFilter.
        The list of survey score ranges used to filter the view

        :return: The survey_scores of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._survey_scores

    @survey_scores.setter
    def survey_scores(self, survey_scores: List['NumericRange']) -> None:
        """
        Sets the survey_scores of this ViewFilter.
        The list of survey score ranges used to filter the view

        :param survey_scores: The survey_scores of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._survey_scores = survey_scores

    @property
    def promoter_scores(self) -> List['NumericRange']:
        """
        Gets the promoter_scores of this ViewFilter.
        The list of promoter score ranges used to filter the view

        :return: The promoter_scores of this ViewFilter.
        :rtype: list[NumericRange]
        """
        return self._promoter_scores

    @promoter_scores.setter
    def promoter_scores(self, promoter_scores: List['NumericRange']) -> None:
        """
        Sets the promoter_scores of this ViewFilter.
        The list of promoter score ranges used to filter the view

        :param promoter_scores: The promoter_scores of this ViewFilter.
        :type: list[NumericRange]
        """
        

        self._promoter_scores = promoter_scores

    @property
    def is_campaign(self) -> bool:
        """
        Gets the is_campaign of this ViewFilter.
        Indicates filtering for campaign

        :return: The is_campaign of this ViewFilter.
        :rtype: bool
        """
        return self._is_campaign

    @is_campaign.setter
    def is_campaign(self, is_campaign: bool) -> None:
        """
        Sets the is_campaign of this ViewFilter.
        Indicates filtering for campaign

        :param is_campaign: The is_campaign of this ViewFilter.
        :type: bool
        """
        

        self._is_campaign = is_campaign

    @property
    def survey_statuses(self) -> List[str]:
        """
        Gets the survey_statuses of this ViewFilter.
        The list of survey statuses used to filter the view

        :return: The survey_statuses of this ViewFilter.
        :rtype: list[str]
        """
        return self._survey_statuses

    @survey_statuses.setter
    def survey_statuses(self, survey_statuses: List[str]) -> None:
        """
        Sets the survey_statuses of this ViewFilter.
        The list of survey statuses used to filter the view

        :param survey_statuses: The survey_statuses of this ViewFilter.
        :type: list[str]
        """
        

        self._survey_statuses = survey_statuses

    @property
    def conversation_properties(self) -> 'ConversationProperties':
        """
        Gets the conversation_properties of this ViewFilter.
        A grouping of conversation level filters

        :return: The conversation_properties of this ViewFilter.
        :rtype: ConversationProperties
        """
        return self._conversation_properties

    @conversation_properties.setter
    def conversation_properties(self, conversation_properties: 'ConversationProperties') -> None:
        """
        Sets the conversation_properties of this ViewFilter.
        A grouping of conversation level filters

        :param conversation_properties: The conversation_properties of this ViewFilter.
        :type: ConversationProperties
        """
        

        self._conversation_properties = conversation_properties

    @property
    def is_blind_transferred(self) -> bool:
        """
        Gets the is_blind_transferred of this ViewFilter.
        Indicates filtering for blind transferred

        :return: The is_blind_transferred of this ViewFilter.
        :rtype: bool
        """
        return self._is_blind_transferred

    @is_blind_transferred.setter
    def is_blind_transferred(self, is_blind_transferred: bool) -> None:
        """
        Sets the is_blind_transferred of this ViewFilter.
        Indicates filtering for blind transferred

        :param is_blind_transferred: The is_blind_transferred of this ViewFilter.
        :type: bool
        """
        

        self._is_blind_transferred = is_blind_transferred

    @property
    def is_consulted(self) -> bool:
        """
        Gets the is_consulted of this ViewFilter.
        Indicates filtering for consulted

        :return: The is_consulted of this ViewFilter.
        :rtype: bool
        """
        return self._is_consulted

    @is_consulted.setter
    def is_consulted(self, is_consulted: bool) -> None:
        """
        Sets the is_consulted of this ViewFilter.
        Indicates filtering for consulted

        :param is_consulted: The is_consulted of this ViewFilter.
        :type: bool
        """
        

        self._is_consulted = is_consulted

    @property
    def is_consult_transferred(self) -> bool:
        """
        Gets the is_consult_transferred of this ViewFilter.
        Indicates filtering for consult transferred

        :return: The is_consult_transferred of this ViewFilter.
        :rtype: bool
        """
        return self._is_consult_transferred

    @is_consult_transferred.setter
    def is_consult_transferred(self, is_consult_transferred: bool) -> None:
        """
        Sets the is_consult_transferred of this ViewFilter.
        Indicates filtering for consult transferred

        :param is_consult_transferred: The is_consult_transferred of this ViewFilter.
        :type: bool
        """
        

        self._is_consult_transferred = is_consult_transferred

    @property
    def remote_participants(self) -> List[str]:
        """
        Gets the remote_participants of this ViewFilter.
        The list of remote participants used to filter the view

        :return: The remote_participants of this ViewFilter.
        :rtype: list[str]
        """
        return self._remote_participants

    @remote_participants.setter
    def remote_participants(self, remote_participants: List[str]) -> None:
        """
        Sets the remote_participants of this ViewFilter.
        The list of remote participants used to filter the view

        :param remote_participants: The remote_participants of this ViewFilter.
        :type: list[str]
        """
        

        self._remote_participants = remote_participants

    @property
    def flow_ids(self) -> List[str]:
        """
        Gets the flow_ids of this ViewFilter.
        The list of flow Ids

        :return: The flow_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_ids

    @flow_ids.setter
    def flow_ids(self, flow_ids: List[str]) -> None:
        """
        Sets the flow_ids of this ViewFilter.
        The list of flow Ids

        :param flow_ids: The flow_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_ids = flow_ids

    @property
    def flow_outcome_ids(self) -> List[str]:
        """
        Gets the flow_outcome_ids of this ViewFilter.
        A list of outcome ids of the flow

        :return: The flow_outcome_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_outcome_ids

    @flow_outcome_ids.setter
    def flow_outcome_ids(self, flow_outcome_ids: List[str]) -> None:
        """
        Sets the flow_outcome_ids of this ViewFilter.
        A list of outcome ids of the flow

        :param flow_outcome_ids: The flow_outcome_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_outcome_ids = flow_outcome_ids

    @property
    def flow_outcome_values(self) -> List[str]:
        """
        Gets the flow_outcome_values of this ViewFilter.
        A list of outcome values of the flow

        :return: The flow_outcome_values of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_outcome_values

    @flow_outcome_values.setter
    def flow_outcome_values(self, flow_outcome_values: List[str]) -> None:
        """
        Sets the flow_outcome_values of this ViewFilter.
        A list of outcome values of the flow

        :param flow_outcome_values: The flow_outcome_values of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_outcome_values = flow_outcome_values

    @property
    def flow_destination_types(self) -> List[str]:
        """
        Gets the flow_destination_types of this ViewFilter.
        The list of destination types of the flow

        :return: The flow_destination_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_destination_types

    @flow_destination_types.setter
    def flow_destination_types(self, flow_destination_types: List[str]) -> None:
        """
        Sets the flow_destination_types of this ViewFilter.
        The list of destination types of the flow

        :param flow_destination_types: The flow_destination_types of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_destination_types = flow_destination_types

    @property
    def flow_disconnect_reasons(self) -> List[str]:
        """
        Gets the flow_disconnect_reasons of this ViewFilter.
        The list of reasons for the flow to disconnect

        :return: The flow_disconnect_reasons of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_disconnect_reasons

    @flow_disconnect_reasons.setter
    def flow_disconnect_reasons(self, flow_disconnect_reasons: List[str]) -> None:
        """
        Sets the flow_disconnect_reasons of this ViewFilter.
        The list of reasons for the flow to disconnect

        :param flow_disconnect_reasons: The flow_disconnect_reasons of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_disconnect_reasons = flow_disconnect_reasons

    @property
    def flow_types(self) -> List[str]:
        """
        Gets the flow_types of this ViewFilter.
        A list of types of the flow

        :return: The flow_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_types

    @flow_types.setter
    def flow_types(self, flow_types: List[str]) -> None:
        """
        Sets the flow_types of this ViewFilter.
        A list of types of the flow

        :param flow_types: The flow_types of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_types = flow_types

    @property
    def flow_entry_types(self) -> List[str]:
        """
        Gets the flow_entry_types of this ViewFilter.
        A list of types of the flow entry

        :return: The flow_entry_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_entry_types

    @flow_entry_types.setter
    def flow_entry_types(self, flow_entry_types: List[str]) -> None:
        """
        Sets the flow_entry_types of this ViewFilter.
        A list of types of the flow entry

        :param flow_entry_types: The flow_entry_types of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_entry_types = flow_entry_types

    @property
    def flow_entry_reasons(self) -> List[str]:
        """
        Gets the flow_entry_reasons of this ViewFilter.
        A list of reasons of flow entry

        :return: The flow_entry_reasons of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_entry_reasons

    @flow_entry_reasons.setter
    def flow_entry_reasons(self, flow_entry_reasons: List[str]) -> None:
        """
        Sets the flow_entry_reasons of this ViewFilter.
        A list of reasons of flow entry

        :param flow_entry_reasons: The flow_entry_reasons of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_entry_reasons = flow_entry_reasons

    @property
    def flow_versions(self) -> List[str]:
        """
        Gets the flow_versions of this ViewFilter.
        A list of versions of a flow

        :return: The flow_versions of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_versions

    @flow_versions.setter
    def flow_versions(self, flow_versions: List[str]) -> None:
        """
        Sets the flow_versions of this ViewFilter.
        A list of versions of a flow

        :param flow_versions: The flow_versions of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_versions = flow_versions

    @property
    def group_ids(self) -> List[str]:
        """
        Gets the group_ids of this ViewFilter.
        A list of directory group ids

        :return: The group_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._group_ids

    @group_ids.setter
    def group_ids(self, group_ids: List[str]) -> None:
        """
        Sets the group_ids of this ViewFilter.
        A list of directory group ids

        :param group_ids: The group_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._group_ids = group_ids

    @property
    def has_journey_customer_id(self) -> bool:
        """
        Gets the has_journey_customer_id of this ViewFilter.
        Indicates filtering for journey customer id

        :return: The has_journey_customer_id of this ViewFilter.
        :rtype: bool
        """
        return self._has_journey_customer_id

    @has_journey_customer_id.setter
    def has_journey_customer_id(self, has_journey_customer_id: bool) -> None:
        """
        Sets the has_journey_customer_id of this ViewFilter.
        Indicates filtering for journey customer id

        :param has_journey_customer_id: The has_journey_customer_id of this ViewFilter.
        :type: bool
        """
        

        self._has_journey_customer_id = has_journey_customer_id

    @property
    def has_journey_action_map_id(self) -> bool:
        """
        Gets the has_journey_action_map_id of this ViewFilter.
        Indicates filtering for Journey action map id

        :return: The has_journey_action_map_id of this ViewFilter.
        :rtype: bool
        """
        return self._has_journey_action_map_id

    @has_journey_action_map_id.setter
    def has_journey_action_map_id(self, has_journey_action_map_id: bool) -> None:
        """
        Sets the has_journey_action_map_id of this ViewFilter.
        Indicates filtering for Journey action map id

        :param has_journey_action_map_id: The has_journey_action_map_id of this ViewFilter.
        :type: bool
        """
        

        self._has_journey_action_map_id = has_journey_action_map_id

    @property
    def has_journey_visit_id(self) -> bool:
        """
        Gets the has_journey_visit_id of this ViewFilter.
        Indicates filtering for Journey visit id

        :return: The has_journey_visit_id of this ViewFilter.
        :rtype: bool
        """
        return self._has_journey_visit_id

    @has_journey_visit_id.setter
    def has_journey_visit_id(self, has_journey_visit_id: bool) -> None:
        """
        Sets the has_journey_visit_id of this ViewFilter.
        Indicates filtering for Journey visit id

        :param has_journey_visit_id: The has_journey_visit_id of this ViewFilter.
        :type: bool
        """
        

        self._has_journey_visit_id = has_journey_visit_id

    @property
    def has_media(self) -> bool:
        """
        Gets the has_media of this ViewFilter.
        Indicates filtering for presence of MMS media

        :return: The has_media of this ViewFilter.
        :rtype: bool
        """
        return self._has_media

    @has_media.setter
    def has_media(self, has_media: bool) -> None:
        """
        Sets the has_media of this ViewFilter.
        Indicates filtering for presence of MMS media

        :param has_media: The has_media of this ViewFilter.
        :type: bool
        """
        

        self._has_media = has_media

    @property
    def role_ids(self) -> List[str]:
        """
        Gets the role_ids of this ViewFilter.
        The role Ids used to filter the view

        :return: The role_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._role_ids

    @role_ids.setter
    def role_ids(self, role_ids: List[str]) -> None:
        """
        Sets the role_ids of this ViewFilter.
        The role Ids used to filter the view

        :param role_ids: The role_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._role_ids = role_ids

    @property
    def reports_tos(self) -> List[str]:
        """
        Gets the reports_tos of this ViewFilter.
        The report to user IDs used to filter the view

        :return: The reports_tos of this ViewFilter.
        :rtype: list[str]
        """
        return self._reports_tos

    @reports_tos.setter
    def reports_tos(self, reports_tos: List[str]) -> None:
        """
        Sets the reports_tos of this ViewFilter.
        The report to user IDs used to filter the view

        :param reports_tos: The reports_tos of this ViewFilter.
        :type: list[str]
        """
        

        self._reports_tos = reports_tos

    @property
    def location_ids(self) -> List[str]:
        """
        Gets the location_ids of this ViewFilter.
        The location Ids used to filter the view

        :return: The location_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._location_ids

    @location_ids.setter
    def location_ids(self, location_ids: List[str]) -> None:
        """
        Sets the location_ids of this ViewFilter.
        The location Ids used to filter the view

        :param location_ids: The location_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._location_ids = location_ids

    @property
    def flow_out_types(self) -> List[str]:
        """
        Gets the flow_out_types of this ViewFilter.
        A list of flow out types

        :return: The flow_out_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_out_types

    @flow_out_types.setter
    def flow_out_types(self, flow_out_types: List[str]) -> None:
        """
        Sets the flow_out_types of this ViewFilter.
        A list of flow out types

        :param flow_out_types: The flow_out_types of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_out_types = flow_out_types

    @property
    def provider_list(self) -> List[str]:
        """
        Gets the provider_list of this ViewFilter.
        A list of providers

        :return: The provider_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._provider_list

    @provider_list.setter
    def provider_list(self, provider_list: List[str]) -> None:
        """
        Sets the provider_list of this ViewFilter.
        A list of providers

        :param provider_list: The provider_list of this ViewFilter.
        :type: list[str]
        """
        

        self._provider_list = provider_list

    @property
    def callback_number_list(self) -> List[str]:
        """
        Gets the callback_number_list of this ViewFilter.
        A list of callback numbers or substrings of numbers (ex: [\"317\", \"13172222222\"])

        :return: The callback_number_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._callback_number_list

    @callback_number_list.setter
    def callback_number_list(self, callback_number_list: List[str]) -> None:
        """
        Sets the callback_number_list of this ViewFilter.
        A list of callback numbers or substrings of numbers (ex: [\"317\", \"13172222222\"])

        :param callback_number_list: The callback_number_list of this ViewFilter.
        :type: list[str]
        """
        

        self._callback_number_list = callback_number_list

    @property
    def callback_interval(self) -> str:
        """
        Gets the callback_interval of this ViewFilter.
        An interval of time to filter for scheduled callbacks. Intervals are represented as an ISO-8601 string. For example: YYYY-MM-DDThh:mm:ss/YYYY-MM-DDThh:mm:ss

        :return: The callback_interval of this ViewFilter.
        :rtype: str
        """
        return self._callback_interval

    @callback_interval.setter
    def callback_interval(self, callback_interval: str) -> None:
        """
        Sets the callback_interval of this ViewFilter.
        An interval of time to filter for scheduled callbacks. Intervals are represented as an ISO-8601 string. For example: YYYY-MM-DDThh:mm:ss/YYYY-MM-DDThh:mm:ss

        :param callback_interval: The callback_interval of this ViewFilter.
        :type: str
        """
        

        self._callback_interval = callback_interval

    @property
    def used_routing_types(self) -> List[str]:
        """
        Gets the used_routing_types of this ViewFilter.
        A list of routing types used

        :return: The used_routing_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._used_routing_types

    @used_routing_types.setter
    def used_routing_types(self, used_routing_types: List[str]) -> None:
        """
        Sets the used_routing_types of this ViewFilter.
        A list of routing types used

        :param used_routing_types: The used_routing_types of this ViewFilter.
        :type: list[str]
        """
        

        self._used_routing_types = used_routing_types

    @property
    def requested_routing_types(self) -> List[str]:
        """
        Gets the requested_routing_types of this ViewFilter.
        A list of routing types requested

        :return: The requested_routing_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._requested_routing_types

    @requested_routing_types.setter
    def requested_routing_types(self, requested_routing_types: List[str]) -> None:
        """
        Sets the requested_routing_types of this ViewFilter.
        A list of routing types requested

        :param requested_routing_types: The requested_routing_types of this ViewFilter.
        :type: list[str]
        """
        

        self._requested_routing_types = requested_routing_types

    @property
    def has_agent_assist_id(self) -> bool:
        """
        Gets the has_agent_assist_id of this ViewFilter.
        Indicates filtering for agent assist id

        :return: The has_agent_assist_id of this ViewFilter.
        :rtype: bool
        """
        return self._has_agent_assist_id

    @has_agent_assist_id.setter
    def has_agent_assist_id(self, has_agent_assist_id: bool) -> None:
        """
        Sets the has_agent_assist_id of this ViewFilter.
        Indicates filtering for agent assist id

        :param has_agent_assist_id: The has_agent_assist_id of this ViewFilter.
        :type: bool
        """
        

        self._has_agent_assist_id = has_agent_assist_id

    @property
    def transcripts(self) -> List['Transcripts']:
        """
        Gets the transcripts of this ViewFilter.
        A list of transcript contents requested

        :return: The transcripts of this ViewFilter.
        :rtype: list[Transcripts]
        """
        return self._transcripts

    @transcripts.setter
    def transcripts(self, transcripts: List['Transcripts']) -> None:
        """
        Sets the transcripts of this ViewFilter.
        A list of transcript contents requested

        :param transcripts: The transcripts of this ViewFilter.
        :type: list[Transcripts]
        """
        

        self._transcripts = transcripts

    @property
    def transcript_languages(self) -> List[str]:
        """
        Gets the transcript_languages of this ViewFilter.
        A list of transcript languages requested

        :return: The transcript_languages of this ViewFilter.
        :rtype: list[str]
        """
        return self._transcript_languages

    @transcript_languages.setter
    def transcript_languages(self, transcript_languages: List[str]) -> None:
        """
        Sets the transcript_languages of this ViewFilter.
        A list of transcript languages requested

        :param transcript_languages: The transcript_languages of this ViewFilter.
        :type: list[str]
        """
        

        self._transcript_languages = transcript_languages

    @property
    def participant_purposes(self) -> List[str]:
        """
        Gets the participant_purposes of this ViewFilter.
        A list of participant purpose requested

        :return: The participant_purposes of this ViewFilter.
        :rtype: list[str]
        """
        return self._participant_purposes

    @participant_purposes.setter
    def participant_purposes(self, participant_purposes: List[str]) -> None:
        """
        Sets the participant_purposes of this ViewFilter.
        A list of participant purpose requested

        :param participant_purposes: The participant_purposes of this ViewFilter.
        :type: list[str]
        """
        

        self._participant_purposes = participant_purposes

    @property
    def show_first_queue(self) -> bool:
        """
        Gets the show_first_queue of this ViewFilter.
        Indicates filtering for first queue data

        :return: The show_first_queue of this ViewFilter.
        :rtype: bool
        """
        return self._show_first_queue

    @show_first_queue.setter
    def show_first_queue(self, show_first_queue: bool) -> None:
        """
        Sets the show_first_queue of this ViewFilter.
        Indicates filtering for first queue data

        :param show_first_queue: The show_first_queue of this ViewFilter.
        :type: bool
        """
        

        self._show_first_queue = show_first_queue

    @property
    def team_ids(self) -> List[str]:
        """
        Gets the team_ids of this ViewFilter.
        The team ids used to filter the view data

        :return: The team_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._team_ids

    @team_ids.setter
    def team_ids(self, team_ids: List[str]) -> None:
        """
        Sets the team_ids of this ViewFilter.
        The team ids used to filter the view data

        :param team_ids: The team_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._team_ids = team_ids

    @property
    def filter_users_by_team_ids(self) -> List[str]:
        """
        Gets the filter_users_by_team_ids of this ViewFilter.
        The team ids are used to fetch associated users for the view

        :return: The filter_users_by_team_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._filter_users_by_team_ids

    @filter_users_by_team_ids.setter
    def filter_users_by_team_ids(self, filter_users_by_team_ids: List[str]) -> None:
        """
        Sets the filter_users_by_team_ids of this ViewFilter.
        The team ids are used to fetch associated users for the view

        :param filter_users_by_team_ids: The filter_users_by_team_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._filter_users_by_team_ids = filter_users_by_team_ids

    @property
    def journey_action_map_ids(self) -> List[str]:
        """
        Gets the journey_action_map_ids of this ViewFilter.
        The journey action map ids are used to fetch action maps for the associated view

        :return: The journey_action_map_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_action_map_ids

    @journey_action_map_ids.setter
    def journey_action_map_ids(self, journey_action_map_ids: List[str]) -> None:
        """
        Sets the journey_action_map_ids of this ViewFilter.
        The journey action map ids are used to fetch action maps for the associated view

        :param journey_action_map_ids: The journey_action_map_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_action_map_ids = journey_action_map_ids

    @property
    def journey_outcome_ids(self) -> List[str]:
        """
        Gets the journey_outcome_ids of this ViewFilter.
        The journey outcome ids are used to fetch outcomes for the associated view

        :return: The journey_outcome_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_outcome_ids

    @journey_outcome_ids.setter
    def journey_outcome_ids(self, journey_outcome_ids: List[str]) -> None:
        """
        Sets the journey_outcome_ids of this ViewFilter.
        The journey outcome ids are used to fetch outcomes for the associated view

        :param journey_outcome_ids: The journey_outcome_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_outcome_ids = journey_outcome_ids

    @property
    def journey_segment_ids(self) -> List[str]:
        """
        Gets the journey_segment_ids of this ViewFilter.
        The journey segment ids are used to fetch segments for the associated view

        :return: The journey_segment_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_segment_ids

    @journey_segment_ids.setter
    def journey_segment_ids(self, journey_segment_ids: List[str]) -> None:
        """
        Sets the journey_segment_ids of this ViewFilter.
        The journey segment ids are used to fetch segments for the associated view

        :param journey_segment_ids: The journey_segment_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_segment_ids = journey_segment_ids

    @property
    def journey_action_map_types(self) -> List[str]:
        """
        Gets the journey_action_map_types of this ViewFilter.
        The journey action map types are used to filter action map data for the associated view

        :return: The journey_action_map_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_action_map_types

    @journey_action_map_types.setter
    def journey_action_map_types(self, journey_action_map_types: List[str]) -> None:
        """
        Sets the journey_action_map_types of this ViewFilter.
        The journey action map types are used to filter action map data for the associated view

        :param journey_action_map_types: The journey_action_map_types of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_action_map_types = journey_action_map_types

    @property
    def development_role_list(self) -> List[str]:
        """
        Gets the development_role_list of this ViewFilter.
        The list of development roles used to filter agent development view

        :return: The development_role_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._development_role_list

    @development_role_list.setter
    def development_role_list(self, development_role_list: List[str]) -> None:
        """
        Sets the development_role_list of this ViewFilter.
        The list of development roles used to filter agent development view

        :param development_role_list: The development_role_list of this ViewFilter.
        :type: list[str]
        """
        

        self._development_role_list = development_role_list

    @property
    def development_type_list(self) -> List[str]:
        """
        Gets the development_type_list of this ViewFilter.
        The list of development types used to filter agent development view

        :return: The development_type_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._development_type_list

    @development_type_list.setter
    def development_type_list(self, development_type_list: List[str]) -> None:
        """
        Sets the development_type_list of this ViewFilter.
        The list of development types used to filter agent development view

        :param development_type_list: The development_type_list of this ViewFilter.
        :type: list[str]
        """
        

        self._development_type_list = development_type_list

    @property
    def development_status_list(self) -> List[str]:
        """
        Gets the development_status_list of this ViewFilter.
        The list of development status used to filter agent development view

        :return: The development_status_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._development_status_list

    @development_status_list.setter
    def development_status_list(self, development_status_list: List[str]) -> None:
        """
        Sets the development_status_list of this ViewFilter.
        The list of development status used to filter agent development view

        :param development_status_list: The development_status_list of this ViewFilter.
        :type: list[str]
        """
        

        self._development_status_list = development_status_list

    @property
    def development_module_ids(self) -> List[str]:
        """
        Gets the development_module_ids of this ViewFilter.
        The list of development moduleIds used to filter agent development view

        :return: The development_module_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._development_module_ids

    @development_module_ids.setter
    def development_module_ids(self, development_module_ids: List[str]) -> None:
        """
        Sets the development_module_ids of this ViewFilter.
        The list of development moduleIds used to filter agent development view

        :param development_module_ids: The development_module_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._development_module_ids = development_module_ids

    @property
    def development_activity_overdue(self) -> bool:
        """
        Gets the development_activity_overdue of this ViewFilter.
        Indicates filtering for development activities

        :return: The development_activity_overdue of this ViewFilter.
        :rtype: bool
        """
        return self._development_activity_overdue

    @development_activity_overdue.setter
    def development_activity_overdue(self, development_activity_overdue: bool) -> None:
        """
        Sets the development_activity_overdue of this ViewFilter.
        Indicates filtering for development activities

        :param development_activity_overdue: The development_activity_overdue of this ViewFilter.
        :type: bool
        """
        

        self._development_activity_overdue = development_activity_overdue

    @property
    def customer_sentiment_score(self) -> 'NumericRange':
        """
        Gets the customer_sentiment_score of this ViewFilter.
        The customer sentiment score used to filter the view

        :return: The customer_sentiment_score of this ViewFilter.
        :rtype: NumericRange
        """
        return self._customer_sentiment_score

    @customer_sentiment_score.setter
    def customer_sentiment_score(self, customer_sentiment_score: 'NumericRange') -> None:
        """
        Sets the customer_sentiment_score of this ViewFilter.
        The customer sentiment score used to filter the view

        :param customer_sentiment_score: The customer_sentiment_score of this ViewFilter.
        :type: NumericRange
        """
        

        self._customer_sentiment_score = customer_sentiment_score

    @property
    def customer_sentiment_trend(self) -> 'NumericRange':
        """
        Gets the customer_sentiment_trend of this ViewFilter.
        The customer sentiment trend used to filter the view

        :return: The customer_sentiment_trend of this ViewFilter.
        :rtype: NumericRange
        """
        return self._customer_sentiment_trend

    @customer_sentiment_trend.setter
    def customer_sentiment_trend(self, customer_sentiment_trend: 'NumericRange') -> None:
        """
        Sets the customer_sentiment_trend of this ViewFilter.
        The customer sentiment trend used to filter the view

        :param customer_sentiment_trend: The customer_sentiment_trend of this ViewFilter.
        :type: NumericRange
        """
        

        self._customer_sentiment_trend = customer_sentiment_trend

    @property
    def flow_transfer_targets(self) -> List[str]:
        """
        Gets the flow_transfer_targets of this ViewFilter.
        The list of transfer targets used to filter flow data

        :return: The flow_transfer_targets of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_transfer_targets

    @flow_transfer_targets.setter
    def flow_transfer_targets(self, flow_transfer_targets: List[str]) -> None:
        """
        Sets the flow_transfer_targets of this ViewFilter.
        The list of transfer targets used to filter flow data

        :param flow_transfer_targets: The flow_transfer_targets of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_transfer_targets = flow_transfer_targets

    @property
    def development_name(self) -> str:
        """
        Gets the development_name of this ViewFilter.
        Filter for development name

        :return: The development_name of this ViewFilter.
        :rtype: str
        """
        return self._development_name

    @development_name.setter
    def development_name(self, development_name: str) -> None:
        """
        Sets the development_name of this ViewFilter.
        Filter for development name

        :param development_name: The development_name of this ViewFilter.
        :type: str
        """
        

        self._development_name = development_name

    @property
    def topic_ids(self) -> List[str]:
        """
        Gets the topic_ids of this ViewFilter.
        Represents the topics detected in the transcript

        :return: The topic_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._topic_ids

    @topic_ids.setter
    def topic_ids(self, topic_ids: List[str]) -> None:
        """
        Sets the topic_ids of this ViewFilter.
        Represents the topics detected in the transcript

        :param topic_ids: The topic_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._topic_ids = topic_ids

    @property
    def external_tags(self) -> List[str]:
        """
        Gets the external_tags of this ViewFilter.
        The list of external Tags used to filter conversation data

        :return: The external_tags of this ViewFilter.
        :rtype: list[str]
        """
        return self._external_tags

    @external_tags.setter
    def external_tags(self, external_tags: List[str]) -> None:
        """
        Sets the external_tags of this ViewFilter.
        The list of external Tags used to filter conversation data

        :param external_tags: The external_tags of this ViewFilter.
        :type: list[str]
        """
        

        self._external_tags = external_tags

    @property
    def is_not_responding(self) -> bool:
        """
        Gets the is_not_responding of this ViewFilter.
        Indicates filtering for not responding users

        :return: The is_not_responding of this ViewFilter.
        :rtype: bool
        """
        return self._is_not_responding

    @is_not_responding.setter
    def is_not_responding(self, is_not_responding: bool) -> None:
        """
        Sets the is_not_responding of this ViewFilter.
        Indicates filtering for not responding users

        :param is_not_responding: The is_not_responding of this ViewFilter.
        :type: bool
        """
        

        self._is_not_responding = is_not_responding

    @property
    def is_authenticated(self) -> bool:
        """
        Gets the is_authenticated of this ViewFilter.
        Indicates filtering for the authenticated chat

        :return: The is_authenticated of this ViewFilter.
        :rtype: bool
        """
        return self._is_authenticated

    @is_authenticated.setter
    def is_authenticated(self, is_authenticated: bool) -> None:
        """
        Sets the is_authenticated of this ViewFilter.
        Indicates filtering for the authenticated chat

        :param is_authenticated: The is_authenticated of this ViewFilter.
        :type: bool
        """
        

        self._is_authenticated = is_authenticated

    @property
    def bot_ids(self) -> List[str]:
        """
        Gets the bot_ids of this ViewFilter.
        The list of bot IDs used to filter bot views

        :return: The bot_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_ids

    @bot_ids.setter
    def bot_ids(self, bot_ids: List[str]) -> None:
        """
        Sets the bot_ids of this ViewFilter.
        The list of bot IDs used to filter bot views

        :param bot_ids: The bot_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_ids = bot_ids

    @property
    def bot_versions(self) -> List[str]:
        """
        Gets the bot_versions of this ViewFilter.
        The list of bot versions used to filter bot views

        :return: The bot_versions of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_versions

    @bot_versions.setter
    def bot_versions(self, bot_versions: List[str]) -> None:
        """
        Sets the bot_versions of this ViewFilter.
        The list of bot versions used to filter bot views

        :param bot_versions: The bot_versions of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_versions = bot_versions

    @property
    def bot_message_types(self) -> List[str]:
        """
        Gets the bot_message_types of this ViewFilter.
        The list of bot message types used to filter bot views

        :return: The bot_message_types of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_message_types

    @bot_message_types.setter
    def bot_message_types(self, bot_message_types: List[str]) -> None:
        """
        Sets the bot_message_types of this ViewFilter.
        The list of bot message types used to filter bot views

        :param bot_message_types: The bot_message_types of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_message_types = bot_message_types

    @property
    def bot_provider_list(self) -> List[str]:
        """
        Gets the bot_provider_list of this ViewFilter.
        The list of bot providers used to filter bot views

        :return: The bot_provider_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_provider_list

    @bot_provider_list.setter
    def bot_provider_list(self, bot_provider_list: List[str]) -> None:
        """
        Sets the bot_provider_list of this ViewFilter.
        The list of bot providers used to filter bot views

        :param bot_provider_list: The bot_provider_list of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_provider_list = bot_provider_list

    @property
    def bot_product_list(self) -> List[str]:
        """
        Gets the bot_product_list of this ViewFilter.
        The list of bot products used to filter bot views

        :return: The bot_product_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_product_list

    @bot_product_list.setter
    def bot_product_list(self, bot_product_list: List[str]) -> None:
        """
        Sets the bot_product_list of this ViewFilter.
        The list of bot products used to filter bot views

        :param bot_product_list: The bot_product_list of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_product_list = bot_product_list

    @property
    def bot_recognition_failure_reason_list(self) -> List[str]:
        """
        Gets the bot_recognition_failure_reason_list of this ViewFilter.
        The list of bot recognition failure reasons used to filter bot views

        :return: The bot_recognition_failure_reason_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_recognition_failure_reason_list

    @bot_recognition_failure_reason_list.setter
    def bot_recognition_failure_reason_list(self, bot_recognition_failure_reason_list: List[str]) -> None:
        """
        Sets the bot_recognition_failure_reason_list of this ViewFilter.
        The list of bot recognition failure reasons used to filter bot views

        :param bot_recognition_failure_reason_list: The bot_recognition_failure_reason_list of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_recognition_failure_reason_list = bot_recognition_failure_reason_list

    @property
    def bot_intent_list(self) -> List[str]:
        """
        Gets the bot_intent_list of this ViewFilter.
        The list of bot intents used to filter bot views

        :return: The bot_intent_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_intent_list

    @bot_intent_list.setter
    def bot_intent_list(self, bot_intent_list: List[str]) -> None:
        """
        Sets the bot_intent_list of this ViewFilter.
        The list of bot intents used to filter bot views

        :param bot_intent_list: The bot_intent_list of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_intent_list = bot_intent_list

    @property
    def bot_final_intent_list(self) -> List[str]:
        """
        Gets the bot_final_intent_list of this ViewFilter.
        The list of bot final intents used to filter bot views

        :return: The bot_final_intent_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_final_intent_list

    @bot_final_intent_list.setter
    def bot_final_intent_list(self, bot_final_intent_list: List[str]) -> None:
        """
        Sets the bot_final_intent_list of this ViewFilter.
        The list of bot final intents used to filter bot views

        :param bot_final_intent_list: The bot_final_intent_list of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_final_intent_list = bot_final_intent_list

    @property
    def bot_slot_list(self) -> List[str]:
        """
        Gets the bot_slot_list of this ViewFilter.
        The list of bot slots used to filter bot views

        :return: The bot_slot_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_slot_list

    @bot_slot_list.setter
    def bot_slot_list(self, bot_slot_list: List[str]) -> None:
        """
        Sets the bot_slot_list of this ViewFilter.
        The list of bot slots used to filter bot views

        :param bot_slot_list: The bot_slot_list of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_slot_list = bot_slot_list

    @property
    def bot_result_list(self) -> List[str]:
        """
        Gets the bot_result_list of this ViewFilter.
        The list of bot results used to filter bot views

        :return: The bot_result_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._bot_result_list

    @bot_result_list.setter
    def bot_result_list(self, bot_result_list: List[str]) -> None:
        """
        Sets the bot_result_list of this ViewFilter.
        The list of bot results used to filter bot views

        :param bot_result_list: The bot_result_list of this ViewFilter.
        :type: list[str]
        """
        

        self._bot_result_list = bot_result_list

    @property
    def blocked_reasons(self) -> List[str]:
        """
        Gets the blocked_reasons of this ViewFilter.
        The list of blocked reason used to filter action map constraints views

        :return: The blocked_reasons of this ViewFilter.
        :rtype: list[str]
        """
        return self._blocked_reasons

    @blocked_reasons.setter
    def blocked_reasons(self, blocked_reasons: List[str]) -> None:
        """
        Sets the blocked_reasons of this ViewFilter.
        The list of blocked reason used to filter action map constraints views

        :param blocked_reasons: The blocked_reasons of this ViewFilter.
        :type: list[str]
        """
        

        self._blocked_reasons = blocked_reasons

    @property
    def is_recorded(self) -> bool:
        """
        Gets the is_recorded of this ViewFilter.
        Indicates filtering for recorded

        :return: The is_recorded of this ViewFilter.
        :rtype: bool
        """
        return self._is_recorded

    @is_recorded.setter
    def is_recorded(self, is_recorded: bool) -> None:
        """
        Sets the is_recorded of this ViewFilter.
        Indicates filtering for recorded

        :param is_recorded: The is_recorded of this ViewFilter.
        :type: bool
        """
        

        self._is_recorded = is_recorded

    @property
    def has_evaluation(self) -> bool:
        """
        Gets the has_evaluation of this ViewFilter.
        Indicates filtering for evaluation

        :return: The has_evaluation of this ViewFilter.
        :rtype: bool
        """
        return self._has_evaluation

    @has_evaluation.setter
    def has_evaluation(self, has_evaluation: bool) -> None:
        """
        Sets the has_evaluation of this ViewFilter.
        Indicates filtering for evaluation

        :param has_evaluation: The has_evaluation of this ViewFilter.
        :type: bool
        """
        

        self._has_evaluation = has_evaluation

    @property
    def has_scored_evaluation(self) -> bool:
        """
        Gets the has_scored_evaluation of this ViewFilter.
        Indicates filtering for scored evaluation

        :return: The has_scored_evaluation of this ViewFilter.
        :rtype: bool
        """
        return self._has_scored_evaluation

    @has_scored_evaluation.setter
    def has_scored_evaluation(self, has_scored_evaluation: bool) -> None:
        """
        Sets the has_scored_evaluation of this ViewFilter.
        Indicates filtering for scored evaluation

        :param has_scored_evaluation: The has_scored_evaluation of this ViewFilter.
        :type: bool
        """
        

        self._has_scored_evaluation = has_scored_evaluation

    @property
    def email_delivery_status_list(self) -> List[str]:
        """
        Gets the email_delivery_status_list of this ViewFilter.
        The list of email delivery statuses used to filter views

        :return: The email_delivery_status_list of this ViewFilter.
        :rtype: list[str]
        """
        return self._email_delivery_status_list

    @email_delivery_status_list.setter
    def email_delivery_status_list(self, email_delivery_status_list: List[str]) -> None:
        """
        Sets the email_delivery_status_list of this ViewFilter.
        The list of email delivery statuses used to filter views

        :param email_delivery_status_list: The email_delivery_status_list of this ViewFilter.
        :type: list[str]
        """
        

        self._email_delivery_status_list = email_delivery_status_list

    @property
    def is_agent_owned_callback(self) -> bool:
        """
        Gets the is_agent_owned_callback of this ViewFilter.
        Indicates filtering for agent owned callback interactions

        :return: The is_agent_owned_callback of this ViewFilter.
        :rtype: bool
        """
        return self._is_agent_owned_callback

    @is_agent_owned_callback.setter
    def is_agent_owned_callback(self, is_agent_owned_callback: bool) -> None:
        """
        Sets the is_agent_owned_callback of this ViewFilter.
        Indicates filtering for agent owned callback interactions

        :param is_agent_owned_callback: The is_agent_owned_callback of this ViewFilter.
        :type: bool
        """
        

        self._is_agent_owned_callback = is_agent_owned_callback

    @property
    def agent_callback_owner_ids(self) -> List[str]:
        """
        Gets the agent_callback_owner_ids of this ViewFilter.
        The list of callback owners used to filter interactions

        :return: The agent_callback_owner_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._agent_callback_owner_ids

    @agent_callback_owner_ids.setter
    def agent_callback_owner_ids(self, agent_callback_owner_ids: List[str]) -> None:
        """
        Sets the agent_callback_owner_ids of this ViewFilter.
        The list of callback owners used to filter interactions

        :param agent_callback_owner_ids: The agent_callback_owner_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._agent_callback_owner_ids = agent_callback_owner_ids

    @property
    def transcript_topics(self) -> List['TranscriptTopics']:
        """
        Gets the transcript_topics of this ViewFilter.
        The list of transcript topics requested in filter

        :return: The transcript_topics of this ViewFilter.
        :rtype: list[TranscriptTopics]
        """
        return self._transcript_topics

    @transcript_topics.setter
    def transcript_topics(self, transcript_topics: List['TranscriptTopics']) -> None:
        """
        Sets the transcript_topics of this ViewFilter.
        The list of transcript topics requested in filter

        :param transcript_topics: The transcript_topics of this ViewFilter.
        :type: list[TranscriptTopics]
        """
        

        self._transcript_topics = transcript_topics

    @property
    def journey_frequency_cap_reasons(self) -> List[str]:
        """
        Gets the journey_frequency_cap_reasons of this ViewFilter.
        The list of frequency cap reasons to filter offer constraints

        :return: The journey_frequency_cap_reasons of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_frequency_cap_reasons

    @journey_frequency_cap_reasons.setter
    def journey_frequency_cap_reasons(self, journey_frequency_cap_reasons: List[str]) -> None:
        """
        Sets the journey_frequency_cap_reasons of this ViewFilter.
        The list of frequency cap reasons to filter offer constraints

        :param journey_frequency_cap_reasons: The journey_frequency_cap_reasons of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_frequency_cap_reasons = journey_frequency_cap_reasons

    @property
    def journey_blocking_action_map_ids(self) -> List[str]:
        """
        Gets the journey_blocking_action_map_ids of this ViewFilter.
        The list of blocking action maps to filter offer constraints

        :return: The journey_blocking_action_map_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_blocking_action_map_ids

    @journey_blocking_action_map_ids.setter
    def journey_blocking_action_map_ids(self, journey_blocking_action_map_ids: List[str]) -> None:
        """
        Sets the journey_blocking_action_map_ids of this ViewFilter.
        The list of blocking action maps to filter offer constraints

        :param journey_blocking_action_map_ids: The journey_blocking_action_map_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_blocking_action_map_ids = journey_blocking_action_map_ids

    @property
    def journey_action_target_ids(self) -> List[str]:
        """
        Gets the journey_action_target_ids of this ViewFilter.
        The list of action targets to filter offer constraints

        :return: The journey_action_target_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_action_target_ids

    @journey_action_target_ids.setter
    def journey_action_target_ids(self, journey_action_target_ids: List[str]) -> None:
        """
        Sets the journey_action_target_ids of this ViewFilter.
        The list of action targets to filter offer constraints

        :param journey_action_target_ids: The journey_action_target_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_action_target_ids = journey_action_target_ids

    @property
    def journey_blocking_schedule_group_ids(self) -> List[str]:
        """
        Gets the journey_blocking_schedule_group_ids of this ViewFilter.
        The list of blocking schedule groups to filter offer constraints

        :return: The journey_blocking_schedule_group_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_blocking_schedule_group_ids

    @journey_blocking_schedule_group_ids.setter
    def journey_blocking_schedule_group_ids(self, journey_blocking_schedule_group_ids: List[str]) -> None:
        """
        Sets the journey_blocking_schedule_group_ids of this ViewFilter.
        The list of blocking schedule groups to filter offer constraints

        :param journey_blocking_schedule_group_ids: The journey_blocking_schedule_group_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_blocking_schedule_group_ids = journey_blocking_schedule_group_ids

    @property
    def journey_blocking_emergency_schedule_group_ids(self) -> List[str]:
        """
        Gets the journey_blocking_emergency_schedule_group_ids of this ViewFilter.
        The list of emergency schedule groups to filter offer constraints

        :return: The journey_blocking_emergency_schedule_group_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_blocking_emergency_schedule_group_ids

    @journey_blocking_emergency_schedule_group_ids.setter
    def journey_blocking_emergency_schedule_group_ids(self, journey_blocking_emergency_schedule_group_ids: List[str]) -> None:
        """
        Sets the journey_blocking_emergency_schedule_group_ids of this ViewFilter.
        The list of emergency schedule groups to filter offer constraints

        :param journey_blocking_emergency_schedule_group_ids: The journey_blocking_emergency_schedule_group_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_blocking_emergency_schedule_group_ids = journey_blocking_emergency_schedule_group_ids

    @property
    def journey_url_equal_conditions(self) -> List[str]:
        """
        Gets the journey_url_equal_conditions of this ViewFilter.
        The list of url equal conditions to filter offer constraints

        :return: The journey_url_equal_conditions of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_url_equal_conditions

    @journey_url_equal_conditions.setter
    def journey_url_equal_conditions(self, journey_url_equal_conditions: List[str]) -> None:
        """
        Sets the journey_url_equal_conditions of this ViewFilter.
        The list of url equal conditions to filter offer constraints

        :param journey_url_equal_conditions: The journey_url_equal_conditions of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_url_equal_conditions = journey_url_equal_conditions

    @property
    def journey_url_not_equal_conditions(self) -> List[str]:
        """
        Gets the journey_url_not_equal_conditions of this ViewFilter.
        The list of url not equal conditions to filter offer constraints

        :return: The journey_url_not_equal_conditions of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_url_not_equal_conditions

    @journey_url_not_equal_conditions.setter
    def journey_url_not_equal_conditions(self, journey_url_not_equal_conditions: List[str]) -> None:
        """
        Sets the journey_url_not_equal_conditions of this ViewFilter.
        The list of url not equal conditions to filter offer constraints

        :param journey_url_not_equal_conditions: The journey_url_not_equal_conditions of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_url_not_equal_conditions = journey_url_not_equal_conditions

    @property
    def journey_url_starts_with_conditions(self) -> List[str]:
        """
        Gets the journey_url_starts_with_conditions of this ViewFilter.
        The list of url starts with conditions to filter offer constraints

        :return: The journey_url_starts_with_conditions of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_url_starts_with_conditions

    @journey_url_starts_with_conditions.setter
    def journey_url_starts_with_conditions(self, journey_url_starts_with_conditions: List[str]) -> None:
        """
        Sets the journey_url_starts_with_conditions of this ViewFilter.
        The list of url starts with conditions to filter offer constraints

        :param journey_url_starts_with_conditions: The journey_url_starts_with_conditions of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_url_starts_with_conditions = journey_url_starts_with_conditions

    @property
    def journey_url_ends_with_conditions(self) -> List[str]:
        """
        Gets the journey_url_ends_with_conditions of this ViewFilter.
        The list of url ends with conditions to filter offer constraints

        :return: The journey_url_ends_with_conditions of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_url_ends_with_conditions

    @journey_url_ends_with_conditions.setter
    def journey_url_ends_with_conditions(self, journey_url_ends_with_conditions: List[str]) -> None:
        """
        Sets the journey_url_ends_with_conditions of this ViewFilter.
        The list of url ends with conditions to filter offer constraints

        :param journey_url_ends_with_conditions: The journey_url_ends_with_conditions of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_url_ends_with_conditions = journey_url_ends_with_conditions

    @property
    def journey_url_contains_any_conditions(self) -> List[str]:
        """
        Gets the journey_url_contains_any_conditions of this ViewFilter.
        The list of url contains any conditions to filter offer constraints

        :return: The journey_url_contains_any_conditions of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_url_contains_any_conditions

    @journey_url_contains_any_conditions.setter
    def journey_url_contains_any_conditions(self, journey_url_contains_any_conditions: List[str]) -> None:
        """
        Sets the journey_url_contains_any_conditions of this ViewFilter.
        The list of url contains any conditions to filter offer constraints

        :param journey_url_contains_any_conditions: The journey_url_contains_any_conditions of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_url_contains_any_conditions = journey_url_contains_any_conditions

    @property
    def journey_url_not_contains_any_conditions(self) -> List[str]:
        """
        Gets the journey_url_not_contains_any_conditions of this ViewFilter.
        The list of url not contains any conditions to filter offer constraints

        :return: The journey_url_not_contains_any_conditions of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_url_not_contains_any_conditions

    @journey_url_not_contains_any_conditions.setter
    def journey_url_not_contains_any_conditions(self, journey_url_not_contains_any_conditions: List[str]) -> None:
        """
        Sets the journey_url_not_contains_any_conditions of this ViewFilter.
        The list of url not contains any conditions to filter offer constraints

        :param journey_url_not_contains_any_conditions: The journey_url_not_contains_any_conditions of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_url_not_contains_any_conditions = journey_url_not_contains_any_conditions

    @property
    def journey_url_contains_all_conditions(self) -> List[str]:
        """
        Gets the journey_url_contains_all_conditions of this ViewFilter.
        The list of url contains all conditions to filter offer constraints

        :return: The journey_url_contains_all_conditions of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_url_contains_all_conditions

    @journey_url_contains_all_conditions.setter
    def journey_url_contains_all_conditions(self, journey_url_contains_all_conditions: List[str]) -> None:
        """
        Sets the journey_url_contains_all_conditions of this ViewFilter.
        The list of url contains all conditions to filter offer constraints

        :param journey_url_contains_all_conditions: The journey_url_contains_all_conditions of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_url_contains_all_conditions = journey_url_contains_all_conditions

    @property
    def journey_url_not_contains_all_conditions(self) -> List[str]:
        """
        Gets the journey_url_not_contains_all_conditions of this ViewFilter.
        The list of url not contains all conditions to filter offer constraints

        :return: The journey_url_not_contains_all_conditions of this ViewFilter.
        :rtype: list[str]
        """
        return self._journey_url_not_contains_all_conditions

    @journey_url_not_contains_all_conditions.setter
    def journey_url_not_contains_all_conditions(self, journey_url_not_contains_all_conditions: List[str]) -> None:
        """
        Sets the journey_url_not_contains_all_conditions of this ViewFilter.
        The list of url not contains all conditions to filter offer constraints

        :param journey_url_not_contains_all_conditions: The journey_url_not_contains_all_conditions of this ViewFilter.
        :type: list[str]
        """
        

        self._journey_url_not_contains_all_conditions = journey_url_not_contains_all_conditions

    @property
    def flow_milestone_ids(self) -> List[str]:
        """
        Gets the flow_milestone_ids of this ViewFilter.
        The list of flow milestones to filter exports

        :return: The flow_milestone_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._flow_milestone_ids

    @flow_milestone_ids.setter
    def flow_milestone_ids(self, flow_milestone_ids: List[str]) -> None:
        """
        Sets the flow_milestone_ids of this ViewFilter.
        The list of flow milestones to filter exports

        :param flow_milestone_ids: The flow_milestone_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._flow_milestone_ids = flow_milestone_ids

    @property
    def is_assessment_passed(self) -> bool:
        """
        Gets the is_assessment_passed of this ViewFilter.
        Filter to indicate if Agent passed assessment or not

        :return: The is_assessment_passed of this ViewFilter.
        :rtype: bool
        """
        return self._is_assessment_passed

    @is_assessment_passed.setter
    def is_assessment_passed(self, is_assessment_passed: bool) -> None:
        """
        Sets the is_assessment_passed of this ViewFilter.
        Filter to indicate if Agent passed assessment or not

        :param is_assessment_passed: The is_assessment_passed of this ViewFilter.
        :type: bool
        """
        

        self._is_assessment_passed = is_assessment_passed

    @property
    def conversation_initiators(self) -> List[str]:
        """
        Gets the conversation_initiators of this ViewFilter.
        The list to filter based on Brands (Bot/User/Agent) or End User who initiated the first message in the conversation

        :return: The conversation_initiators of this ViewFilter.
        :rtype: list[str]
        """
        return self._conversation_initiators

    @conversation_initiators.setter
    def conversation_initiators(self, conversation_initiators: List[str]) -> None:
        """
        Sets the conversation_initiators of this ViewFilter.
        The list to filter based on Brands (Bot/User/Agent) or End User who initiated the first message in the conversation

        :param conversation_initiators: The conversation_initiators of this ViewFilter.
        :type: list[str]
        """
        

        self._conversation_initiators = conversation_initiators

    @property
    def has_customer_participated(self) -> bool:
        """
        Gets the has_customer_participated of this ViewFilter.
        Indicates if the customer has participated in an initiated conversation

        :return: The has_customer_participated of this ViewFilter.
        :rtype: bool
        """
        return self._has_customer_participated

    @has_customer_participated.setter
    def has_customer_participated(self, has_customer_participated: bool) -> None:
        """
        Sets the has_customer_participated of this ViewFilter.
        Indicates if the customer has participated in an initiated conversation

        :param has_customer_participated: The has_customer_participated of this ViewFilter.
        :type: bool
        """
        

        self._has_customer_participated = has_customer_participated

    @property
    def is_acd_interaction(self) -> bool:
        """
        Gets the is_acd_interaction of this ViewFilter.
        Filter to indicate if interaction was ACD or non-ACD

        :return: The is_acd_interaction of this ViewFilter.
        :rtype: bool
        """
        return self._is_acd_interaction

    @is_acd_interaction.setter
    def is_acd_interaction(self, is_acd_interaction: bool) -> None:
        """
        Sets the is_acd_interaction of this ViewFilter.
        Filter to indicate if interaction was ACD or non-ACD

        :param is_acd_interaction: The is_acd_interaction of this ViewFilter.
        :type: bool
        """
        

        self._is_acd_interaction = is_acd_interaction

    @property
    def has_fax(self) -> bool:
        """
        Gets the has_fax of this ViewFilter.
        Filters to indicate if interaction has FAX

        :return: The has_fax of this ViewFilter.
        :rtype: bool
        """
        return self._has_fax

    @has_fax.setter
    def has_fax(self, has_fax: bool) -> None:
        """
        Sets the has_fax of this ViewFilter.
        Filters to indicate if interaction has FAX

        :param has_fax: The has_fax of this ViewFilter.
        :type: bool
        """
        

        self._has_fax = has_fax

    @property
    def data_action_ids(self) -> List[str]:
        """
        Gets the data_action_ids of this ViewFilter.
        The list of Data Action IDs 

        :return: The data_action_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._data_action_ids

    @data_action_ids.setter
    def data_action_ids(self, data_action_ids: List[str]) -> None:
        """
        Sets the data_action_ids of this ViewFilter.
        The list of Data Action IDs 

        :param data_action_ids: The data_action_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._data_action_ids = data_action_ids

    @property
    def action_category_name(self) -> str:
        """
        Gets the action_category_name of this ViewFilter.
        Deprecated - Please use integrationIds instead

        :return: The action_category_name of this ViewFilter.
        :rtype: str
        """
        return self._action_category_name

    @action_category_name.setter
    def action_category_name(self, action_category_name: str) -> None:
        """
        Sets the action_category_name of this ViewFilter.
        Deprecated - Please use integrationIds instead

        :param action_category_name: The action_category_name of this ViewFilter.
        :type: str
        """
        

        self._action_category_name = action_category_name

    @property
    def integration_ids(self) -> List[str]:
        """
        Gets the integration_ids of this ViewFilter.
        The list of integration IDs for Data Action

        :return: The integration_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._integration_ids

    @integration_ids.setter
    def integration_ids(self, integration_ids: List[str]) -> None:
        """
        Sets the integration_ids of this ViewFilter.
        The list of integration IDs for Data Action

        :param integration_ids: The integration_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._integration_ids = integration_ids

    @property
    def response_statuses(self) -> List[str]:
        """
        Gets the response_statuses of this ViewFilter.
        The list of Response codes for Data Action

        :return: The response_statuses of this ViewFilter.
        :rtype: list[str]
        """
        return self._response_statuses

    @response_statuses.setter
    def response_statuses(self, response_statuses: List[str]) -> None:
        """
        Sets the response_statuses of this ViewFilter.
        The list of Response codes for Data Action

        :param response_statuses: The response_statuses of this ViewFilter.
        :type: list[str]
        """
        

        self._response_statuses = response_statuses

    @property
    def available_dashboard(self) -> str:
        """
        Gets the available_dashboard of this ViewFilter.
        Filter to indicate the availability of the dashboard is public or private.

        :return: The available_dashboard of this ViewFilter.
        :rtype: str
        """
        return self._available_dashboard

    @available_dashboard.setter
    def available_dashboard(self, available_dashboard: str) -> None:
        """
        Sets the available_dashboard of this ViewFilter.
        Filter to indicate the availability of the dashboard is public or private.

        :param available_dashboard: The available_dashboard of this ViewFilter.
        :type: str
        """
        if isinstance(available_dashboard, int):
            available_dashboard = str(available_dashboard)
        allowed_values = ["Public", "Private"]
        if available_dashboard.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for available_dashboard -> " + available_dashboard)
            self._available_dashboard = "outdated_sdk_version"
        else:
            self._available_dashboard = available_dashboard

    @property
    def favourite_dashboard(self) -> bool:
        """
        Gets the favourite_dashboard of this ViewFilter.
        Filter to indicate whether the dashboard is favorite or unfavorite.

        :return: The favourite_dashboard of this ViewFilter.
        :rtype: bool
        """
        return self._favourite_dashboard

    @favourite_dashboard.setter
    def favourite_dashboard(self, favourite_dashboard: bool) -> None:
        """
        Sets the favourite_dashboard of this ViewFilter.
        Filter to indicate whether the dashboard is favorite or unfavorite.

        :param favourite_dashboard: The favourite_dashboard of this ViewFilter.
        :type: bool
        """
        

        self._favourite_dashboard = favourite_dashboard

    @property
    def my_dashboard(self) -> bool:
        """
        Gets the my_dashboard of this ViewFilter.
        Filter to indicate the dashboard owned by the user.

        :return: The my_dashboard of this ViewFilter.
        :rtype: bool
        """
        return self._my_dashboard

    @my_dashboard.setter
    def my_dashboard(self, my_dashboard: bool) -> None:
        """
        Sets the my_dashboard of this ViewFilter.
        Filter to indicate the dashboard owned by the user.

        :param my_dashboard: The my_dashboard of this ViewFilter.
        :type: bool
        """
        

        self._my_dashboard = my_dashboard

    @property
    def station_errors(self) -> List[str]:
        """
        Gets the station_errors of this ViewFilter.
        The list of agent errors that are related to station

        :return: The station_errors of this ViewFilter.
        :rtype: list[str]
        """
        return self._station_errors

    @station_errors.setter
    def station_errors(self, station_errors: List[str]) -> None:
        """
        Sets the station_errors of this ViewFilter.
        The list of agent errors that are related to station

        :param station_errors: The station_errors of this ViewFilter.
        :type: list[str]
        """
        

        self._station_errors = station_errors

    @property
    def canonical_contact_ids(self) -> List[str]:
        """
        Gets the canonical_contact_ids of this ViewFilter.
        The canonical contact ids are used to filter the view

        :return: The canonical_contact_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._canonical_contact_ids

    @canonical_contact_ids.setter
    def canonical_contact_ids(self, canonical_contact_ids: List[str]) -> None:
        """
        Sets the canonical_contact_ids of this ViewFilter.
        The canonical contact ids are used to filter the view

        :param canonical_contact_ids: The canonical_contact_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._canonical_contact_ids = canonical_contact_ids

    @property
    def alert_rule_ids(self) -> List[str]:
        """
        Gets the alert_rule_ids of this ViewFilter.
        The list of Alert Rule IDs

        :return: The alert_rule_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._alert_rule_ids

    @alert_rule_ids.setter
    def alert_rule_ids(self, alert_rule_ids: List[str]) -> None:
        """
        Sets the alert_rule_ids of this ViewFilter.
        The list of Alert Rule IDs

        :param alert_rule_ids: The alert_rule_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._alert_rule_ids = alert_rule_ids

    @property
    def evaluation_form_context_ids(self) -> List[str]:
        """
        Gets the evaluation_form_context_ids of this ViewFilter.
        The list of Evaluation Form Context IDs

        :return: The evaluation_form_context_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._evaluation_form_context_ids

    @evaluation_form_context_ids.setter
    def evaluation_form_context_ids(self, evaluation_form_context_ids: List[str]) -> None:
        """
        Sets the evaluation_form_context_ids of this ViewFilter.
        The list of Evaluation Form Context IDs

        :param evaluation_form_context_ids: The evaluation_form_context_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._evaluation_form_context_ids = evaluation_form_context_ids

    @property
    def evaluation_statuses(self) -> List[str]:
        """
        Gets the evaluation_statuses of this ViewFilter.
        The evaluation statuses that are used to filter the view

        :return: The evaluation_statuses of this ViewFilter.
        :rtype: list[str]
        """
        return self._evaluation_statuses

    @evaluation_statuses.setter
    def evaluation_statuses(self, evaluation_statuses: List[str]) -> None:
        """
        Sets the evaluation_statuses of this ViewFilter.
        The evaluation statuses that are used to filter the view

        :param evaluation_statuses: The evaluation_statuses of this ViewFilter.
        :type: list[str]
        """
        

        self._evaluation_statuses = evaluation_statuses

    @property
    def workbin_ids(self) -> List[str]:
        """
        Gets the workbin_ids of this ViewFilter.
        The list of Workbin IDs

        :return: The workbin_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._workbin_ids

    @workbin_ids.setter
    def workbin_ids(self, workbin_ids: List[str]) -> None:
        """
        Sets the workbin_ids of this ViewFilter.
        The list of Workbin IDs

        :param workbin_ids: The workbin_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._workbin_ids = workbin_ids

    @property
    def worktype_ids(self) -> List[str]:
        """
        Gets the worktype_ids of this ViewFilter.
        The list of Worktype IDs

        :return: The worktype_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._worktype_ids

    @worktype_ids.setter
    def worktype_ids(self, worktype_ids: List[str]) -> None:
        """
        Sets the worktype_ids of this ViewFilter.
        The list of Worktype IDs

        :param worktype_ids: The worktype_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._worktype_ids = worktype_ids

    @property
    def workitem_ids(self) -> List[str]:
        """
        Gets the workitem_ids of this ViewFilter.
        The list of Workitem IDs

        :return: The workitem_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._workitem_ids

    @workitem_ids.setter
    def workitem_ids(self, workitem_ids: List[str]) -> None:
        """
        Sets the workitem_ids of this ViewFilter.
        The list of Workitem IDs

        :param workitem_ids: The workitem_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._workitem_ids = workitem_ids

    @property
    def workitem_assignee_ids(self) -> List[str]:
        """
        Gets the workitem_assignee_ids of this ViewFilter.
        The list of Workitem Assignee IDs

        :return: The workitem_assignee_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._workitem_assignee_ids

    @workitem_assignee_ids.setter
    def workitem_assignee_ids(self, workitem_assignee_ids: List[str]) -> None:
        """
        Sets the workitem_assignee_ids of this ViewFilter.
        The list of Workitem Assignee IDs

        :param workitem_assignee_ids: The workitem_assignee_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._workitem_assignee_ids = workitem_assignee_ids

    @property
    def workitem_statuses(self) -> List[str]:
        """
        Gets the workitem_statuses of this ViewFilter.
        The list of Workitem Statuses IDs

        :return: The workitem_statuses of this ViewFilter.
        :rtype: list[str]
        """
        return self._workitem_statuses

    @workitem_statuses.setter
    def workitem_statuses(self, workitem_statuses: List[str]) -> None:
        """
        Sets the workitem_statuses of this ViewFilter.
        The list of Workitem Statuses IDs

        :param workitem_statuses: The workitem_statuses of this ViewFilter.
        :type: list[str]
        """
        

        self._workitem_statuses = workitem_statuses

    @property
    def is_analyzed_for_sensitive_data(self) -> bool:
        """
        Gets the is_analyzed_for_sensitive_data of this ViewFilter.
        Filter to indicate the transcript has been analyzed for sensitive data.

        :return: The is_analyzed_for_sensitive_data of this ViewFilter.
        :rtype: bool
        """
        return self._is_analyzed_for_sensitive_data

    @is_analyzed_for_sensitive_data.setter
    def is_analyzed_for_sensitive_data(self, is_analyzed_for_sensitive_data: bool) -> None:
        """
        Sets the is_analyzed_for_sensitive_data of this ViewFilter.
        Filter to indicate the transcript has been analyzed for sensitive data.

        :param is_analyzed_for_sensitive_data: The is_analyzed_for_sensitive_data of this ViewFilter.
        :type: bool
        """
        

        self._is_analyzed_for_sensitive_data = is_analyzed_for_sensitive_data

    @property
    def has_sensitive_data(self) -> bool:
        """
        Gets the has_sensitive_data of this ViewFilter.
        Filter to indicate the transcript contains sensitive data.

        :return: The has_sensitive_data of this ViewFilter.
        :rtype: bool
        """
        return self._has_sensitive_data

    @has_sensitive_data.setter
    def has_sensitive_data(self, has_sensitive_data: bool) -> None:
        """
        Sets the has_sensitive_data of this ViewFilter.
        Filter to indicate the transcript contains sensitive data.

        :param has_sensitive_data: The has_sensitive_data of this ViewFilter.
        :type: bool
        """
        

        self._has_sensitive_data = has_sensitive_data

    @property
    def sub_path(self) -> str:
        """
        Gets the sub_path of this ViewFilter.
        Filter for Sub Path

        :return: The sub_path of this ViewFilter.
        :rtype: str
        """
        return self._sub_path

    @sub_path.setter
    def sub_path(self, sub_path: str) -> None:
        """
        Sets the sub_path of this ViewFilter.
        Filter for Sub Path

        :param sub_path: The sub_path of this ViewFilter.
        :type: str
        """
        

        self._sub_path = sub_path

    @property
    def user_state(self) -> str:
        """
        Gets the user_state of this ViewFilter.
        The user supplied state value in the view

        :return: The user_state of this ViewFilter.
        :rtype: str
        """
        return self._user_state

    @user_state.setter
    def user_state(self, user_state: str) -> None:
        """
        Sets the user_state of this ViewFilter.
        The user supplied state value in the view

        :param user_state: The user_state of this ViewFilter.
        :type: str
        """
        if isinstance(user_state, int):
            user_state = str(user_state)
        allowed_values = ["ActiveAndInactive", "Active", "Inactive", "Deleted"]
        if user_state.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for user_state -> " + user_state)
            self._user_state = "outdated_sdk_version"
        else:
            self._user_state = user_state

    @property
    def is_cleared_by_customer(self) -> bool:
        """
        Gets the is_cleared_by_customer of this ViewFilter.
        Filter to indicate if the customer cleared the conversation.

        :return: The is_cleared_by_customer of this ViewFilter.
        :rtype: bool
        """
        return self._is_cleared_by_customer

    @is_cleared_by_customer.setter
    def is_cleared_by_customer(self, is_cleared_by_customer: bool) -> None:
        """
        Sets the is_cleared_by_customer of this ViewFilter.
        Filter to indicate if the customer cleared the conversation.

        :param is_cleared_by_customer: The is_cleared_by_customer of this ViewFilter.
        :type: bool
        """
        

        self._is_cleared_by_customer = is_cleared_by_customer

    @property
    def evaluation_assignee_ids(self) -> List[str]:
        """
        Gets the evaluation_assignee_ids of this ViewFilter.
        The evaluation assignee ids that are used to filter the view.

        :return: The evaluation_assignee_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._evaluation_assignee_ids

    @evaluation_assignee_ids.setter
    def evaluation_assignee_ids(self, evaluation_assignee_ids: List[str]) -> None:
        """
        Sets the evaluation_assignee_ids of this ViewFilter.
        The evaluation assignee ids that are used to filter the view.

        :param evaluation_assignee_ids: The evaluation_assignee_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._evaluation_assignee_ids = evaluation_assignee_ids

    @property
    def evaluation_assigned(self) -> bool:
        """
        Gets the evaluation_assigned of this ViewFilter.
        Filter to indicate that the user has no assigned evaluation.

        :return: The evaluation_assigned of this ViewFilter.
        :rtype: bool
        """
        return self._evaluation_assigned

    @evaluation_assigned.setter
    def evaluation_assigned(self, evaluation_assigned: bool) -> None:
        """
        Sets the evaluation_assigned of this ViewFilter.
        Filter to indicate that the user has no assigned evaluation.

        :param evaluation_assigned: The evaluation_assigned of this ViewFilter.
        :type: bool
        """
        

        self._evaluation_assigned = evaluation_assigned

    @property
    def assistant_ids(self) -> List[str]:
        """
        Gets the assistant_ids of this ViewFilter.
        The assistant ids that are used to filter the view.

        :return: The assistant_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._assistant_ids

    @assistant_ids.setter
    def assistant_ids(self, assistant_ids: List[str]) -> None:
        """
        Sets the assistant_ids of this ViewFilter.
        The assistant ids that are used to filter the view.

        :param assistant_ids: The assistant_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._assistant_ids = assistant_ids

    @property
    def knowledge_base_ids(self) -> List[str]:
        """
        Gets the knowledge_base_ids of this ViewFilter.
        The knowledge base ids that are used to filter the view.

        :return: The knowledge_base_ids of this ViewFilter.
        :rtype: list[str]
        """
        return self._knowledge_base_ids

    @knowledge_base_ids.setter
    def knowledge_base_ids(self, knowledge_base_ids: List[str]) -> None:
        """
        Sets the knowledge_base_ids of this ViewFilter.
        The knowledge base ids that are used to filter the view.

        :param knowledge_base_ids: The knowledge_base_ids of this ViewFilter.
        :type: list[str]
        """
        

        self._knowledge_base_ids = knowledge_base_ids

    @property
    def is_parked(self) -> bool:
        """
        Gets the is_parked of this ViewFilter.
        Filter to indicate if the interactions are parked.

        :return: The is_parked of this ViewFilter.
        :rtype: bool
        """
        return self._is_parked

    @is_parked.setter
    def is_parked(self, is_parked: bool) -> None:
        """
        Sets the is_parked of this ViewFilter.
        Filter to indicate if the interactions are parked.

        :param is_parked: The is_parked of this ViewFilter.
        :type: bool
        """
        

        self._is_parked = is_parked

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

