# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class WebDeploymentsRefreshJWTRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        WebDeploymentsRefreshJWTRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'refresh_token': 'str',
            'deployment_id': 'str'
        }

        self.attribute_map = {
            'refresh_token': 'refreshToken',
            'deployment_id': 'deploymentId'
        }

        self._refresh_token = None
        self._deployment_id = None

    @property
    def refresh_token(self) -> str:
        """
        Gets the refresh_token of this WebDeploymentsRefreshJWTRequest.
        Refresh token used to issue a new JWT.

        :return: The refresh_token of this WebDeploymentsRefreshJWTRequest.
        :rtype: str
        """
        return self._refresh_token

    @refresh_token.setter
    def refresh_token(self, refresh_token: str) -> None:
        """
        Sets the refresh_token of this WebDeploymentsRefreshJWTRequest.
        Refresh token used to issue a new JWT.

        :param refresh_token: The refresh_token of this WebDeploymentsRefreshJWTRequest.
        :type: str
        """
        

        self._refresh_token = refresh_token

    @property
    def deployment_id(self) -> str:
        """
        Gets the deployment_id of this WebDeploymentsRefreshJWTRequest.
        The WebDeployment ID

        :return: The deployment_id of this WebDeploymentsRefreshJWTRequest.
        :rtype: str
        """
        return self._deployment_id

    @deployment_id.setter
    def deployment_id(self, deployment_id: str) -> None:
        """
        Sets the deployment_id of this WebDeploymentsRefreshJWTRequest.
        The WebDeployment ID

        :param deployment_id: The deployment_id of this WebDeploymentsRefreshJWTRequest.
        :type: str
        """
        

        self._deployment_id = deployment_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

