# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import WfmIntegrationsHrisTimeOffTypesJobTopicErrorBody
    from . import WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffType

class WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'entities': 'list[WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffType]',
            'status': 'str',
            'error': 'WfmIntegrationsHrisTimeOffTypesJobTopicErrorBody'
        }

        self.attribute_map = {
            'id': 'id',
            'entities': 'entities',
            'status': 'status',
            'error': 'error'
        }

        self._id = None
        self._entities = None
        self._status = None
        self._error = None

    @property
    def id(self) -> str:
        """
        Gets the id of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.


        :return: The id of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.


        :param id: The id of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.
        :type: str
        """
        

        self._id = id

    @property
    def entities(self) -> List['WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffType']:
        """
        Gets the entities of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.


        :return: The entities of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.
        :rtype: list[WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffType]
        """
        return self._entities

    @entities.setter
    def entities(self, entities: List['WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffType']) -> None:
        """
        Sets the entities of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.


        :param entities: The entities of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.
        :type: list[WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffType]
        """
        

        self._entities = entities

    @property
    def status(self) -> str:
        """
        Gets the status of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.


        :return: The status of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str) -> None:
        """
        Sets the status of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.


        :param status: The status of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.
        :type: str
        """
        if isinstance(status, int):
            status = str(status)
        allowed_values = ["Processing", "Complete", "Error"]
        if status.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for status -> " + status)
            self._status = "outdated_sdk_version"
        else:
            self._status = status

    @property
    def error(self) -> 'WfmIntegrationsHrisTimeOffTypesJobTopicErrorBody':
        """
        Gets the error of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.


        :return: The error of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.
        :rtype: WfmIntegrationsHrisTimeOffTypesJobTopicErrorBody
        """
        return self._error

    @error.setter
    def error(self, error: 'WfmIntegrationsHrisTimeOffTypesJobTopicErrorBody') -> None:
        """
        Sets the error of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.


        :param error: The error of this WfmIntegrationsHrisTimeOffTypesJobTopicHrisTimeOffTypesJobNotification.
        :type: WfmIntegrationsHrisTimeOffTypesJobTopicErrorBody
        """
        

        self._error = error

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

